// C Source File
// Created 9/15/2011; 10:54:39 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "defines.h"
#include "map_gfx.h"
#include "dung_maps.h"
#include "ext_vars.h"
#include "rooms.h"
extern int current_game;
//====================================================================================================
/*

*/
//====================================================================================================

/*

			this will be the dungeon map system

*/
#define map_rows 9
#define map_cols 8
int dung_map[map_rows][map_cols];// 128 bytes of info - about
//====================================================================================================
/*
			dungeon map info:
			
			this is an 8x8 square that will help the mapping system figure out where you have and
			have not been in a dungeon map.
			the [8][8] is to mirror the current map.
			here is the specs that are to go into the map:
			0 - this is no room
			1 -	this is a room that has not been entered, but exists
			2 - this is a room that has been entered.
			3 - for hidden room.
			
			in the event of a hidden room, well this one is tricky, b/c you need to actually load
			the room itself to find out if the room is hidden or not.
			basically, this is how things will work:
			1 - if the map for the dungeon has not been gotten and is not in the save, then create a new map.
			2 - if we are in the new map faze, then it will clr_dun_map().  
				2.1 - for every room we enter, if it is not hidden, then make 0==2.
			
			3- if we do have the map for that dungeon:
				- if the map has not been compiled, 
					- 3.1 - call write_map().  this will configure the rooms by calling each room to see if it
									is hidden or not., if not, then it writes a 1 to that thingie.
				- if the map is already in the save, then do nothing. let the changing of the rooms call c
						chk_dung_map(); assumming that it is a dungeon. (>0)	

*/
//====================================================================================================

int g_dung_map(int x,int y)
{
		if ((x<0) || (y<0) || (x>=map_rows) || (y>=map_cols)){return -6666;}
	return dung_map[x][y];
}

//====================================================================================================
/*

*/
//====================================================================================================


void clr_dung_map()
{
	int i=0,k=0;
	while (i<map_rows){
		while (k<map_cols)
		{
			dung_map[i][k]=0;
			k++;
		}// end while k
		i++;k=0;
	}// end while i
}//end clr dungeon map

//====================================================================================================
/*

*/
//====================================================================================================

void save_dung_map(int fle)
{
    
	if (fle<=0){return;}
	char sav[8], sav2[20];
	    FILE *f = NULL;
    int yn = TRUE;
//TRY

//ONERR
//ENDTRY


  


   // case save temp
    // open file for writing
    sprintf(sav,"zsv%i",current_game);
    sprintf(sav2,"zsv%i\\Z%iM%i",current_game,current_game,fle);
    FolderCur(SYMSTR(sav),TRUE);
    sprintf(sav,"Z%iM%i",current_game,fle);
//    sprintf(sav2,"main\\SAV%i.AFW",fle);
    HSym sym = SymFind (SYMSTR (sav));
    TRY

    if (sym.folder){cmd_unarchiv(SYMSTR(sav));}// unarchive the save
    ONERR
    ENDTRY	
    
 TRY     
    if ((f = fopen(sav,"wb")) == NULL) {// write into temp - use the file saving routine for the
    // saving of the real file.  for everything else, use the temp file
        yn = FALSE;
    } else {
        // write inv data to the file
        if (fwrite(dung_map,sizeof(dung_map),1,f) != 1) {
            yn = FALSE;
        }
        // append the file ID tag
        // it is type AFW.  ie my game
        fputc(0,f);
        fputs("ZLD",f);
        fputc(0,f);
        fputc(OTH_TAG,f);

        // close the file
        fclose(f);
    }	
		if (yn){cmd_archive(SYMSTR(sav2));}
ONERR
ENDTRY		
}// end save3

//====================================================================================================
/*

*/
//====================================================================================================

 int get_dung_map(int fle) {
  
  if (fle<=0){return FALSE;}
  clr_dung_map();
   int yn = TRUE;
  //TRY
    FILE *f = NULL;
    
		char sav[8];
   // case save temp
    // open file for writing
    sprintf(sav,"zsv%i",current_game);
    FolderCur(SYMSTR(sav),TRUE);
    sprintf(sav,"Z%iM%i",current_game,fle);   
    
    // open file for reading in binary mode
   //HSym sym = SymFind (SYMSTR (sav));
   
TRY   
    if ((f = fopen(sav,"rb")) == NULL) { // this opens up the temp dung_mapentory
        yn = FALSE;
    } else {
        // read data from file into dung_map
        if (fread(dung_map,sizeof(dung_map),1,f) != 1) {
             yn = FALSE;
        }
	
       // close the file
        fclose(f);
    }
		
ONERR
ENDTRY
	

	
    return yn;
}




//====================================================================================================
/*
			check dungeon map will check to see if the current pos has been added or not.
			
*/
//====================================================================================================


void chk_dung_map()
{
	int x=link_stat(map_x), y=link_stat(map_y);
	if ((dung_map[x][y]<=1) && (dung_map[x][y]!=3)){dung_map[x][y]=2;}
	
}// end check dungeon map







//====================================================================================================
/*
			fill dungeon map will scan the current world[][] and if the var is >0 then it will set the 
			var to 1 for the corresponding map. it will also call up the rooms to find out if the room is
			hidden or not.
*/
//====================================================================================================
void fill_dung_map(int fle)
{


		int temp[map_rows][map_cols];
		char mapa[8];
		int fileio=TRUE, i=0,k=0;
		FILE *f = NULL;
		FolderCur(SYMSTR("maps"),TRUE);
			TRY
			
					sprintf(mapa,"zdm%i",fle);

			    if ((f = fopen(mapa,"rb")) == NULL) {
			        fileio = FALSE;
			    } else {
			        if (fread(temp,sizeof(temp),1,f) != 1) { fileio = FALSE; }
			        fclose(f);
			    }// end else
			
			
			ONERR
				fileio=FALSE;
			ENDTRY

			if (fileio){
					while (i<map_rows){
						while (k<map_cols){//59953
							if ((temp[i][k]>0) && (i<8))
							{
							
								if (get_any_room_info(i,k,hidden)<=0){dung_map[i][k]=1;}// end if the room is not hidden
								else {dung_map[i][k]=3;}
								
								
							}// end if there exists a room
							else {dung_map[i][k]=temp[i][k];}// make sure it puts in the compass stuff
							k++;
						}// end while k
						i++;k=0;
					}// end while i
			}// end if gotten

}// end write dung map

//====================================================================================================
/*

*/
//====================================================================================================
//void compass_force(){dung_map[8][1]=0; dung_map[8][2]=3;dung_map[8][0]=1;}
int compass_exists(){return dung_map[8][0];}
int compass_x(int tf){if (tf){return dung_map[8][1];} else {return dung_map[8][2];}}
//====================================================================================================
/*

*/
//====================================================================================================
void compass_got(int yn){dung_map[8][0]=yn;}

//====================================================================================================
/*

*/
//====================================================================================================

void compass_add()
{//down is >10  horizontal is <9
	int i=g_over_world_stat(overworld_compass, oob());
	int num=0;
	if ((i>77) || (i<0)){return;}// dont go out of bounds.
	while (i>9){i-=10;num++;}
	dung_map[8][2]=num; num=0;
	while (i>0){i--;num++;}
	dung_map[8][1]=num; 
	compass_got(TRUE);
}// end compass add
