// C Source File
// Created 10/22/2015; 2:54:15 PM

#include <tigcclib.h>
#include "all.h"
#include "start.h"


extern char *light, *dark;
extern int link_speed,link_direction,link_picture, link_x, link_y, link_speed_adjust,room_entry_x,room_entry_y;
extern int   link_frame,sword_charge,terminate;//keyl, keyr, keyu, keyd,keya,keyb, terminate;//, link_frame2;                    //Keeps track of link's frame #.
int spins=0, spinslash_active=FALSE, disp_hearts=TRUE, heart_x=90, heart_y= -2, hover=0,heart_reverse=TRUE, dont_draw_object=-1;
extern int dark_room,button_pressed,double_damamge,skip_animate_mob, slowdown, we_transistion;

//=================================================================================================
/*
		Carry item
		The item that link lifts and carries is stored in hold_carry
		This will check to see if link is carrying an item.  then it checks to see if the item is real
		if it is fake, then reset link's state.
		if the item is real, then force the x/y pos of that item to be in line with links x/y pos
		then force draw that item.  the drawing is done here, instead of animate_object() b/c
		when drawn in animate_object() the object laggs 1 space behind.
*/
//=================================================================================================	

void carry_item()
{
			
				int loc=link_stat(hold_carry);
				if (get_object(loc, obj_num)<0){mod_link(dual_state,0,TRUE);dont_draw_object=-1;}
				else {set_object(loc,obj_x,link_x); set_object(loc,obj_y,link_y-16); dont_draw_object=loc;
				obj_quickdraw(link_x, fix_row_gain(link_y-16), get_object(loc,obj_pic), get_object(loc,obj_draw_type), 0);}
				change_link_frame(11);
}// end carry item

//=================================================================================================
/*
			walking
			this routine handles link's dual_state for walking
			included dual states are: carry, sword walking, shield, pushing
*/
//=================================================================================================	


void walking(int pic, int speed)
{

		terminate=TRUE;// make sure we can go back to a normal link state
		
		//------------------------------------------------------------------
		//  can link move
		//------------------------------------------------------------------		

		int mv=can_move(LINK,link_direction);
	  if (mv==TRUE){move_link(speed);}
	  
		//------------------------------------------------------------------
		//  if he cant, then check to see if a push stone
		//------------------------------------------------------------------	  
		else if (mv>=100)// made this modification specifically for push stones.
		{pic=6; if (get_item_info(get_object(mv-100,obj_num),item_type)==pushable){move_push_stone(mv-100);goto skip;}}
		else  {pic=6; goto skip;}// mod the pic to make link push
		
		//------------------------------------------------------------------
		//  Now check to see if holding an item or a sword
		//------------------------------------------------------------------	
			
		switch(link_stat(dual_state))
		{
		
			case LINK_CARRY: carry_item(); return;
			case LINK_WALKING_SWORD:
					if (link_frame>2){link_picture = LINK_THRUST2;if (link_frame>4){link_frame=0;}}
					else {link_picture=0;}
					//------------------------------------------------------------------
					//	sword_charging() will make the sword blink while link is walking.  
					//  Change false to true if you want to charge the sword while 
					// 	link is walking.
					//------------------------------------------------------------------
					sword_display(link_direction, TRUE, FALSE, sword_charging(FALSE));
					return;
			break;
			case LINK_SHIELD:	pic=8; break;

		}// end switch

		skip:
		change_link_frame(pic);
		
}// end walking

//=================================================================================================
/*
		attacking
		this includes link's dual_state for link_attacking
		included dual states are: wand, generic, spin slash, sword, shield, and other use items.
		use_item() defaults everything to link_state of ATTACK, so even using a potion is defaulted
			under attacking()
*/
//=================================================================================================	


void attacking()
{

		switch(link_stat(dual_state))
		{				
			case LINK_WAND:					gfx_wand();						break;
			case LINK_GENERIC_ITEM:	generaic_item_use();	break;
		//	case LINK_SPIN_SLASH:		mod_link(state,LINK_STUN, TRUE);			break;
			case LINK_SWORD:				gfx_slash();					break; 
			case LINK_SHIELD:				link_frame=0; change_link_frame(8); terminate=TRUE;break;
			//------------------------------------------------------------------
			// doing the change_link_frame() in default allows some animation to
			// happen when you use an item, like a potion or light orb.
			//------------------------------------------------------------------
			default:change_link_frame(LINK_THRUST2-1);terminate=TRUE;return;
 
		}//end switch
		
}// end attacking

//=================================================================================================
/*
			stunned
			this contains link's dual_state for stun
			the included states are: hookshot, hole fall, get item, 
*/
//=================================================================================================	


void stunned()
{
		int stat=link_stat(dual_state);
		//------------------------------------------------------------------
		// if link is holding an item, then make him throw it when he gets stunned
		//------------------------------------------------------------------
		if	((get_object(link_stat(hold_carry), obj_num)>0) && (stat!=LINK_GET_ITEM)){toss_object();return;}
	
		switch(stat)
		{
			case LINK_HOOKSHOT:  link_picture = LINK_THRUST2; if (link_stat(link_rand_var1) == -33){link_picture=13;	link_direction=up;} return;// (get_object(loc, obj_var1)==33) link_pic=13 link_dir=up
			case LINK_HOLE_FALL:
			//------------------------------------------------------------------
			// The hole falling is a set of 3 pictures of link.  They are in
			// order.  it starts with picture 13.  the link pictures are in a
			// 3 dimentional array.  the link_direction tells game to use the
			// 2nd dimension in the 3D array.  link_picture tells the game to
			// use the 1st dimension of the 3D array.  
			//------------------------------------------------------------------			
			
			link_picture=13;	link_direction=up;
			if (link_frame>10){link_direction=down;}
			if (link_frame>20){link_direction=left;}
			if (link_frame>30){
				//------------------------------------------------------------------
				// after you show the gfx of link falling, make him lose life and 
				// reset his x/y position to where he entered the room.
				//------------------------------------------------------------------				
					link_state_reset();
					mod_link(hp,-4,FALSE);
					link_frame=-1;
					link_x=room_entry_x;// reset link to where he ented into the room
					link_y=room_entry_y;
					link_direction=down;
					dont_get_stuck();
					hover=0;
				}				
			return;
			case LINK_GET_ITEM:
			//------------------------------------------------------------------
			// this is where link holds an item after he gets it from buying
			// or a treasure box.  make link wait 24 loops before going back
			// to normal.  Also, force set his picture and direction.
			// if getting the item from a treasure chest, then it will be #1000+
			// so you will have to get the picture of that item to display it
			//------------------------------------------------------------------
			link_direction=down;	link_picture=11;
			stat=link_stat(hold_carry);
			
			if (stat>=1000){stat=get_item_info(stat, item_pic_id);}// if a normal item, then get its pic			
			if (link_frame<=24){obj_quickdraw(link_x, fix_row_gain(link_y-13), stat,  A_NORMAL, 0);}
			else {link_state_reset();terminate=TRUE;}
			return;
			case LINK_SPIN_SLASH:		gfx_spin_slash();			return;
		}//end switch
		if (link_frame>1){link_state_reset();return;}
}// end stunned

//=================================================================================================
/*
		any state duality
		this contains the dual states that could fall under any main state of link.
		the included states are reel back, death. 
*/
//=================================================================================================	

void any_state_duality()
{	
	int x=0;
	switch (link_stat(dual_state))
	{
		
		case LINK_REEL_BACK: mod_link(link_blink,10,TRUE);// make link blink around 5 times after he gets hit.
		case LINK_REEL_BACK_NO_DAMAGE:	gfx_reel_back(LINK);	break;
		case LINK_DEAD:
				if (!skip_animate_mob){link_frame=0;}// set the frame to 0 during the first run.
				
				//------------------------------------------------------------------
				// force the mobs to not animate while link is dead.  this prevents
				// strange things from happening.
				//------------------------------------------------------------------
				skip_animate_mob=TRUE;

				//------------------------------------------------------------------
				// keep link dead so he will not return back to life.  this will
				// prevent people from playing link while he has 0 life and to 
				// prevent link from coming back to life due to whatever bug.
				//------------------------------------------------------------------
				mod_link(state,LINK_NORMAL,TRUE);	mod_link(dual_state,LINK_DEAD,TRUE);
				link_picture = LINK_NORMAL;
				
			//------------------------------------------------------------------
			// Now make link spin around as he dies.
			//------------------------------------------------------------------
			if ((link_frame%5)==0){link_direction=circle_dir(link_direction);}
			if (link_frame>45){
				
				//------------------------------------------------------------------
				// After spinning, check for a faerie in a bottle. if found then
				// bring link back to life.
				//------------------------------------------------------------------
				for (x=0; x<3; x++)
				{if (item_amt(item_bottle_1+x, 0)==bottle_faerie)
				{mod_link(state,LINK_STUN,TRUE);mod_link(dual_state,0,TRUE);mod_link(hp,1,TRUE);use_faerie(item_bottle_1+x);return;}}
			game_over();// if no faerie, then game over
			}
			link_frame++;
		break;		
	}// end switch
}// end any_state_duality()


//=================================================================================================
/*
		link state reset
		links reset state was used so much that i decided to make a simple function to 
			do it for me.  this saved a few bytes
		this just resets link's state to normal and blanks link's dual state	
*/
//=================================================================================================	

void link_state_reset(){mod_link(state,LINK_NORMAL,TRUE);mod_link(dual_state,0,TRUE);skip_animate_mob=FALSE;}

//=================================================================================================
/*
		normality
		this contains the dual states for link_normal
		dual states in here are carry and lift
*/
//=================================================================================================	


void normality()
{
		int x=0,y=0;
		switch(link_stat(dual_state))
		{
				case LINK_CARRY: carry_item(); return;
				case LINK_LIFT1:
				link_picture=10;
				//------------------------------------------------------------------
				// link kept on grabbing a shadow, but in reality, it was item# 555
				// so this should prevent link from grabbing non-existant items.
				//------------------------------------------------------------------
				if ((x=link_stat(hold_carry))==555){link_state_reset();link_frame=0;return;}

				//------------------------------------------------------------------
				// force the object to stay above links head
				//------------------------------------------------------------------
				y=get_object(x,obj_y);
				if (y<=(link_y-14))
				{
					set_object(x,obj_x,link_x);
					set_object(x,obj_y,link_y-16);
					if (get_object(x,obj_type)!=boom_bomb){	set_object(x,obj_type,follow_object);}
					mod_link(dual_state,LINK_CARRY,TRUE);
					
				}
				else{	set_object(x,obj_y,y-4);link_frame=0;	}	

			break;
			
		}// end switch	

	
}// end normality()


//=================================================================================================
/*
		animate link
		this is the main routine that will animate link.
		it will do transistioning, if necessary (ie the fade in/out when changing areas)
		if link is on a treadmill, then it will force move link.
		it will loop through the link state and dual state
		it will also force draw link and a raft if link is on the water.
		*** this is one of the main routines called in the main loop.  try to keep it as small
			and efficient as possible.
*/
//=================================================================================================	


void animate_link()
{

	//------------------------------------------------------------------
	//  Do the transition
	//------------------------------------------------------------------

	if (g_transistion_active()>0){slowdown=0;we_transistion=TRUE;//disp_error_num(infini_loop,g_transistion(),g_transistion_active());
			//infini_loop++; if (infini_loop>=500){s_transistion_active(0);s_transistion(0);warper(link_direction);infini_loop=0;we_transistion=FALSE;}
			if (g_transistion_active()>=3){warper(link_direction);}
	if ((g_transistion_active()==2) && (g_transistion()<2)){slowdown=link_stat(save_speed_limiter);}return;} 
	we_transistion=FALSE;

	//------------------------------------------------------------------
	//  If touching a treadmill, then move link
	//------------------------------------------------------------------

	if (touching_sprite(link_x, link_y, 66)){link_direction=up; move_link(link_speed);}
	if (touching_sprite(link_x, link_y, 70)){link_direction=right; move_link(link_speed);}
	if (touching_sprite(link_x, link_y, 74)){link_direction=down; move_link(link_speed);}
	if (touching_sprite(link_x, link_y, 78)){link_direction=left; move_link(link_speed);}

	//------------------------------------------------------------------
	// 	If link is hold a shield, then set his picture
	//------------------------------------------------------------------

	if (item_type_exists( shield, hold)){link_picture=4;}else {link_picture=0;}

	//------------------------------------------------------------------
	// Link has 4 main states.  each main state has sub states.
	// How link moves will be based upon his main and sub state.
	// Hopefully, this will remove confusion and make things simpler
	//  with less code.
	//------------------------------------------------------------------

	switch (link_stat(state))
	{
		case LINK_NORMAL:  normality();		break;
		case LINK_WALK:  walking(link_picture,link_speed);link_frame++;	break;
		case LINK_ATTACK:  attacking();	link_frame++;	break;
		case LINK_STUN:			stunned(); link_frame++;	 break;
		default:link_state_reset();link_frame = -1;terminate=TRUE;break;
	}//end switch
	any_state_duality();

	//------------------------------------------------------------------
	// if link is touching water, then display the raft
	//------------------------------------------------------------------

	if (touching_sprite(link_x, link_y, water_pic)){
			int rot=0; 	if (link_direction==right || link_direction==left){rot=rot_90;}
			obj_quickdraw(link_x, fix_row_gain(link_y+8), item_raft_pic, A_NORMAL, rot);
		}// END IF ON WATER.
		
		DrawImage(LINK, link_picture, link_x, link_y, A_NORMAL, TRUE,0);// draw link
		
}// end animate link*/

//=================================================================================================
/*
		toss object
		this was removed from chk_for_lift() and made separate so link could toss any item he is
			holding in the event he changed states from link_carry
*/
//=================================================================================================	


extern int argh;
void toss_object()
{
		int	new_oj=link_stat(hold_carry), item=item_bomb, typ=get_object(new_oj,obj_type);
		
		//------------------------------------------------------------------
		//	Check the object type and change it to a generic type or a bomb.
		// 	this will make it do damage or explode.
		//------------------------------------------------------------------		
		if ((typ==boom_bomb) || (typ==bomb)){set_object(new_oj,obj_type,flying_bomb);}		
		else {set_object(new_oj,obj_type,throw_object);item=item_rock;}
		preset_obj(new_oj, get_object(new_oj,obj_type), 0, 0, item,5);// set all the object stats
		mod_link(hold_carry,-1,TRUE);dont_draw_object=-1;// remove the item from link
		argh=15;
		mod_link(state,LINK_ATTACK, TRUE);// put link into attacking mode so it will animate
}// end throw object

//=================================================================================================
/*
		sword charging()
		this was made separate from gfx_slash() so i could use it in multiple
			places, specifically the sword walking area in animate_link()
		this routine will make the sword blink and return the draw type, so when you draw the sword
			with quickdraw, you can pass in the modded draw type into quickdraw() to make the sword "blink"	
*/
//=================================================================================================	


int sword_charging(int charge)
{
	int draw_type=A_NORMAL, blink=FALSE; // set up the blinking
	//------------------------------------------------------------------
	// If charging, then increase sword_charge.  If the sword_charge is
	// high enough, then change things so the sword will have the blink
	// effect.
	//------------------------------------------------------------------
	if (charge){sword_charge++;	if (sword_charge>150){sword_charge=50;}if ((sword_charge%2)==0){blink=TRUE;}}
	else {if ((link_frame%2)==0){blink=TRUE;}}
	if ((sword_charge>30)&& blink && (link_stat(hp)>=(int)(link_stat(max_hp)*.7))){draw_type=A_REVERSE;}
	return draw_type;
}// end sword charging.


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//=================================================================================================
/*

*/
//=================================================================================================	
