// C Source File
// Created 3/4/2015; 6:39:29 PM

#include <tigcclib.h>
#include "all.h"

extern int dark_room, link_x, link_y, shop_active, link_frame, 
						skip_animate_mob, slowdown, link_direction,dont_draw_object;
//------------------------------------------------------------------
//
//------------------------------------------------------------------

//=================================================================================================
/*

*/
//=================================================================================================

//=================================================================================================
/*
			obj_bounce() will make an object appear to be bouncing by adjusting the y coordiante of the
			object
*/
//=================================================================================================


void obj_bounce(int loc)
{
	
	switch (get_object(loc,obj_frame))
	{
		case 2 ... 3:
		case 8:	case 12:
					increase_object(loc, obj_y, -2);
		break;
	
		case 5 ... 6:
		case 10: case 14:
					increase_object(loc, obj_y, 2);
		break;
	}// end switch

}// end obj bounce

//=================================================================================================
/*
	 	obj_blink() will make an object appear to blink.  there are 2 different options:  if 
	 	darken == TRUE, then it will switch the planes of the object and draw it "inverse" colors
	 	like.  if darken == FALSE, then it will force the object to not draw.  it loops based off
	 	of 4 frames - every 2 fames makes it display normal and the other 2 frames displayes based
	 	off of the value of "darken".
*/
//=================================================================================================


void obj_blink(int loc, int darken)
{
		
			int frame=get_object(loc, obj_frame);

					if (frame%4>1){if (darken){frame=A_REVERSE;}else {frame=dissappear;}}
					else {frame=A_NORMAL;}

			set_object(loc, obj_draw_type, frame);
}


//=================================================================================================
/*
		obj_rotater() will choose which direction to rotate an object.  used for things like the
		boomerang and rotating mob weapons
*/
//=================================================================================================


void obj_rotater(int loc)
{
int typ=get_object(loc,obj_type);
 if (mob_rotate_weaps || (typ==boomerang))
 {set_object(loc, obj_rotate,rotate_dir(get_object(loc, obj_rotate))); }
/*			switch (get_object(loc,obj_type))
			{
				case boomerang: 
				case arrow_foe_rotate:// ... arrow_foe_rotate_follow:
					set_object(loc, obj_rotate,rotate_dir(get_object(loc, obj_rotate))); 
				break;
			}*/

}

//=================================================================================================
/*
		obj_cleanup() is like a garbage collection of objects.  it will delete objects off of the 
		screen based off of its frame number.  different objects have different lengths of time
		they will stay displayed, before they are deleted.  for this, they are defined in the
		switch statement.  if a new version of the ti-89 is made where the processor is faster
		than 14 mhz, then you will need to adjust these.
*/
//=================================================================================================



void obj_cleanup(int loc)// this will be the place where the object will be removed
{
	int delete=FALSE;
	int frame=get_object(loc,obj_frame);
	
	switch (get_object(loc,obj_type))
	{ 
		case potion:
		case hookshot: case boomerang: case throw_object: case follow_object: return;// do nothing if either one of these
		case leaf: case shatter: if (frame>6){delete=TRUE;} break;
		case fire: if (frame>17){delete=TRUE;} break;
		case rupie: case arrow_ammo: case heart: case bomb:
				if (frame>177){delete=TRUE;}
		break;
		case explosion: if (frame>=9){delete=TRUE;} break; 
		case toggle_switch:	case spike: return; // spikes never get removed.
		default: if (frame>140){delete=TRUE;} break;// a temp situation
	}// end switch
	if (delete){delete_obj(loc);}
}// end obj_cleanup


//=================================================================================================
/*
		touch_faerie() is for when link touches a "faerie" object type.  if he does, then it will
		stun link (so you cant press buttons), disable the displaying of the mobs, and then 
		heal link's hp at 2 hp per loop.  the faerie object should auto animate when disp_objects
*/
//=================================================================================================


void touch_faerie(int loc)
{
				
					set_object(loc, obj_var2, disp_circle_object(get_object(loc,obj_var2), get_item_info(get_object(loc,obj_num),item_pic_2)));
					mod_link(hp,2,FALSE);
					mod_link(state,LINK_STUN,TRUE);
					skip_animate_mob=TRUE;// do this to make sure mobs dont attack you while being healed.
					set_object(loc,obj_y, link_y);// you have to do this, b/c if you dont, then it will delete the object, so
					// simply make it return to link_y and have it run... whatever.
					if (link_stat(hp)>=link_stat(max_hp)){set_object(loc, obj_frame, 200);
							mod_link(state,LINK_NORMAL,TRUE);skip_animate_mob=FALSE;}
}// end touch_faerie

//=================================================================================================
/*
		obj_explosion_contact_wall() checks to see if object_type "explosion" is touching a wall
		that is predefined to become a hole if "bombed".  if it is, thne it will put a walkable 
		sprite there. then it will check the other room, of the	opposite side, to see if the same 
		type of wall exists, if so, then it will put a walkable	sprite there, too.  
*/
//=================================================================================================


void obj_explosion_contact_wall(int loc)
{
		int	i=192,ax=0,ay=0,x=0, y=0, chk=0,rmapx2=rmapx,rmapy2=rmapy;
		while (i<200){// search through to see if a wall is bombed.
				ax=0;ay=0;
				while (ax<3){
				while (ay<3){
					if (touching_sprite( get_object(loc,obj_x)+(ax*10)-2,get_object(loc,obj_y)+(ay*10)-2, i)){
							
							x=get_object(loc,obj_x)+(ax*10)-2;
							y=get_object(loc,obj_y)+(ay*10)-2;	
							chk=precision_sprite_find(x, y,i);// get and fix the sprite location.
							if (chk>=100 && chk<200){x+=(chk-111);}
							else if (chk>=200){y+=(chk-211);}
							y=gter(y);x=gter(x);

							if ((chk=get_all_maps(rmapx, rmapy,y,x))<196){chk+=4;}
							chk-=150;// this does the same thing as the switch below.

						
							if (chk>45 && chk<50){set_all_maps(rmapx, rmapy,y,x, chk);
									// first replace the bombed part with a hole
									// then check to see if it was on the edge of the screen.
									// if it was, then attempt to look at the next room to the lrud
									// of it to see if it was a bombable place, too.  if it was, then 
									// replace that sprite too.  - the original zelda allowed this
									// and when trying to make their maps, it was a pain b/c the rooms could be
									// bombed from either side.  this was a real problem for me, so this should fix
									// it.
							
									if (y==0){y=7;rmapx2=rmapx-1;}
									else if (y==7){y=0;rmapx2=rmapx+1;}
									else if (x==0){x=9;rmapy2=rmapy-1;}
									else if (x==9){x=0;rmapy2=rmapy+1;}
									else {goto skip;}
								
									if ((chk=get_all_maps(rmapx2, rmapy2,y,x))<196){chk+=4;} chk-=150;
									if (chk>45 && chk<50){set_all_maps(rmapx2, rmapy2,y,x, chk);}
									
								skip:
							}// had strange atrifacts show up, so this will
							// prevent some odd out of bounds errors.
				}// end if touching sprite
				ay++;
			}// end ay
				ay=0;ax++;
			}//end while ax
			i++;
		}// end while search for wall bombed.
}// end obj_explosion_contact_wall


//=================================================================================================
/*
		obj_contact_link() is part of the obj_contact().  it checks to see if an object comes into
		contact with link.  this handles random drop objects (from mobs and cutting grass), shop
		objects, special items, weapons (including mob weapons), etc.
*/
//=================================================================================================


void obj_contact_link(int loc)
{
	int typ=get_object(loc,obj_type);
// it is shorter to choose what you want link to be hit by than choosing what he will not be hit by
		if ((typ!=bomb) && (typ!=arrow_ammo) && (typ!=faerie) && (typ!=heart) && (typ!=rupie) && (typ!=key_normal) && (typ!=explosion)
				 && (typ!=hookshot) && (typ!=boomerang) && (typ!=item_hookshot_chain) && (typ!=light_orb) && (!mob_weaps)
				 && (typ!=potion)  && (typ!=ring) && (typ!=spike)){return;}
//	if (typ==rock || typ==boulder || 	typ==slashable_terrain || typ==pushable || typ==boom_bomb || typ==flying_bomb
//			|| typ==torch || typ==treasure_box || typ==raft || typ==friendly_arrow || typ==throw_object || typ==wand)	{return;}
	int amt=1, item=get_object(loc,obj_num);
	
	if (touch_object(link_x, link_y, LINK, loc, FALSE)==TRUE){
		
	//	if (typ==spike){disp_error("touched");}
		if ((mob_weaps) || (typ==spike))  {pain(LINK, get_object(loc, obj_dam),get_object(loc, obj_type), loc);set_object(loc, obj_frame, 200);return;}
		if (typ==explosion) {if (get_object(loc, obj_frame)>=9) {pain(LINK, 8 , type_explosion,loc);}return;}
		
		
		if (shop_active){
		//	disp_error_num(item, get_item_info(item,item_cost),link_stat(rupies));
		if (link_stat(rupies)>=get_item_info(item,item_cost) && link_stat(dual_state) != LINK_GET_ITEM)
		 		{
		 			//0, 4, 13, 80m 92
				 	//	disp_error_num(item, 0,0);
				 		if (typ==potion)
				 		{// prevents link from buying a potion if there is no empty bottle in hand
				 						int i=hold_a;
										while (i<=hold_c){
											if ((get_item_info(link_stat(i), item_type)==bottle) && (link_stat(i+18)<=0))
											{goto cntu;}
											i++;
										}// end while
										return;
				 		}// end if a potion
		 		
		 		cntu:
		 			add_item_inv(item,get_object(loc, obj_var1));
		 			mod_link(rupies,get_item_info(item,item_cost)*-1,FALSE);
		 			mod_link(dual_state,LINK_GET_ITEM,TRUE);
		 			mod_link(state,	LINK_STUN,TRUE);
		 			mod_link(hold_carry,get_item_info(item,item_pic_id),TRUE);
		 			clr_object(); shop_active=FALSE;// if the shop is active, then clear out the
		 			// objects in the list, then add the new one above link.
		 			
		 			link_frame=0;
		 			
		 			// put the item in the rand var spot so i can delete it later.
		 		}
		}// end if shop active
		else {
		

			switch (typ)
			{
				case bomb: case arrow_ammo: amt=5; break;
				case faerie:  touch_faerie(loc);   return;
				case key_normal:  set_room_info(key_gotten,TRUE); break;//case key_boss: case key_master:
			//	case bomb_bag: case rupie_bag: case quiver: add_special_item(typ, get_object(loc,obj_num));return;
				case hookshot: link_state_reset();case boomerang: 
				
					if (get_object(loc,obj_frame)>2){delete_obj(loc);} return; break;
				case item_hookshot_chain: set_object(loc, obj_frame, 200); return;
			}
				set_object(loc, obj_frame, 200);// make sure it does garbage collection
				add_item_inv(get_object(loc,obj_num),amt);
			}// end if shop not active
		}

}// end obj_contact_link

//=================================================================================================
/*
		obj_contact() will test 3 different things: contact with link, mob, another object, or special
		types of contacts, like a wall (in that	order).  any object that does something when it comes
		into contact with something, then put it in this routine.  
*/
//=================================================================================================


void obj_contact(int loc)
{
	 int who=0;
	 int typ=get_object(loc,obj_type);
	 int frame=get_object(loc, obj_frame);
	 int ox=get_object(loc,obj_x), oy=get_object(loc,obj_y);
	
	
	 	obj_contact_link(loc);
	 
	 if ((who=touch_mob(ox, oy, loc))!=555)
	 {
	 		switch (typ)
	 		{		
		 		case wand:	 			
		 			add_object(item_fire, get_object(loc,obj_x),get_object(loc,obj_y),item_fire);
		 			stun_mob(who, 30);// set the mobs stun to 30 so it will burn a lot
		 			set_object(loc, obj_frame, 200);
				break;
				case explosion: if (frame>=9){pain(who, 8 , type_explosion,0); goto tsprites;} else {return;} break;
				case fire: 			if ((frame%3)==0){pain(who, 7, type_fire,0);} 	 break;
				case boomerang:	stun_mob(who, 30); set_object(loc,obj_dir, dir_return);  break;
				case hookshot: 	set_object(loc,obj_var1, 100);  return; break;//set_object(loc,obj_dir, dir_return);
				case friendly_arrow: pain(who, get_object(loc, obj_dam),type_arrow,0); set_object(loc, obj_frame, 200); return;
				case throw_object:
				case rock: 
					add_object(item_shatter, ox, oy,item_shatter); 
					pain(who, get_object(loc, obj_dam),0,0); 
					delete_obj(loc);
				return;
			};// end switch
		

	 }// end if touching a mob
	 
	 
	 


	 if ((who=touch_object(ox, oy,OBJECT,  loc, TRUE))!=555)
	 {
			int who_type=get_object(who,obj_type);
			switch (typ)
	 		{		
			 		case wand:
					 	 if (who_type==torch){
					 			add_object(item_fire, get_object(loc,obj_x),get_object(loc,obj_y),item_fire);
					 			delete_obj(who);  delete_obj(loc);
					 			set_room_info(torches_lit,get_room_info(torches_lit)+1);
					 			if (get_room_info(room_lit)){dark_room=FALSE;set_object_animate_info(link_direction, dark_room);fill_current_room();}// end if all torches lit.
					 			
					 			set_object(loc, obj_frame, 200);
							}//end if torch
						
					case friendly_arrow:	
						 if (who_type==toggle_switch){change_toggle_switch();delete_obj(loc);}	
					break;
					case boomerang:
						if ((who_type==rupie) || (who_type==heart) || (who_type==bomb) || (who_type==arrow_ammo) ||
								(who_type==key_normal)){
									
								set_object(who, obj_x, ox);
								set_object(who, obj_y, oy);
								set_object(loc, obj_dir, dir_return);
								set_object(loc, obj_var1, who);
							}
							else if ((who_type==toggle_switch) && (get_object(loc,obj_dir) != dir_return))
										{change_toggle_switch();set_object(loc,obj_dir, dir_return);}
					break;
					case item_hookshot_chain:
						if ((who_type==hookshot) && (get_object(who,obj_var1)>=100)){set_object(loc, obj_frame, 200);}
					break;
					case spike:
						if (who_type==pushable){	reset_spike(loc);}
					break;
				}// end switch
			}//end if touching object

			 tsprites:
			 if ((typ==explosion) && (frame>=9)){obj_explosion_contact_wall(loc);}
			 if ((typ==boomerang)	&& ((who=get_object(loc, obj_var1))>=0))
						{// just in case it loses it
							set_object(who, obj_x, ox);
							set_object(who, obj_y, oy);
						}
}// end obj_contact
//61191


//62191
void set_obj_opposite_dir(int loc, int speed)
{
	int xp=get_object(loc, obj_speed_x);
	int yp=get_object(loc, obj_speed_y);
						
			 if (yp<0){yp=speed;}
	else if (yp>0){yp=speed*-1;}
	else if (xp<0){xp=speed;}
	else if (xp>0){xp=speed*-1;}
								
	set_obj_speed(loc, xp, yp);
}

void reset_spike(int loc){set_obj_opposite_dir(loc, 2);	set_object(loc,obj_var1, 3); }

int mv_spike(int loc)
{if (movable(loc, 0, OBJECT))  {move_object( loc, 0,0);return TRUE;}return FALSE;}


void move_spike(int loc)
{
		
		int x=get_object(loc, obj_x);
		int y=get_object(loc, obj_y);
		int h=get_object(loc, item_H);
		int w=get_object(loc, item_W);	
		int xp=0, yp=0,exec=FALSE;	

		switch (get_object(loc,obj_var1))
		{
			case 2:
				
				if (!mv_spike(loc)){	reset_spike(loc);}
			break;
			case 3:
				xp=get_object(loc, obj_speed_x);
				yp=get_object(loc, obj_speed_y);
				w=get_object(loc,obj_var2);
				mv_spike(loc);
						 if (yp<0){if (y<=w){exec=TRUE;h=obj_y;}}
				else if (yp>0){if (y>=w){exec=TRUE;h=obj_y;}}
				else if (xp<0){if (x<=w){exec=TRUE;h=obj_x;}}
				else if (xp>0){if (x>=w){exec=TRUE;h=obj_x;}}
				if (exec){
					set_object(loc,h, w);// set its thing back in place
					set_obj_speed(loc,  0,  0);
					set_object(loc,obj_var2, 0);// set the return var
					set_object(loc,obj_var1, 1);	
				}
			break;
			default:
			
				if ((link_x+14<x) || (link_x>x+w)){exec=FALSE;}
				else{
					if (link_y<y){yp=-5;}else{yp=5;} exec=TRUE;x=y;
					goto skip;
				}	
				
				if ((link_y+14<y) || (link_y>y+h)){exec=FALSE;}
				else{	if (link_x<x){xp=-5;}else{xp=5;}exec=TRUE;}	
				skip:
				if (exec){
					
					set_object(loc,obj_var2, x);// set the return var
					set_obj_speed(loc, xp, yp);
					set_object(loc,obj_var1, 2);
				
				}//end slse
			break;
		}//end switch
	
}// end spike

//=================================================================================================
/*
		move_all_objects() will call the correct routine to animate based off of the object type
*/
//=================================================================================================



void move_all_objects(int loc)
{

				int frame=get_object(loc,obj_frame);

						switch (get_object(loc,obj_type))
						{
							case mob_poof:	obj_blink(loc,TRUE); animate_mob_death(loc);				break;
							case boomerang:	obj_rotater(loc);  move_object( loc, 5, get_object(loc,obj_dir));	break;
							case fire:			obj_blink(loc,FALSE);							break;
							case boom_bomb: animate_boom_bomb(loc);					break;
							case flying_bomb: animate_boom_bomb(loc);
							case throw_object: 	animate_throw_object(loc);	break;
							case arrow_foe ... arrow_foe_follow: 	animate_mob_weapons(loc);  obj_rotater(loc);	break;//

							case hookshot: obj_blink(loc,TRUE); animate_hookshot(loc); move_object( loc, 0, 0); 	break;
							case wand: slash_terrain( link_loc(get_object(loc, obj_y)),link_loc(get_object(loc, obj_x)));
							case friendly_arrow:   move_object( loc, 0,0); 	break;
							case rupie: case arrow_ammo: case heart: case bomb:
								if (shop_active){set_object(loc, obj_frame,0);return;}
								if (frame<15)	{obj_bounce(loc);}
								if (frame>149) {obj_blink(loc, FALSE);}
							break;
							case spike: move_spike(loc); break;
				
						}// end switch
			chk_obj_oob(loc);// make sure they do not go out of bounds
}// end display objects




//=================================================================================================
/*
			animate_objects() is the main routine called, which will animmate all objects in the 
			object_list[][].  the main idea is to do as few loops as possible, meaning, only attempt
			to move objects if they are the types that move.  other types, like rocks and pots, can
			skip all the movement checks and skip straight to displaying them.
*/
//=================================================================================================


void animate_objects()
{

	if (g_transistion_active()>0){return;} 	 
 	 int loc=0, typ=0;
	 for (loc=0; loc<obj_list_size; loc++){
	 	
	 	if (get_object(loc,obj_num) >= 500){

		 	typ=get_object(loc,obj_type);
		// 	if (typ==rock || typ==boulder ){goto end;}// activate this only if you want to increase terrain speed 
																									// but dont forget to modify drawterrain() as well.
																									 
		 if (typ==rock || typ==boulder || typ==slashable_terrain || typ==pushable || typ==torch || typ==treasure_box 
		 						|| typ==raft || typ==toggle_switch){goto drawonly;}// dont do checks, just draw them. - reduces cpu cycles.
			else if (typ==leaf || typ==shatter){goto bypass;}
		//	else if (typ==follow_object){goto end;}	// redundant, but do it to skip in the event to add speed				 			
			else{obj_contact(loc); move_all_objects(loc);}
			
			
			
			bypass:
			obj_cleanup(loc);
			//------------------------------------------------------------------
			// the object frame always has to be increased, it animates the 
			// objects and makes sure that the objects dissappear after a time.
			// although, the listed above that "goto drawonly", these are perm
			// displayers, so they should always skip having their frame 
			// increased.
			//------------------------------------------------------------------			
			increase_object(loc, obj_frame, 1);  
			drawonly:
			if (dont_draw_object!=loc){draw_object(loc);}
		//	end:
	 	}// end if the object exists
	 
	 }// end for
//		adjust_game_speed();
 	
 	 
 	 
}// end animate objects



//============================================================================================


