// C Source File
// Created 11/6/2015; 12:07:11 PM

#include <tigcclib.h>
#include "all.h"

//60358 -> 59935 -> 59847 ~0.5k less in size

//=================================================================================================
/*
																										PEDE INFO
																										
		the pede is an interesting mob.  it has one head and many body parts.	
		the head roams around freely, while the body parts follow the head.  
		technically, the body parts follow the mob in front of it (even more technical, it will
				follow "loc-1" where "loc" is	the location in the array of the mobs[].  so it would be 
				mobs[loc][<mob stat>] for current pede body and mobs[loc-1][<mob stat>] for the one it is 
				following)
		when a part of the pede changed direction, either the head or body, it will calculate the x / y 
				coordinate it changed directions at and the direction it changed to. 
				if the pede part WAS moving left or right, then it would get the x coordinate
				if the pede part WAS moving up or down, then it would get the y coordinate
				then it would get the number for the direction it changed to
				
				the pede directions are calculated like this: ((lrud + 1) * 1000) + (x / y corrdiante)
				that direction calculation is then put in mob_rand_var1 of "loc+1".  if mob_rand_var1
				is used, then it will put it into mob_rand_var2.
				
				to see if the pede body will change a direction, then it will check mob_rand_var1 to 
				see if it is > -100.  if it is, then it will reverse calculate the number and see if
				it has moved to the correct x/y coordinate.  if it has then it will change direction.
				
				after it changes it direction, it will pass mob_rand_var1 to mobs[loc+1][].  then it will
				look at mob_rand_var2 and see if it is > -100.  if it is, then mob_rand_var1=mob_rand_var2.
				then it will make mob_rand_var2 = -100.  if mob_rand_var2 <= -100, then mob_rand_var1 will 
				be reset to -100.   					

		just to make things work right, the spacing of the pede has to be checked to maintain the 
				the correct spacing between the sprites, so it will look right, otherwise the body parts
				will seperate and it will not maintain correct form
				
		** IMPORTANT ** 
					- for the pede to work correctly, you must set the mob_rand_var1 and mob_rand_var2 
						to -100 in the external files during the mob creation.  otherwise, the pede body
						will just walk off the screen.
					- (-100) is the indicator that the pede does not need to test to see if it needs to
						change a direction.			

			*lrud	- this means: "left, right, up, or down"						
*/
//=================================================================================================	


//=================================================================================================
/*

*/
//=================================================================================================	

void set_pede_vars(int loc, int dup_var1){
	
		loc++;

		if (get_mob_stat(loc,mob_type)!=pede_body){return;}
		if ((loc)<max_mobs)
		{
			if (get_mob_stat(loc,mob_rand_var1)<=-100){mod_mob(loc, mob_rand_var1, dup_var1, TRUE);}	
			else{mod_mob(loc, mob_rand_var2, dup_var1, TRUE);	}
		// check to see if var1 is used., if not, then store.  if used, then store in 
		// var 2
		
		}	//end 	if ((loc)<max_mobs)
	
}//end set pede vars
//=================================================================================================
/*

*/
//=================================================================================================	

void chk_spacing(int loc)
{
			int who=loc-1;
			int dir_loc=get_mob_stat(loc,mob_dir);
			int dir_who=get_mob_stat(who,mob_dir);		
			if (dir_who!=dir_loc){return;}//if not the same dir, then dont do anything.
			int x=get_mob_stat(loc, mob_x);
			int y=get_mob_stat(loc, mob_y);
			int a1=0, a2=0,  wh2=0;
			int wh=mob_w;
			
			int xy=mob_x;
			
				if ((dir_who==up) || (dir_who==down)){xy=mob_y;wh=mob_h;}				
				a1=get_mob_stat(loc,xy);// loc is chasing who
				a2=get_mob_stat(who,xy);
					

				wh2=mob_stat_flip(who,wh);
//59931
	int spacing=1;// change if you want the spacing to be different
	int b1=(wh2+a2+spacing);
	int c1=(a2-wh2-spacing);
		switch (dir_loc)
	{
		case left: 	if (b1!=a1){x=b1;} break;
		case up: 		if (b1!=a1){y=b1;} break;
		case down:  if (c1!=a1){y=c1;} break;
		case right: if (c1!=a1){x=c1;} break;
		default: return;
	}// end switch

		mod_mob(loc, mob_x, x, TRUE);// set the x/y coords
		mod_mob(loc, mob_y, y, TRUE);
}//chk_spacing(int loc)*/

//=================================================================================================
/*

*/
//=================================================================================================	

void pede_body_3(int loc){
if ((loc<0) || (loc>=max_mobs)){return;}
int dir=get_mob_stat(loc,mob_dir);
int var1=get_mob_stat(loc,mob_rand_var1);
int var2=get_mob_stat(loc,mob_rand_var2);		
int dup_var1=var1;
		
	int num=0;
	while (var1>(999-16)){var1-=1000;num++;}
	num--;// b/c of the offset of +1 with the lrud
	int x=get_mob_stat(loc, mob_x);
	int y=get_mob_stat(loc, mob_y);

		
	move_constant(loc, get_mob_stat(loc,mob_speed));//int ani_speed);
	
	if (var1<-16){goto drawonly;}// no direction changing if var1 is not set.

	int change=FALSE;
	
	switch (dir)
	{
		case up: if (y<=var1){change=TRUE;y=var1;}break;
		case down: if (y>=var1){change=TRUE;y=var1;}break;
		case left: if (x<=var1){change=TRUE;x=var1;}break;
		case right: if (x>=var1){change=TRUE;x=var1;}break;
		default: disp_error("pede var1 broken");break;
	}// end switch

	if (change)
	{

		mod_mob(loc, mob_dir, num, TRUE);//set the direction
		mod_mob(loc, mob_x, x, TRUE);// set the x/y coords
		mod_mob(loc, mob_y, y, TRUE);
		
		set_pede_vars(loc,dup_var1);
		
		if (var2>-100){	var1=var2; mod_mob(loc, mob_rand_var2, -100, TRUE);	}	else {var1=-100;}
		
		mod_mob(loc, mob_rand_var1, var1, TRUE);
		

	}// end if change
	

	chk_spacing(loc);

	drawonly:
	DrawImage(MOB, picture_rotator(loc, get_mob_stat(loc, mob_current_sprite)),get_mob_stat(loc,mob_x) , get_mob_stat(loc,mob_y), loc, TRUE,0);

}// end pede body

//=================================================================================================
/*

*/
//=================================================================================================	



void pede_head_3(int loc)
{
	int dir=get_mob_stat(loc,mob_dir);
	
	try_to_move_mob(loc);

	if (get_mob_stat(loc,mob_rand_var2)<0){mod_mob(loc,mob_rand_var2,35+random(22),TRUE);change_dir(loc);}
	
	int dir2=get_mob_stat(loc,mob_dir);
	int num=0;
	if (dir!=dir2){
		switch (dir)
	{
		case up:
		case down: num=get_mob_stat(loc, mob_y); break;
		case left: 
		case right: num=get_mob_stat(loc, mob_x);break;
	}// end switch	
	mod_mob(loc,mob_rand_var2,7,FALSE);
	set_pede_vars(loc, ((dir2+1)*1000)+num);}
	mod_mob(loc,mob_rand_var2,-1,FALSE);
	DrawImage(MOB, picture_rotator(loc, get_mob_stat(loc, mob_current_sprite)),get_mob_stat(loc,mob_x) , get_mob_stat(loc,mob_y), loc, TRUE,0);
}// end pede head
//=================================================================================================
/*

*/
//=================================================================================================	

