// C Source File
// Created 7/27/2011; 8:07:14 PM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"
//#include "story_line.h"
#include "dung_maps.h"
/*
		map info:
		20 slots for info in 8,9
		
		need for slots:
		- gfx file needed
		- mob gfx list needed
		- mob file (stats) to load for the room - avg of 4 mobs per room (could have more. i think i 
			will max it out at 8 mobs per room)
		- warp file
		- shop file
		- movable object list (objects can only move onto walkable areas and can only move once) - remove
				from list once moved. this list is loaded upon entering the room and deleted upon exit
		- town mob list (including the msgs that they will say)
		- treasure list (5 boxes at max)
		- room dark/light (whether the rooms displays dark or not.)
		
		9,9=room number. - make sure a number is not in there.  the below routine will automatically set the #
		
		- list for locked doors. (door loc (sprite id#), key (id #) needed to unlock) 
				(to create this... give a sprite id# and if you come accross that sprite and you have the
					key, then auto unlock. and replace sprite with an opean door.)
					make one of the keys so that they are used upon opeaning the door, while all others
					are infinite use as long as you have it.




*/
extern int shop_active, link_x, link_y,  link_speed;
/*
#define warp_points 16
#define warp_room 0
#define warp_x_low 1
#define warp_x_high 2
#define warp_y_low 3
#define warp_y_high 4
#define warp_new_world 5
#define warp_new_rmapx 6
#define warp_new_rmapy 7
#define warp_new_link_x 8
#define warp_new_link_y 9*/
int current_warp=0, we_transistion=0;//, current_locked_doors=0;//,room_entry_x=0,room_entry_y=0;
int warp[warp_points][warp_stats]; //56028
extern int dark_room, room_entry_x,room_entry_y, link_direction;//repop,
/*
	up to 5 places to "warp"
	room #, x_low, x_high, y_low, y_high, new world, new world_x, new world_y, new x, new y,
	the last part shows the coordinates in the world, instead of trying to find the room #
	this is b/c you could put duplicate rooms in the world[][] and all it would do is find the 
	first room of that # and warp you there, which would be bad. 
	
	x_high and y_high may not be needed, b/c you can auto set it up to do x_low+8 or someting
	like that. - actually on 2nd thought, this is better, b/c you could have a large cave opening
	which would have like 2 or 3 sprites and if that happened, then you would need to have the range.
	
	
	i increaded warp to 16, so you could use the same warp file for 8 rooms, assuming 2 warp points each.
	
	posx >=, pos_x, pos_y, new posx, new posy, new room#, new world#
	posx <=,			""
	posy >=,			""		
	posy <=,			""
	notused,			""
	
	use -77 as a counter that says "overlook this" for the posx/y ><=
	
	this will only be used in those rooms which need to transfer to a new map or have
	stairs (warp point) that takes you somewhere else.
	
	use the same file for all of the room_maps[][][0][x] that forces you to goto another map
	this will only be useful for those at the top of the map
	do the same for room_maps[][][4][x] when you need to go to a lower part of the world map.
	then do it for all of the room_maps[][][x][0/3] for the other parts of the world map.,
	so you would only need 4 warping files for each of the thingies.
	
	current warp keeps track of the current warp file.  if you load the file once, then do not reload,
	b/c it is a waste of time.  you can make it {-1,0,0,link_x=7,link_y, 0, q}
	make the code so you can leave the new room blank so if you do, then it will only
	pay attention to the new world# and the newx/newy  that way you can resuse it.


	the warping system needs to be set up, so that if you are in a range of that variable, then you will 
	automatically be transferred to a new location.  maybe x+8 and y+8, to allow for completely walking
	on that area. or maybe +4 so you are 1 step away from that area.
*/

//int treasure[5][5];
/*
	x,y,item#, gold, treasure #id (to modify when gotten)
	if item<=0, then attempt to get gold
	if gold<= then attempt to get item
	if both are 0, then get nothing.
	draw gfx of item gotten.
	get the item id# and then link it to its pic id and disp that pic 
*/

//int locked_doors[5][3];
/*

	with new thoughts, locked doors will be automated, just like the rocks are.  there should be 3
	sprites for each door type: basic locked, boss locked, force sealed.  basic locked will go away with
	a key - just use 2nd and a key object you can buy.  if a door sprite, then replace door sprite with 
	floor. (or a black spot?).  better yet, get the current sprite link is standing on and duplicate it 
	where the door is.  for the force sealed doors, you can set up a sl file from mobs, to replace door
	with sprite. or you can have it automatically scan the room when all the mobs die and then replace all
	forced doors - your choice.  (i think i will do auto to avoid pain in the ass sl coding later. - also,
	run the check if all the mobs have died as well (when first loading the room- this may not matter though
	simply b/c the room maps should already be forced to be floor sprites - you may need a sprite to replace
	the doors with, when loading the room.  there might be a spot on the room arr to replace doors with a 
	predefined sprite.).)  - you will need a place in the room arr to let you know that there are doors.  
	if not, then you could use the key on the same sprite number on the main world map and you would lose 
	your key and the sprite of the terrain would change.
	- also, with the mobs, add in a space in the array for mob stats to tell whether the mob is a key holder
	or not. - actually, make it always drop something:
	1 - key
	2 - heart 
	3 - arrow
	4 - bomb
	5 - compass?
	6 - heart container.
	7 - boss key?
	 - if a key holder mob, then only allow 1 to exist. - will need to do checks, b/c mobs are loaded randomly
	 	- force the room to load all key holders, then force it to remove all but one keyholder.
	
	to make the compass work, force set the current map at x/y to blink...

	up to 5 locked places.  
	sprite id#, key needed to unlock, master key id (a key that does not go away when used.)
	(the first key place will make the key go away when you use it.)

	when you think about it, you could make 1 file and include every door in it.  then in those
	rooms, which have a locked door, then use this file and let it work.
	make sure you mod the gfx when you use this.
	
	- there should only be up to 4 locked doors, but there is a locked block that could be used for 
		#5.  spaces from 0->3 correspond to the 4 locked doors in ascending order.  those will be the id's to 
		which door it is.
	
	crrent_locked_doors is to keep track of the current locked door file.

*/
// msg list[][]
// movable_objcts[][]
/*

#define gfx_list 0
#define mob_gfx_list 1
#define mob_file 2
#define warp_list 3
#define treasure_list 4
#define locked_door_list 5
#define movable_objects 6
#define shop_list 7
#define towns_people 8
#define msg_list 9


#define room_dark 10  // just do <define> - 10 to get the thingie.
room id=19
#define mobs_killed 11 // this will tell you whether to load the mob file for the room or not.
	// modify this section once you kill off all the mobs.
use case 0 .. 9: for the 8 section.
and case 10 ... 19: for the 9 section.

*/

void clr_warp()
{
	
	int i=0,k=0;
	while (i<warp_points){
			while (k<warp_stats){	warp[i][k]=0; 
					k++;
				}// end while k
			i++;k=0;
		}// end while i
}


//=================================================================================================


// just fyi:  this just completely broke everything and caused address errors.
void get_map_vars()//int a, int b)// need the map id
{
	int i=0;//, k=warp_list;
	shop_active=FALSE;
	room_entry_x=link_x;
	room_entry_y=link_y;
//	while (i<shop_list){	clr_arr(i); i++;}// clear out the arrays
	i=get_object(link_stat(hold_carry),obj_num);
	int typ=0;
	
		
	clr_object();// clear out all of the obects in the room when you enter it.
	
	if (link_stat(dual_state)==LINK_CARRY)
	{
	//	disp_error_num(typ, i, 0);
		if (i>=1000){typ=get_item_info(i, item_type);}else{typ=get_object(i,obj_type);}
		if (typ==bomb){typ=boom_bomb;}
		i=add_object(i,link_x,link_y-16,i);
		//if (get_object(i,obj_type)!=boom_bomb){	set_object(i,obj_type,follow_object);}
		set_object(i,obj_type,typ);
		mod_link(hold_carry,i,TRUE);//not having this here makes the rocks dissappear when you go to another room.
	}
	room_object_adder();// add rocks and other liftable objects to the object list.
/*	else if (link_stat(dual_state)==LINK_RAFTING)
	{
		i=add_object(i,link_x,link_y+8,i);
		mod_link(link_rand_var1,i,TRUE);
		//set_object(i,obj_type,follow_object);// lets do this to see what happens.
	}//*/
	i=0;
	char sav[8];
	
	if (get_room_info(story_file)>0){
		
		exec_sl(get_room_info(story_file));
		//get_story(get_room_info(story_file));// get the sl file
	//	story_main();// execute the sl file.
	}// end if there exists a sl file
//	if  (current_warp==get_room_info(warp_list)){goto end;}
	if (get_room_info(warp_list)>0){
	
	TRY
	FolderCur(SYMSTR("etc"),TRUE);
	ONERR
	ENDTRY
	FILE *f = NULL;
	

					
					sprintf(sav,"wp%i",get_room_info(warp_list));	



	 TRY
	
	    if ((f = fopen(sav,"rb")) == NULL) { // this opens up the temp inventory
	        	clr_warp();// if you error, then just clear out the array.
//printf("broek  %s",sav);	
	        //yn = FALSE;
	    } else {fread(warp,sizeof(warp),1,f);	current_warp=i;fclose(f);
	    
	    		for (i=0; i<warp_points; i++)
	    		{// this helps prevent errors later on.  having this here keeps me from having to do these checks every time
	    			// i run through a warp list.  
	    			if (warp[i][warp_world_check]==same_map){warp[i][warp_world_check]=oob();}
	    			if (warp[i][warp_to_map]==same_map){warp[i][warp_world_check]=oob();}
	    		}// end for
	    		
	    }// end else
	
			ONERR
			
			ENDTRY
		}// end if
		
//printf("\n %i, %i, %i, %i", warp[0][0],warp[0][1],warp[0][2],warp[0][3]); wait_for_key(b_ko);
	
		clr_mob_list(1);// clear out the mob list.
	//	mobs_loaded=FALSE;mob_tracker=0;clr_mob_list();// clear the mob list
	
//printf("kry=%i info=%i",get_room_info(add_key),get_room_info(key_gotten));
//wait_for_key(esc_ko);	
	if ((get_room_info(add_key)>0) && (get_room_info(key_gotten)<=0))
		{	set_room_info(mobs_killed,0);	}
		// if there exists a key to be gotten and you have not gotten it yet, then 
		// this will force the mobs to reload.
	
	if (get_room_info(mobs_killed)<=0)
		{
			if (get_room_info(mob_file)>0){mob_gfx_loader(get_room_info(mob_gfx_list));}
			// only grab the gfx loader if the mob file is >0.  if it is 88, then it will be pulled by
			// compile mobs. 
			compile_mobs(get_room_info(mob_file), get_room_info(mobs_start), get_room_info(mobs_end),1,get_room_info(mobs_amount));// set the file
		 	if ((get_room_info(add_key)>0)&& (get_room_info(key_gotten)<=0)){mod_mob(0,mob_item,item_key_normal,TRUE);}
		 	// if you auto add a key, then give it to the first mob on the mob list.
		}// end if mobs not killed
		else {door_scan();}// if all mobs killed then do a door scan.
		dark_room=get_room_info(room_dark);// if the room is flagged as dark, then it will make it start as dark.
		//just change this internal var and it will make the room light again.
		if (get_room_info(room_lit)) {dark_room=FALSE;}// if the room has been lit via the room_stats, then force the room 
		// to be lit.
	chk_dung_map();// this will check to see if the dung map is mapped or not.
	if (we_transistion){s_transistion_active(2);s_transistion(50);}
	// this might take care of the mysterious shadow that appears..
	 set_object_animate_info(link_direction, dark_room);
	 fill_current_room();	
	 sword_set(link_x, link_y, 14, 14);// prevent the sword from being in a different spot.
	 set_num_of_mobs();
}// end get map vars





//=================================================================================================




	
/*	
int room_exists(int id)// this may be pointless
{
//	int i=0,k=0;
//	while (i<4)
//	{
//		while (k<4)
//		{
			if (get_room_maps(9,9)==id){return TRUE;}
//			k++;
//		}// end while k
//			i++;k=0;
//	}// end while i
	return FALSE;
}// end room exists
*/
/*
#define warp_points 16

// from warp
#define warp_map_x 0
#define warp_map_y 1
#define warp_x_sprite 2
#define warp_y_sprite 3
// to warp
#define warp_to_ow 4
#define warp_to_rset 5
#define warp_to_map_x 6
#define warp_to_map_y 7
#define warp_to_sprite_x 8
#define warp_to_sprite_y 9
#define warp_world_check 10

*/


/*
		in the warper ext file, you will pass in the sprite loc in the array.  the warper, 
		then will determine what low and high stats to set it to based upon that sprite location.
		the addition to this was b/c i kept on passing in the wrong coordinates and realized that 
		everything was always the same, based off the floor sprite location.  since this was the
		case, i went ahead and did modifications in order to make sure all i had to do, was to 
		pass in the sprite location in the array and it would figure out everything else for me
		automatically.
		
*/
extern int slowdown;
int warper(int dir)
{
	// warp 16/9
//=======================================================================================
/*

			this will test to see if there is a place to warp in the warp section first.
			the order is very important.  first check the "sl" for warps in order to bypass
			the other built in warps, b/c you might want to override the regular room moving
			system.
			
			first check warper, then world map for out of bounds then the room for out of bounds.

*/
//=======================================================================================

/*
old warper areas.

			//x > y v
			// x sprite modifications
			if (warp[i][warp_x_sprite]==8){x_low=8*16-4;x_high=9*16-4; }
			else if (warp[i][warp_x_sprite]==1){x_low=16-4;x_high=2*16-6; }
			else if (warp[i][warp_x_sprite]<=0){x_low=(-16); x_high=0;}// at -8 the scroll room takes effect
			else {x_low=(warp[i][warp_x_sprite]*16)-4; x_high=(warp[i][warp_x_sprite]*16)+18;} 
			
			// y sprite modifications
			if (warp[i][warp_y_sprite]>=7){
					y_low=(warp[i][warp_y_sprite]*16);y_high=(warp[i][warp_y_sprite]*16)+12; 
			}else{y_low=(warp[i][warp_y_sprite]*16)-8;y_high=(warp[i][warp_y_sprite]*16)+2;}
			
			// keep theis below, so it can overwirte the default values if it needs to.
			// x mods based off of y		
			if ((warp[i][warp_y_sprite]<=0))// || (warp[i][warp_y_sprite]>=7)
			// if the warp is at the left or right, then widen the x planes
			{x_low=(warp[i][warp_x_sprite]*16)-6;x_high=((warp[i][warp_x_sprite]+1)*16)+6; }	

*/

	int i=0;//,w=0,q=0;
	int x=link_stat(map_x);
	int y=link_stat(map_y);
	int y_low=0, y_high=0, x_low=0, x_high=0;
//	char e1[70];
	while (i<warp_points)
	{
		// below is a failsafe against the transition freezing, like it used to.
	
//printf_xy(0,80,"i=%i", warp[i][warp_world_check] );slow(15000);
		if ((warp[i][warp_map_x]==x) && (warp[i][warp_map_y]==y) && (warp[i][warp_world_check]==oob()))
		{
			
			//x > y v
			// x sprite modifications
		//	if (warp[i][warp_x_sprite]==8){x_low=8*16-2;x_high=9*16-4; }
		//	else if (warp[i][warp_x_sprite]==1){x_low=16-4;x_high=2*16-6; }
			if (warp[i][warp_x_sprite]<=0){x_low=(-16); x_high=0;}// at -8 the scroll room takes effect
			else {x_low=(warp[i][warp_x_sprite]*16)+2; x_high=(warp[i][warp_x_sprite]*16)+14;}// make a little square inside the sprite. 
			
			// y sprite modifications
		//	if (warp[i][warp_y_sprite]>=7){
		//			y_low=(warp[i][warp_y_sprite]*16);y_high=(warp[i][warp_y_sprite]*16)+12; 
		//	}else{y_low=(warp[i][warp_y_sprite]*16)+2;y_high=(warp[i][warp_y_sprite]*16)+14;}
			y_low=(warp[i][warp_y_sprite]*16)+2;y_high=(warp[i][warp_y_sprite]*16)+14;
			// keep theis below, so it can overwirte the default values if it needs to.
			// x mods based off of y		
			if ((warp[i][warp_y_sprite]<=0))// || (warp[i][warp_y_sprite]>=7)
			// if the warp is at the left or right, then widen the x planes
			{x_low=(warp[i][warp_x_sprite]*16);x_high=((warp[i][warp_x_sprite]+1)*16); }			
	//sprintf(e1,	" xl=%i xh=%i, yl=%i yh=%i", x_low, x_high, y_low, y_high);
	//	add_print(0,80,e1);slow(20000);	
//	disp_error(e1);slow(20000);		
//printf(" xl=%i xh=%i, yl=%i yh=%i", x_low, x_high, y_low, y_high);slow(20000);		
			
			if ( ((link_x+8)>=x_low) && ((link_x+8)<=x_high) && ((link_y+8)>=y_low) && ((link_y+8)<=y_high) ) 
					 {
					  if (g_transistion_active()==0){s_transistion_active(1);s_transistion(0);}else{
						  if (warp[i][warp_to_ow]!=same_map){
							  if ((warp[i][warp_to_map]!=oob()) && (link_stat(ow_id)!=warp[i][warp_to_ow])) {
											if (!pull_new_map(warp[i][warp_to_ow], warp[i][warp_to_map])){disp_error("Failed to load map.");}
							 	 }// end if not current rset and not current ow
							 	 else if ((warp[i][warp_to_map]!=oob()) && (link_stat(ow_id)==warp[i][warp_to_ow])) {
							 	 		if (!get_world_map(warp[i][warp_to_map])){disp_error("Failed to load map.");}
							 	 }// end else if
					 	 }// end if not same map
					 	 
					 //	 else if (warp[i][warp_to_map]!=current_rset()){set_rset(warp[i][warp_to_rset]);}
					 	 
					 	 		link_x=(warp[i][warp_to_sprite_x]*16);
					 	 		link_y=(warp[i][warp_to_sprite_y]*16);
					 	 		//sword_set(link_x, link_y, 14, 14);// force the sword to redo its location to prevent
					 	 		// it from magically killing mobs via its last position.
					 	 		// that would look right 
					 	 		
					 	 		set_inv_xy();
					 	 		mod_link(map_x, warp[i][warp_to_map_x],TRUE);
					 	 		mod_link(map_y, warp[i][warp_to_map_y],TRUE);
					 	 		get_map_vars();
					 	 	//	load_rooms();
								return TRUE;
								}
					 }// end if link is iin the range of the warp.
		}// end if we are in the current room
		i++;
	}// end while
//	room #, x_low, x_high, y_low, y_high, new world, new world_x, new world_y, new x, new y,

//=======================================================================================
/*
				this will check to see if the world map is out of bounds
*/
//=======================================================================================


/*



info on world[][]

[8][0]->[8][4] will hold the up info if you go out of bounds of the map
[9][0]->[9][4] will hold the down info if you go out of bounds of the map
[10][0]->[10][4] will hold the left info if you go out of bounds of the map
[11][0]->[11][4] will hold the right info if you go out of bounds of the map
for example, look at the following code for more info:

					
					
						//next_world_map(g_world(8,0);}
						//if (g_world(8,1)!=555){link_x=g_world(8,1);}
						//if (g_world(8,2)!=555){link_y=g_world(8,2);}
						//if (g_world(8,3)!=555){rmap_x=g_world(8,3);}
						//if (g_world(8,4)!=555){rmap_y=g_world(8,4);}

[8][5] will hold the current dungeon number
[11][7] will hold the gfx file needed. 						

*/
	/*
this section simply just attemptes to load another world[][], but since it is already gone, it is no longer needed.
	
			switch (dir)
			{
				case up:		i=8;	break;
				case down:	i=9;	break;
				case left:	i=10;	break;
				case right:	i=11;	break;
				
			}
			int moved=FALSE;
		if (g_world(i,0)>0){
				if (g_world(i,0)!=current_world) {next_world_map(g_world(i,0));moved=TRUE;}
				if (g_world(i,1)!=555){link_x=g_world(i,1);moved=TRUE;}
				if (g_world(i,2)!=555){link_y=g_world(i,2);moved=TRUE;}
				if (g_world(i,3)!=555){mod_link(map_x,g_world(i,3),TRUE);moved=TRUE;}
				if (g_world(i,4)!=555){mod_link(map_y,g_world(i,4),TRUE);moved=TRUE;}
			
				if (moved){repop=0;load_rooms();return TRUE;}
			}*/
//=======================================================================================
/*
				this will check to see if the rooms are out of bounds
*/
//=======================================================================================
				/*int ds=link_stat(dual_state),exec=FALSE;
				switch (dir)
				{
					case up:
							if (link_y-link_speed < link_y_min_oob){
								if ((ds==LINK_REEL_BACK) || (ds==LINK_REEL_BACK_NO_DAMAGE))
										{link_y=link_y_min_oob+4;}else{exec=TRUE;}
							}
					break;
					case down:
							if (link_y+link_speed > link_y_max_oob){
								if ((ds==LINK_REEL_BACK) || (ds==LINK_REEL_BACK_NO_DAMAGE))
										{link_y=link_y_max_oob-4;}else{exec=TRUE;}
								
							}
					break;					
					case left:
							if (link_x-link_speed < link_x_min_oob){
								if ((ds==LINK_REEL_BACK) || (ds==LINK_REEL_BACK_NO_DAMAGE))
										{link_x=link_x_min_oob+4;}else{exec=TRUE;}
							
							}
					break;
					case right:
							if (link_x+link_speed > link_x_max_oob){
								if ((ds==LINK_REEL_BACK) || (ds==LINK_REEL_BACK_NO_DAMAGE))
										{link_x=link_x_max_oob-4;}else{exec=TRUE;}
								
							}
					break;
				}// end switch*/
			/*	this setup takes less space, but you get errors from hell if you do this	
				if ((link_x+link_speed > link_x_max_oob) || (link_x-link_speed < link_x_min_oob) ||
					 (link_y+link_speed > link_y_max_oob) || (link_y-link_speed < link_y_min_oob))
					 {scroll_room(dir); return TRUE;}*/
				//	if (exec){scroll_room(dir); return TRUE;}
				if (link_y-link_speed < link_y_min_oob && dir==up)		{scroll_room(up);return TRUE;}
				if (link_y+link_speed > link_y_max_oob && dir==down)	{scroll_room(down);return TRUE;}
				if (link_x-link_speed < link_x_min_oob && dir==left)	{scroll_room(left);return TRUE;}
				if (link_x+link_speed > link_x_max_oob && dir==right)	{scroll_room(right);return TRUE;}
				if ((g_transistion_active()>=3) && (g_transistion()==50) && (i>=warp_points))	
						{s_transistion_active(0);s_transistion(0);we_transistion=FALSE;slowdown=link_stat(save_speed_limiter);}
	return FALSE;
	
}// end warper
/*
void door_scan()
{
		int i,k,mb=get_room_info(mobs_killed);
		for (i=0; i<8; i++)
		for (k=0; k<10; k++)
		{
			switch (get_room_maps(i,k))
			{
				case 166 ... 169:
					if (mb)// if the mobs are all dead, then remove the locked doors.
							{
								set_room_maps(i,k, get_room_info(base_sprite));
							}
				break;			
			}// end switch
			if ((i>0) && (i<7)){k+=8;}
			
		}
}// end door scan
*/
void room_object_adder()
{// this will add objects to the room, like rocks, doors, pots, etc.
// it will also open doors if all the mobs are dead.
// if you have to do any room scans and then replacements, then always use this.
// first scan
// if find object x->y, set_room()add object(); - actually, if you lift the object, then it should
// replace it with base_sprite, otherwise all of teh rocks will dissappear with the above idea.
		int i,k,item;
		
	//	int x=rmapx();
	//	int y=rmapy();
	//	if ((get_room_info(rmapx(),rmapy(),torches_lit)<=0) || 
	//	(get_room_info(rmapx(),rmapy(),torches_lit)< get_room_info(rmapx(),rmapy(),torches_to_be_lit))){
		int dk=get_room_info(room_dark);
		set_room_info(torches_lit,0);
//		}// end if torches not lit or torches < number of torches to be lit.
		set_room_info(torches_to_be_lit,dk);
	//	if (get_room_info(mobs_killed)){door_scan();}// if all the mobs are dead, then scan the room to open the doors.
		
		int ts=0;
	//	int mb=get_room_info(mobs_killed);// this will be used later just in case of a door
		for (i=0; i<8; i++)
		for (k=0; k<10; k++)
			{
			//	printf("%i, ",get_room_maps(x,y,i,k));
				switch (get_all_maps(rmapx, rmapy,i,k))
				{
					case 500://175:
					//	int add_object(short obj_num, short obj_x, short object_y, int item)
						add_object(item_rock,k*16, i*16,item_rock);
					break;
					case 501://195
						add_object(item_pot,k*16, i*16,item_pot);
					break;
					case 502:
						item=add_object(item_push_stone,k*16, i*16,item_push_stone);
						set_object(item, obj_dir, -66);
						set_object(item, obj_var1, 0);
						set_object(item, obj_frame, 10);// set the frame high so i can access it.
					break;
					case 503://spike
						add_object(item_spike,k*16, i*16,item_spike);
					//	set_object(item, obj_type, spike);
					break;
					case 504://toggle switch
						add_object(item_toggle_switch,k*16, i*16,item_toggle_switch);
					break;					
					case 58:
				//	printf("in here %i",dark_room);
						if ((dk) && (get_room_info(room_lit)==FALSE)){
							
						ts++;
						set_room_info(torches_to_be_lit,ts)	;
					//	if (get_room_info(rmapx(),rmapy(),torches_lit)< get_room_info(rmapx(),rmapy(),torches_to_be_lit))
						add_object(item_light_torch,k*16, i*16,item_light_torch); 
						
						}
					//	wait_for_key(b_ko);
					break;//room_entry_x=0,room_entry_y
					//case 82 ... 169: - rill bad idea
			/*		case 166 ... 169:// this will check for the doors and then unlock them if the mobs are all dead
						if ((gter(link_x)<=1)  && (k<=1)){link_x+=10;}// move link in the event that there is a door and he
						if ((gter(link_x)>=8)  && (k>=8)){link_x-=10;}// is standing on it.  this will prevent link from
						if ((gter(link_y)<=1)  && (i<=1)){link_y+=10;}// getting stuck.
						if ((gter(link_y)>=6)  && (i>=6)){link_y-=10;}
						room_entry_x=link_x;// this is needed, b/c it sets the entry point past the door, so you dont get stuck in it.
						room_entry_y=link_y;
						//the room_entry_x/y is for the perm doors, so if you fall in a hole, you are still stuck in the room.
					//	if (mb)// if the mobs are all dead, then remove the locked doors.
					//	{
					//		set_room_maps(i,k, get_room_info(base_sprite));
					//	}
					break;//*/
				}// end switch
			}// end for
		//	wait_for_key(b_ko);
		

		if (get_room_info(room_lit)){dark_room=FALSE;}
			
}// end room object adder

/*
		oob checks to see if link is out of bounds (oob) of the world[][] section of the overworld (ow) array.
		each world[][] section is 2x2 in size.  the overworld array is 4x4 in size.  
		this will return the current world number
		
		nope - this will return which element in the overworld array to look at. 

*/

void dont_get_stuck()
{
		mod_link(inv_link_speed,0, TRUE);// do this, so we know that we can move in our current x/y pos
		set_inv_xy(); // set it so we know we are in the right room.
	
//printf("\n\n\na.");	
		int w=can_move(LINK, link_direction), q=0, m=0, i=0;
		mod_link(inv_link_speed,4, TRUE);// set it back to normal to prevent issues
		if (w==TRUE){goto end;}
		else if (w==FALSE)
		{
//printf("b");
			char arr[12]={10, 0,   0, 10,  10, -10,
										0, 10, -10, 10, -10,  0};// loop through this to see if we can move in these directions in
										// attempt to fix the alignment of link.
							
				switch (link_direction)
				{// switch out the locations of the array to check
					case up: 		i=6;q=0;m=(-1);		break;
					case down:	i=6;q=0;m=1;			break;
					case left:	i=0;q=6;m=(-1);		break;
					case right:	i=0;q=6;m=1;			break;
				}// end switch

			w=0;
			
			st:
//printf("c");
				mod_link(inv_link_x, arr[i+w]*m, FALSE);
				mod_link(inv_link_y, arr[q+w]*m, FALSE);								
										
				if (can_move(LINK, link_direction)){
//printf("d");
					room_entry_x=(link_x+=(arr[i+w]*m));
					room_entry_y=(link_y+=(arr[q+w]*m));
						
					goto end;}
				else {w++;set_inv_xy();printf("e");}
				if (w>5){goto end;}
			goto st;
		}// end else	
		end:
	//	printf("q");
}// end dont get stuck

int set_oob(int world)
{
	
	if ((world=world_loc(world))==555){return 555;}
	int x=0,y=0;
	switch (world)
	{
		case 1: y=2; break;
		case 2: x=2; break;
		case 3: x=y=2; break;
	}// end switch
	mod_link(ow_x, x, TRUE);
	mod_link(ow_y, y, TRUE);
	return TRUE;
}

int boo(int x, int y)
{
		if ((x<2) && (y<2)) {return 0;}
		if ((x<2) && (y>=2)) {return 1;}
		if ((x>=2) && (y<2)) {return 2;} 
		if ((x>=2) && (y>=2)) {return 3;}	
		return -6666;
}// the reverse of oob

int oob()
{
			
	//	int x=link_stat(ow_x);
	//	int y=link_stat(ow_y);
	//	int i=0;

		
	//	if ((x<2) && (y<2)) {i=0;}
	//	if ((x<2) && (y>=2)) {i=1;}
	//	if ((x>=2) && (y<2)) {i=2;} 
	//	if ((x>=2) && (y>=2)) {i=3;} 

		return g_over_world(overworld_map_nums,boo(link_stat(ow_x),link_stat(ow_y)));
		
	//	return -6666;
}// end of oob

/*
		this will find the coords for the rset.
*/
void set_rset(int rset)
{
	int i=0,k=0;
	for (i=0;i<4;i++){for (k=0;k<4;k++){
		if (g_over_world(i,k)==rset){
			mod_link(ow_x, i, TRUE);
			mod_link(ow_y, k, TRUE);
			return;
		}// end if
	}}
}


int current_rset()
{// this will need to be redesigned.
	return g_over_world(link_stat(ow_x),link_stat(ow_y));
	//return 0;
}// end current room

void oob_reel_chk()
{

		if (link_y <= link_y_min_oob){link_y=link_y_min_oob+4;}				
		else if (link_y >= link_y_max_oob){link_y=link_y_max_oob-4;}				
		else if (link_x <= link_x_min_oob){link_x=link_x_min_oob+4;}					
		else if (link_x >= link_x_max_oob){link_x=link_x_max_oob-4;}
		set_inv_xy();

}