// C Source File
// Created 2/3/2013; 5:10:22 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"

int chk_num(int num)
{// this just checks to see if the number is out of my bounds
	if (num<(-32000)){num=(-32000);}
	if (num>32000){num=32000;}
	return num;
}// end check num
/*
		the projectile list is an object_list[][] that has less stats.  it is used for the mob
		projectiles.  this allows me to save space, b/c the mob projectiles need less than
		half the stats as the main objects.  mob objects start out at 9000+

*/

int proj_list[max_projectiles_size][max_projectiles_stats];//  188 bytes.
int item_list[max_list_size][max_item_stats];

inline int get_proj_list(int a, int b)
{

	b-=20;// this is the current offset of the defines. - defining here prevents me from having to 
	// declair it everywhere.
	if ((a<0) || (b<0) || (a>=max_projectiles_size) || (b>=max_projectiles_stats)) {return -6666;}
	return proj_list[a][b];
}// end get proj_list

inline void set_proj_list(int a, int b, int num)
{
	b-=20;// this is the current offset of the defines.
	if ((a<0) || (b<0) || (a>=max_projectiles_size) || (b>=max_projectiles_stats)) {return;}
	proj_list[a][b]=chk_num(num);
}// end set proj_list
/*
#define proj_id 20
#define proj_pic_id 21
#define proj_damage 22
#define proj_H 23
#define proj_W 24
max_item_stats 11
*/
//============================================================================================


int get_item(int a, int b)
{
	
	if (b>=20){return get_proj_list(a, b);}// so i can use the same routines for the proj_list
	if ((a<0) || (b<0) || (a>=max_list_size) || (b>=max_item_stats)){return -6666;}
	return item_list[a][b];
}// end get item

//============================================================================================


void set_item(int a, int b, int num)
{
	if (b>=20){set_proj_list(a, b, num);return;}
	if ((a<0) || (b<0) || (a>=max_list_size) || (b>=max_item_stats)){	return;	}
   item_list[a][b]=chk_num(num);
}// end get item

//============================================================================================




int item_loc(int item)
{
	int i=0,a=max_list_size,b=item_id;
	if (item>=projectile_offset){a=max_projectiles_size;b=proj_id;}
	for(i=0;i<a;i++){if (item==get_item(i,b)){return i;}}
	
//	else{
//		while (i<max_list_size){if (item==get_item(i,item_id)){return i;}i++;}// end while
//	}
	return 555;// item not found.
}// end item loc

//=================================================================================================

int item_to_proj(int stat)
{
	switch (stat)
	{
		case item_id: 		return proj_id; 		break;
		case item_pic_id: return proj_pic_id; break;
		case item_damage: return proj_damage; break;
		case item_H:			return proj_H;			break;
		case item_W:			return proj_W;			break;
		case item_type: 	return proj_type;		break;// the item type is a constant MOB_DAMAGER
	}
	return 0;
}

//=================================================================================================


int get_item_info(int item,int stat)
{
	int i=0;
	if (item>=projectile_offset){stat=item_to_proj(stat);}
	if ((i=item_loc(item))<max_list_size){	return get_item(i,stat);}

	// max_list_size should be larger than the max_projectiles_size.
	return 0;// no stat.  best to default it to 0
}// end get item stat

//============================================================================================
/*int type_in_bag(int type, int max, int which)
{
	int i=0;
	for (i=0;i<max;i++){
			if (type==get_item_info(g_inv(1,i),item_type))
			{
				switch (which){
					case 1: return TRUE; break;
					case 2: return g_inv(1,i); break;
					case 3: return i; break;
					default: return TRUE; break;
				}// end switch
			}// end if
	}// end for		
	if (which==1){return FALSE;}else {return 555;}
}// end type in bag


int type_holding(int type,int which)
{
	int i=hold_a;
	for (i=hold_a;i<hold_d;i++){
			if (type==get_item_info(link_stat(i),item_type))
			{
				switch (which){
					case 1: return TRUE; break;
					case 2: return link_stat(i); break;
					case 3: return i; break;
					default: return TRUE; break;
				}// end switch
			}// end if
	}// end for		
	if (which==1){return FALSE;}else {return 555;}
}// end typeholding 
*/
int item_type_exists( int type, int where)
{//65253
	// where can be for the inventory or held.
	// search through the inventory/ held for get_item_info(inv(ixxX), item_type)==type.  if so, then return true
	// this is to let me know if i have the bow or bombs or any other random item type like shield equipped.
	int i=0,i_max=0;
	
	switch (where)
	{
		case hold:
		//	return type_holding(type, 1);
					i=hold_a;
			while (i<=hold_c){	if (type==get_item_info(link_stat(i),item_type)){return TRUE;}i++;}
		break;
		case bag:
		case 4:
			i=0;i_max=12;
			if (where==4){i=12;i_max=inv_cols;}// added so i can check the external inventory.
		//	return type_in_bag(type, i_max, 1);
			while (i<i_max){	if (type==get_item_info(g_inv(1,i),item_type)){return TRUE;}i++;}
			
		break;
		case 3: // this will find the exact location of that item and return the item number
		// it checks both the inventory and the hold.  although it may take a little more
		// ram, it does allow for the item number to be whatever i choose as long as the item
		// type is whatever.  - this is designed for infinity.
			i=0;//i_max=12;
			//if (where==4){i=12;i_max=30;}// added so i can check the external inventory.
			while (i<12){	if (type==get_item_info(g_inv(1,i),item_type)){return g_inv(1,i);}i++;}
	//	  if ((i=type_in_bag(type, 12, 2))!=555){return i;}
		//  if ((i=type_holding(type, 2))!=555){return i;}
			i=hold_a;
		
			while (i<=hold_c){	if (type==get_item_info(link_stat(i),item_type)){return link_stat(i);}i++;}
		break;
		case either:
			i=hold_a;
			while (i<=hold_c){	if (type==get_item_info(link_stat(i),item_type)){return TRUE;}i++;}
			i=0;
		//	if (type_holding(type, 1)){return TRUE;}
		//	return type_in_bag(type, 12, 1);
			while (i<12){	if (type==get_item_info(g_inv(1,i),item_type)){return TRUE;}i++;}
		break;
	//	case 8:// to test whether a container item holds something or not.
		//	i=type_in_bag(bottle, 12, 2);
		//	if ((i!=555) &&  (item_amt(i, 0)==type)){return i;}
			//while (i<12){	if (bottle==get_item_info(g_inv(1,i),item_type)){return g_inv(1,i);}i++;}
	//	break;
	//	case 8 ... 9:// returns the item that is holding the object
	//		if (where ==9){i=type_holding(type, 2);}else{i=type_in_bag(bottle, 12, 2);}
	//		if ((i!=555) &&  (item_amt(i, 0)==type)){return i;}
				//	i=hold_a;
			//while (i<=hold_d){	if ((bottle==get_item_info(link_stat(i),item_type)) && (link_stat(i+18)==type)){return link_stat(i);}i++;}
	//	break;	
	}

	return FALSE;
}//end item type extists
//============================================================================================

int quest_loc(int type, int num)
{
// gets the location of the quest item and type.
		int i=type*10, maxer=10+(type*10);
	while (i<maxer){if (g_inv(4,i)==num){return i;}	i++;}// end while
	return 555;
}

//============================================================================================


void add_quest(int type, int num)
{// this just adds a quest item
	if (!quest_exists(type,num))
	{
		if (quest_loc(type,0)!=555){s_inv(4,quest_loc(type,0),num);}// end if there exists a spot
	}// end if it doesnt already exist
}// end add quest.

//============================================================================================


int quest_exists(int type, int num)
{
	// this will just loop through to see if the dungeon map of the specified #
	// exists or not.
	//	[4]	level info: 0>9 (maps)***, 10>19 (compasses)***, 20>29 (triforce/ dungeon complete)***
	
	
	int i=type*10, maxer=10+(type*10);
	while (i<maxer){if (g_inv(4,i)==num){return TRUE;}i++;}// end while
	return FALSE;
}// end dung map exists.
//============================================================================================

