// C Source File
// Created 10/11/2012; 1:32:48 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"
char bb[6]={'0','0','0','0','0','\0'};

extern unsigned short gfx_light[gfx_list_size][16], link_pic_mask[4][link_gfx_size][16];
extern unsigned short object_pic_mask[object_gfx_size][16];
extern char *light2;                         //Pointer to virtual light plane
extern char *dark2; 

//============================================================================================
//*

int collide(int x, int x_w, int y, int y_h, int a, int a_w, int b, int b_h)
{// x/y is for the object flying into the a/b object
// _w stands for width. _h is for height
// the normal collission detection attempts to find out if 2 boxes are inside of each other.
// however, this requires either math or multiple checks to check each corner.
// this routine, however, looks to see if they are not touching, by checking only 4 things.
// first get the coordiantes of the width and height by adding current x/y loc to the width and height.
// then do checks to see if the total width/height is outside the x/y coord for each box.
// you can only have 1 of 4 positions where something does not exist inside of a box: to the up, down, left or right.
// if even one part of that box is outside, then it is NOT touching.  so only one if statment is needed to see if
// 2 objects of different height and width are colliding.
// compliments to Jesus himself.  I asked for the way to do it the easiest way and he showed me and this is the result:

	a_w+=a;// this will set up the width to be the total size of the objects
	b_h+=b; x_w+=x; y_h+=y;
	// the -1 allows for a 1 extra pixel entry before it collides.
	// this is different b/c it tests to see if it is out of bounds instead of in bounds.
	if ((x_w-1<a) || (a_w-1<x) || (y_h-1<b) || (b_h-1<y)){return FALSE;}
	return TRUE;// this routine is nearly perfect.  and it has less checks.
	
	
}// end collide



//============================================================================================
//*
int chk_special_move(int type, int num)
{// made for those special situations so things like the raft can work.
	switch (type)
	{
		case LINK:
			if ((num>=54) && (num<=57)){ 
				if (item_type_exists(raft,4)){return TRUE;}
			return FALSE;}
		//	else {return 555;}
		break;
		case MOB:
			if ((num>=54) && (num<=57)){ 
			// if type aquadic_monsiter {return TRUE;}
				
			return FALSE;}
		break;
	}// end switch
	return 555;
}
//============================================================================================
void slow(int time)
{
	int count1, count2;

	for (count1=0;count1<=time;count1++){for (count2=0;count2<=time-2;count2++){count1--;}}
	
}// end pauser

//============================================================================================


//64459 -> 64607

/*
			the positioner and movable() system info:
			
			i asked God to show me how to do this, and then he gave me the info for it.
						
			the 3 routines below: (positioner(), movable(), touching_sprite()) are all part of a single
			system that attempts to detect if you are touching a sprite.  This system i call the triangulation
			detection system.  movable() and touching_sprite() both use the positioner() routine.  however, the
			positioner routine needed to pass back 6 different variables... in order to do this, it simply sets
			the values of 6 global varbials:
			(int posit_x=0, posit_y=0, posit_x2=0, posit_y2=0, posit_dual_check_x=0, posit_dual_check_y=0;)
			
			what it does is divide the current position of link_x and link_y by 16.  this gives the relative sprite
			that link exists in.  then it checks to see how far into the sprite it is.  First it will check to see
			how far left or right it is into that first sprite.  if it is not far enough in, then it will set the 
			appropriate value to look at the sprite to the right of it.  if link has enough pixels in both the left 
			and right sprite, then both are checked.
			
			then it will check the y values of link.  if link doesnt have enough pixels in the original sprite
			(which is always the top one), then it will set it to check the bottom sprite.  if it has enough pixels
			in both sprites, then it will check both sprite.  
			
			the x and y coordiantes are checked separatly.  this ensures that (up to) a total of 3 different sprites are 
			checked to see if there is a collision.  the original system attempted to get the best location of link
			and then guess in attempt to check if he was in a single sprite.  only 1 sprite was checked in the old system.  
			this led to odd issues with link not being able to move or getting stuck where he should be able to walk.
			
			originally, the triangulation checker checked up to 4 sprites, but this led to link getting stuck in 
			places he should not get suck it.  i found it was because (in the grid of):
			
			ab
			cd
			
			, d always had a couple of pixels in it.  then d was a non movable sprite.  thus, it signaled that link
			could not move.  however, when the checking for d was removed, it allowed link to move like he should.  you
			would think that you would need to check D to prevent him from walking on a non movable sprite, but in reality,
			once he gets far enough over into that sprite, it prevents him from moving.  the triangulation detection system 
			does not check in the same pattern.  it's detection is split up into groups, so the 3 sprites that are checked 
			can cange in direction.  for example:
			
			with the squares of:  a b :    a b    or   a b   or  	  b  	  or  a    or  a b   or  a   or  b    or 	      or a 
														c d,:      d				 c					c d				  c d	  	           d	 		 c			 	c d
														
														
			are all checked, depending on the position of link.  that is the flexability of this detection system.
			thus the triangulation detection system was born.
			
			

*/
//int ycheck(int y){if (y<0){y=0;} if (y>7){y=7;}return y;}
//int xcheck(int y){if (y<0){y=0;} if (y>9){y=9;}return y;}

//============================================================================================



int posit_x=0, posit_y=0, posit_x2=0, posit_y2=0, posit_dual_check_x=0, posit_dual_check_y=0;

//============================================================================================


void positioner(int x,int y)
{
	int a=0, b=0;
	posit_x=0; posit_y=0; posit_x2=0; posit_y2=0; posit_dual_check_x=0; posit_dual_check_y=0;// failsafe so they dont retain values
	
	a=x-(gter(x)*16);
	b=y-(gter(y)*16);// get the offset of pixels from the movable sprite from the permanent sprite location
// the below condition set is redesigned to allow a closer walk to the sides.

	if (a<=6){posit_x=gter(x);} // how far left into the sprite it is - dont go below 2 and probably not above 6
	else if (a>=10){posit_x=gter(x)+1;} // how far right into the sprite it is - dont go above 14 and probably not below 10
	else if ((a<10) && (a>6)) // this is in between 2 sprites.  - only change this if you change one of the above 2 numbers
	{// it is best that if you change both of the numbers above at the same time and by the same amount.  
		posit_x=gter(x);
		posit_x2=gter(x)+1;
		posit_dual_check_x=1;
	}// end  if ((x<12) && (x>4))	
	
/* this condition set below is near perfect. 	
	if (a<=4){posit_x=gter(x);}
	else if (a>=12){posit_x=gter(x)+1;}
	else if ((a<12) && (a>4))
	{
		posit_x=gter(x);
		posit_x2=gter(x)+1;
		posit_dual_check_x=1;
	}// end  if ((x<12) && (x>4))*/
	
	if (b>=8){posit_y=gter(y)+1;}  // this tells how far up into a sprite you can travel (that you could not move on normally)
	// dont adjust above 8 and not below 2.  8 makes link look like he is standing up against the wall.
	else if (b<=4){posit_y=gter(y);}// this tells how far down on an object you can stand.  if you go above 4, then it will 
	// look like link is standing on an object.  if you take it down to 0, then link will never touch the sprite, but it will
	// make it difficult move
	else if ((b>4) && (b<8))// this says that you are touching both sprites.  change only when you change the above numbers
	{// these numbers can be changed independantly, b/c it makes you look like you are standing on or next to something.
		posit_y=gter(y);
		posit_y2=gter(y)+1;
		posit_dual_check_y=1;
	}// end if ((b>4) && (b<8))
	// remember that this is in the format of x <-> and y is up/down, so you will do g_all_maps(y,x) instead of (x,y)
	// however, the x,y that is passed in will be (link_x, link_y)
}


//============================================================================================


int movable(int who, int dir, int type)
{// this will do terrain collission detection
// who is for the id.  type is for link, mob, or object - new defines will need to be made for this. - well maybe not
// dir is for the direction they are attempting to go.



#define mv_list_size 12// this is a list of ranges in groups of 2: (low sprite, high sprite)
// it will check to see if link is standing on one of those numbers and if so, then it will let link move.
int mv_list[mv_list_size]={0,49,502,502, 0, 0, 66,81, 170,174, 66, 78};//for default

int lx=3, ly=3;

//a=gter(lx);// first truncate it to the nearest 16th
//b=gter(ly);
int i=0,speed=0, a=0, good=FALSE;


// the below allows for a 4 pixel x pos on any sprite to the left or right regardless of any sprite type
// it will adjust the map_x/y based upon the position of link.
// be sure to calculate the x/y seperatly, so 2 switch statements.  if you combine the switch statements, then
// you will create a situation where the x pos is calculated, but the ypos isnt; therefore, you just move funny.
// this will give it a more precise moving calculations by getting exact locations and comparing it to the sprites.
// it is similar to precision_move()

if (type==LINK)
{
//{0,49,502,502, 54, 57, 81,66, 170,174, 0, 0};// dont let link move on 66->78 for now 
//	mv_list[10]=0; - not needed really, b/c you alread have the range of 66->81, which covers the mob movement.
//	mv_list[11]=0;
	speed=link_stat(inv_link_speed);
	lx=link_stat(inv_link_x);// get link_x
	ly=link_stat(inv_link_y);// get link_y
//	positioner(link_stat(inv_link_x),link_stat(inv_link_y));
}
else if (type==MOB)
{
//	{0,49,502,502, 54, 57, 81,66, 170,174, 66, 78}; - 502 - 54, 170, 66->81
		
		i=get_mob_stat(who,mob_type);
		if ((i==flyer) || (i==wizard) || (i==evil_eye) || (get_mob_stat(who,mob_underground)>=3))
				{	return TRUE; }// special things only for a mob
	
	
	i=2;
	while (i<10){mv_list[i]=0;i++;}// mod the move list to remove sprites that you dont want
	// the mobs to walk on.
	lx=get_mob_stat(who,mob_x);
	ly=get_mob_stat(who,mob_y);
	speed=get_mob_stat(who,mob_speed);
}
//*/
switch (dir)
{
// this will make it look like link has already moved.  if the collide checker (below) sees that he is standing on a 
// movable sprite, then it will allow link (or the mob) to move.  if not, then it will signal to not move.  simply put:
// it is a preemptive move checking system.

	case up: ly-=speed; break;
	case down: ly+=speed; break;
	case left: lx-=speed; break;
	case right: lx+=speed; break;
}// end switch dir




positioner(lx, ly);// get the positions


int x1=posit_x, y1=posit_y, itm=0; // this is so we can keep changing the vars


redo:

	if (y1<0){y1=0;} if (y1>7){y1=7;}
	if (x1<0){x1=0;} if (x1>9){x1=9;}

// below will check to see if you have touched an object or not.

	if ((i=touch_object(x1*16, y1*16, type, 0, TRUE))!=555){

				itm=get_object(i, obj_num);
				switch(itm)
				{
				//	case HEART1: case CRYSTAL1: case BOMB2: case ARROW2: goto cntu; break;
					case 1000 ... 3000:
						itm=get_object(i,obj_type);//get_item_info(itm,item_type);
			
						if (itm==rock || itm==boulder || itm==torch || itm==treasure_box){return FALSE;}
					//	{if (get_object(i,obj_type)!=follow_object){return FALSE;}else {goto cntu;}}// if removed, then you will not be able
						// to move if you are holding an object.
						else if (itm==pushable){return i+100;}
						else {goto cntu;}
					break; 
					case item_hookshot_chain: goto cntu; break;
					case projectile_offset ... (projectile_offset+1000): return TRUE;
				}
				
				return FALSE;
			}
		cntu:
// now check to see if you have touched a bad part of the land you should not walk on.
		
	a=get_all_maps(rmapx, rmapy, y1 , x1);
	if (chk_special_move(type, a)==TRUE){good=TRUE;}
	
	for (i=0;i<mv_list_size;i+=2){// this checks a list of ranges to see if link is standing on one of those sprites.
		

		if ((mv_list[i]<=a) && (mv_list[i+1]>=a)){good=TRUE;}
	}// end while checking if can move.

	
	if ((posit_dual_check_x==1) && (good)){posit_dual_check_x=2; good=FALSE; x1=posit_x2; goto redo;} 
	if ((posit_dual_check_y==1) && (good)){posit_dual_check_y=2; good=FALSE; x1=posit_x; y1=posit_y2;goto redo;} 

	


return good;

	
}// end movable

//=================================================================================================



int touching_sprite_range(int qx, int qy, int sprite_low, int sprite_high, int return_sprite)
{
	// lets you know if you are touching a sprite or not
	// this uses the triagular positioning from above
	
	positioner(qx, qy);// get the positions
	// the basic triangulation checks:
	int x=posit_x;// for safeguard if you check both x and y
	int sprit=0;
	redo:
	sprit=get_all_maps(rmapx, rmapy, posit_y , posit_x);
	if ((sprite_low<=sprit) && (sprite_high>=sprit)){if (return_sprite){return sprit;} else {return TRUE;}}
	if (posit_dual_check_x==1){posit_x=posit_x2; posit_dual_check_x=2; goto redo;}
	if (posit_dual_check_y==1){posit_y=posit_y2; posit_x=x; posit_dual_check_y=2; goto redo;} 

return FALSE;

}// end touch sprite



//============================================================================================



int touching_sprite(int qx, int qy, int sprite){return touching_sprite_range(qx, qy, sprite, sprite, FALSE);}

//=================================================================================================

/*
		set link sprite loc will find the sprite that link is touching and set his x/y coords to it.
		it is used for the hole fall routine.
*/
void set_link_sprite_loc(int qx, int qy, int sprite)
{// this uses positioner() too.  
		positioner(qx, qy);// get the positions
	// the basic triangulation checks:
	if (sprite==get_all_maps(rmapx, rmapy, posit_y , posit_x)){}
	else if ((posit_dual_check_x==1) && (sprite==get_all_maps(rmapx, rmapy, posit_y , posit_x2))){posit_x=posit_x2;}
	else if ((posit_dual_check_y==1) && (sprite==get_all_maps(rmapx, rmapy, posit_y2 , posit_x))){posit_y=posit_y2;} 
	md_link(inv_link_x,posit_x*16, TRUE);
	md_link(inv_link_y,posit_y*16, TRUE);
}




//============================================================================================

int object_stat_flip(int loc, int stat)
{
// in the event that the object is facing either left or right, you will need to flip its
// width and height.
	int dir=get_object(loc,obj_dir);
	if ((dir==left) || (dir==right))
	{
		switch (stat){
//		case obj_x: stat=obj_y; break;  - if you do this, then funny things will happen.
//		case obj_y: stat=obj_x; break; 
		case item_W:   stat=item_H;   break;
		case item_H:	 stat=item_W;   break;
		}// end switch
	}// end if left or right
	
	return get_object(loc,stat);

}


//============================================================================================



int touch_object(int x, int y, int who, int loc, int ret)
{
	/*36992 ->36930 ->37477
			this routine attemts to find out if an object touches link or if
			the boomerang touches the object.
			ret has 4 settings
			if true, then return the id
			if false, then return whether the location has been touched or not.
			if 2, then return item type
			if 4 then scan to see if you touched any object - for movable()
			if 5, then return the item id #
			ret is to return the exact location or not.
	*/
	// if not shield active and link_facing, then tell yes.
	//int x=link_stat(link_x)
	// link_x and link_y already defined.
	
	int a=0,b=0, i=0, obj=0, orig_obj=0;
	switch (who)
	{
		case LINK:
			x++; y++;a=b=14;
		break;
///		case boomerang:
//			a=b=10;x+=2;y+=2;
//		break;
		case MOB:// mob will return any object bening touched.  it will not return a specific object - yet
				a=mob_stat_flip(loc,mob_w);
				b=mob_stat_flip(loc,mob_h);
				x+=offset_calculate(x, a);
				y+=offset_calculate(y, b);		
		loc=0;
				ret=4;
		break;
		case OBJECT:// this will see if am object is being hit by another object or not - mainly for the torches and fire.
		//	ret=4;// search for any object being hit
				a=object_stat_flip(loc,item_W);
				b=object_stat_flip(loc,item_H);
				x=offset_calculate(x, a);
				y=offset_calculate(y, b);
				orig_obj=loc;// store the value of the location of the object so we can compare to make sure it doesnt test itself
				// to see if it is colliding with itself.
		break;
	}

	

if ((ret==TRUE) || (ret==4)){i=0;loc=0;}else {i=obj_list_size-1;}
//collide(int x, int x_w, int y, int y_w, int a, int a_w, int b, int b_w)
	int ox=0,oy=0,ow=0,oh=0, typ=0;// for the object x, y, width, height
	
	while (i<obj_list_size)
	{
		//get_object(loc,item_W)
		
		obj=get_object(loc,obj_num);
		typ=get_object(loc,obj_type);
		if ((who==OBJECT) && (i==orig_obj)){obj=(-4);}// if an object, then make sure it doesnt attempt test collission with itself.
	if ((obj>=0) &&  (typ!=mob_poof) && (typ!=raft) ){
					
				ow=object_stat_flip(loc,item_W);
				oh=object_stat_flip(loc,item_H);
	
				
				ox=offset_calculate(get_object(loc,obj_x), ow);
				oy=offset_calculate(get_object(loc,obj_y), oh);
//==== note: almost all objects in the game are centered, so the following calculations are based off that assumption.				


		if (collide(ox, ow, oy, oh, x,a,y,b))
				{
						if (ret==TRUE){return loc;}//if ((typ==boomerang) || (typ==hookshot))
					//	{}else {return loc;}}
					//	else if (ret==2){return get_object(loc,obj_type);}
						else if ((ret==FALSE) || (ret==4)){return TRUE;}
	//					else if (ret==5){return get_object(loc,obj_num);}
					}// end if collission.
			//	else{if (!ret){return FALSE;}}	
		}// end if object number >=0			
		i++;loc++;
		
		}// end while			

	return 555;
}// end touch object

//============================================================================================


int mob_stat_flip(int who, int stat)
{
	int dir=get_mob_stat(who,mob_dir);
	if ((dir==left) || (dir==right))
	{
		switch (stat){
		case mob_w:   stat=mob_h;   break;
		case mob_h:	 stat=mob_w;   break;
		}// end switch
	}// end if left or right
	
	return get_mob_stat(who,stat);
}

//============================================================================================


/*
			offset calcualte attempts to center the mob/object to the sprite, based off of its height and width.
			for now, it allows for up to a 32 x 32 "item".

*/
int offset_calculate(int xy, int hw)
{// xy == x/y coords - either or
// hw == height/width - either or
	if ((hw>16) && (hw<=32)){xy=xy+((int)((32-hw)/2));}// these are to calculate future 32x32 mobs
	else {xy=xy+((int)((16-hw)/2));}
	return xy;
}

//============================================================================================
int moby_contact(int loc, int x, int w, int y, int h)
{
	if (get_mob_stat(loc,mob_underground)<=0){
				int	ow=mob_stat_flip(loc,mob_w);
				int	oh=mob_stat_flip(loc,mob_h);
					
				int	ox=offset_calculate(get_mob_stat(loc,mob_x), ow);
				int	oy=offset_calculate(get_mob_stat(loc,mob_y), oh);
					
				if (collide(x, w, y, h, ox, ow, oy, oh)){return TRUE;}// end if they do collide
			}	
	return FALSE;
}// end moby contact


int touch_mob(int x, int y, int who)
{
	/*36992 ->36930
			this routines sees if one of the mobs are touching link, if so then return who
	45166 ->45114
	*/
	// if not shield active and link_facing, then tell yes.

	
	int a=13,b=13;
	switch (who)
	{
		case LINK://100
			 a=b=14;x++;y++;
		break;
	//	case boomerang://205
	//		a=b=10;x+=2;y+=2;
	//	break;
		case 0 ... obj_list_size:
			// in the event it is an object, use this
			
				a=object_stat_flip(who,item_W);
				b=object_stat_flip(who,item_H);
				x=offset_calculate(x,a);//x+(int)((16-a)/2);
				y=offset_calculate(y,b);//y+(int)((16-b)/2);

		break;
		case 300 ... 400:// for mobs.  just pass in who+300 for this to work.
				a=mob_stat_flip(who-300,mob_w);
				b=mob_stat_flip(who-300,mob_h);
				x=offset_calculate(x, a);
				y=offset_calculate(y, b);	
		break;
	}// end switch who
	

//	int ox=0,oy=0,ow=0,oh=0;	
	int i=0;
	while (i<max_mobs)
	{
		if ((i+300)==who){i++;}// prevents a mob from seeing that it collides with itself.
		// dont worry about going oob, b/c if oob, then it returns -6666, so the below if will not go off.
		if (get_mob_stat(i,mob_id)>0)
		{//collide(int x, int x_w, int y, int y_w, int a, int a_w, int b, int b_w)

				if (moby_contact(i, x, a, y, b)){return i;}
		/*		ow=mob_stat_flip(i,mob_w);
				oh=mob_stat_flip(i,mob_h);
				
				ox=offset_calculate(get_mob_stat(i,mob_x), ow);
				oy=offset_calculate(get_mob_stat(i,mob_y), oh);
				
			if (collide(x, a, y, b, ox, ow, oy, oh))
				{
			
					if (get_mob_stat(i,mob_underground)<=0){return i;}// if the mob is not underground, then
					// send the location.
				}// end if they do collide*/
		}
		i++;
	}// end while <max_mobs
	return 555;
}// end touch_mob
//============================================================================================


int gter(int y){return (int)(y/16);}

//=================================================================================================

int opposite_dir(int dir)
{// gives the opposite direction
	switch (dir){
		case up: 		return down;
		case down: 	return up;
		case left: 	return right;
		case right: return left;
	}// end switch
	return down;
}


//=================================================================================================

int circle_dir(int dir)
{// gives the new direction  when you want the object to rotate in a circle.
		switch (dir)
	{
	
		case up: 		return left;// up will be the reverse
		case down:	return right;// down will be the reverse of the array
		case left: 	return down;// left will be the reverse
		case right: return up;// will need to be modified w/ pic 8 added, starting
	
//		case up: dir=right;	break;// up will be the reverse
//		case down: dir=left;	break;// down will be the reverse of the array/
//		case left: dir=up;	break;// left will be the reverse
//		case right: dir=down;	break;// will need to be modified w/ pic 8 added, starting
//		default: dir=down; break;
		// with the end of right slash and ending with the end of the down slash
	}// end switch
	return up;
}// end circle dir.

//=================================================================================================


int rotate_dir(int rotate)
{
		switch (rotate)
		{
			
			case rot_90: 	return rot_180;//r
			case rot_180: return rot_270;//d
			case rot_270: return 0;//l			
		}// end switch	
		return rot_90;
}
//=================================================================================================

int rotate_to_dir(int rotate)
{
		switch (rotate)
		{
			
			case rot_90: 	return right;//r
			case rot_180: return down;//d
			case rot_270: return left;//l			
		}// end switch	
		return up;
}
//=================================================================================================

int dir_to_rotate(int dir)
{// pass in a direction that you are facing and it will return the correct direction that a sprite 
// should be rotated.

	switch (dir)
	{
		case upright:
		case up:		return 0;
		case downright:
		case right:	return rot_90;
		case downleft:
		case down:	return rot_180;
		case upleft:
		case left:	return rot_270;
	
		
	}// end switch
	return 0;
}// end dir to rotate*/
//=================================================================================================


int precision_move(int x, int y, int dir, int amt)
{// this just attempts a precision move
//	int a=x,b=y;
	switch (dir)
	{// if the move thinks it is the same sprite then, force it to move one sprite in that direction.
		case up:
			if (gter(y-amt)==gter(y)){y-=16;}
			else {y-=amt;}

		break;
		case down:
			if (gter(y+amt)==gter(y)){y+=16;}
			else {y+=amt;}

		break;
		case left:
			if (gter(x-amt)==gter(x)){x-=16;}
			else {x-=amt;}

		break;
		case right:
			if (gter(x+amt)==gter(x)){x+=16;}
			else {x+=amt;}

		break;
	}// end switch
	
	
	int i=get_all_maps(rmapx, rmapy,gter(y),gter(x));

	if (i>=0 && i<=49){return TRUE;}
	return FALSE;
}// end precision move

//=================================================================================================

int precision_sprite_find(int x, int y, int sprite)// this only works for doors and sprites on the walls.
{// find the sprite in the correct way.
// will return 122 for x+=11
// 100 for -11
// basically, do x+=(precision_sprite()-111); if precision_sprite>=100
// if 200+. then do, y+=
	if (get_all_maps(rmapx, rmapy,gter(y),gter(x))==sprite) {return 0;}// attempt to get the right sprite
						else if (get_all_maps(rmapx, rmapy,gter(y+11),gter(x))==sprite){return 222;}//{y+=11;}
						else if (get_all_maps(rmapx, rmapy,gter(y-11),gter(x))==sprite){return 200;}//{y-=11;}
						else if (get_all_maps(rmapx, rmapy,gter(y),gter(x-11))==sprite){return 100;}//{x-=11;}
						else if (get_all_maps(rmapx, rmapy,gter(y),gter(x+11))==sprite){return 122;}//{x+=11;}
						return 0;	
}// end precision sprite find.
//=================================================================================================


//=================================================================================================

