// C Source File
// Created 7/15/2011; 3:11:25 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                       */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"
#include "start.h"
#include "story_line.h"
#include "dung_maps.h"
/*

17965 -> 17979 -> 17964
		this is the file that will handle link gfx


*/


extern char *light, *dark;
extern int link_speed,link_direction,link_picture, link_x, link_y, link_speed_adjust,room_entry_x,room_entry_y;
extern int   link_frame,sword_charge,keyl, keyr, keyu, keyd,keya,keyb, terminate;//, link_frame2;                    //Keeps track of link's frame #.
int spins=0, spinslash_active=FALSE, disp_hearts=TRUE, heart_x=90, heart_y= -2, hover=0,heart_reverse=TRUE;//item_used=0,
int sword_wait=0;
extern int dark_room,button_pressed,double_damamge,skip_animate_mob, slowdown, we_transistion;
//=================================================================================================


//=================================================================================================


void link_gfx_loader(int id)
{
	char messa[10];
	FolderCur(SYMSTR("gfx"),TRUE);// transfer to the mob filder.
	FILE *q = NULL;
	unsigned short tmp[4][link_gfx_size][16];
	int w=0, x=0, y=0, loop=0;

redo:
	TRY

		q = NULL;

			switch(loop)
			{
				case 0: sprintf(messa,"linkl%i",id); break;
				case 1: sprintf(messa,"linkd%i",id); break;
				case 2: sprintf(messa,"linkm%i",id); break;
			}
    

    if ((q = fopen(messa,"rb")) == NULL) {return;} else {
        if (fread(tmp,sizeof(tmp),1,q) != 1) {return;}else{
        	for (w=0;w<4;w++){
	        	for (x=0;x<link_gfx_size;x++){
	        		for (y=0;y<16;y++){
	        			s_link_pic(w,x,y,tmp[w][x][y],loop+1);
	        		}// 3nd for
	        	}// 2st for
	        }// 1st	for
        }
        fclose(q);
    }
 
 
	ONERR
	ENDTRY     
 
		loop++;
		if (loop<3){goto redo;}
	
}// end link loader
//*/


//=============================================================================================




int dir_to_sprite_xy_modder(int dir, int xy, int sprite)
{
	/*
			this routine will find out how much to add to your current sprite based upon your x/y
			1 is for the x var, 2 is for the y var
	*/
	
	switch (dir)
	{
		case up:		if (xy==1){	return 0;	}	else {return sprite*-1;} 	break;
		case down:	if (xy==1){	return 0;	}	else {return sprite+8;} 	break;
		case left:	if (xy==1){	return sprite*-1;	}	else {return 0;} 	break;
		case right:	if (xy==1){	return sprite+8;	}	else {return 0;} 	break;
		default:	return 0;
	}// end switch dir
	return 0;
}// end dir to sprite xy modder
//=================================================================================================

void sword_display(int area, int deal_damage, int tslash, int draw_type)
{
	if (sword_wait>0){sword_wait--;sword_charge=0;link_state_reset();sword_active(FALSE);return;}
	int x=link_x, y=link_y, rotate=0, pic=get_item_info(item_used(),item_pic_id);
	rotate=dir_to_rotate(area);
	
	switch (area)
	{
		case 8:			x+=3;// to center the up posistion.
		case up: 		y-=16; x-=2;	break;
		case down: 	y+=16; x+=4;	break;
		case left:	x-=16; y+=4;	break;
		case right: x+=16; y+=4;	break;
		
		case upleft:		pic--;	x-=13;y-=13;	break;//x=link_x-13;y=link_y - 13;
		case upright:		pic--;	x+=13;y-=13;	break;
		case downleft:	pic--;	x-=12;y+=14;	rotate=100;break;//x-=12;y+=13; - downsword
		case downright:	pic--;	x+=13;y+=15;	break;

	}
	obj_quickdraw(x, fix_row_gain(y), pic, draw_type, rotate);
	if (deal_damage){sword_active(TRUE);sword_set(x, y, 14, 14);}else {sword_active(FALSE);}
	
	if (tslash) {
		if ((double_damamge) && (spinslash_active) && (area<=right)){terrain_wipe(link_loc(x)-1, link_loc(y)-1, 6);}
		else {slash_terrain(link_loc(y), link_loc(x));}
	
	}// end if tslash
}//*/

//=================================================================================================


void gfx_slash()
{
	
	
	int dir=0, deal_damage=0, tslash=0, charge=0;

	link_picture = LINK_THRUST2;
	if (((sword_charge>0) && (!spinslash_active))||  (sword_wait>0)){link_frame=3;}// prevent the sword from reattacking when letting go 
	//of the lrud keys
	
	switch (link_frame)
	{
		case 0:
			link_picture = LINK_THRUST2-1;
			switch (link_direction)
					{
						case up:		dir=left; break;
						case left: 
						case right:	dir=8; break;
						case down:	dir=right;break;
					}// end switch
		break;
		case 1:
			deal_damage=1;tslash=1;spins=0;
			
			switch (link_direction)
					{
						case up:		
						case left: 	dir=upleft;  break;
						case right:	dir=upright;break;
						case down:	dir=downright;break;
					}// end switch
		break;
		case 2:  tslash=1;	dir=link_direction;  deal_damage=1;  	break;
		case 3: dir=link_direction; charge=TRUE;terminate=TRUE;deal_damage=1; break;
		default:link_frame=-1;sword_active(FALSE);terminate=TRUE;return;
	 	
	}

	sword_display(dir, deal_damage, tslash, sword_charging(charge));

	
}// end gfx slash

//=================================================================================================


void gfx_wand()
{
	sword_charge=-1;
	if (link_frame>2){
		int	loc=add_object(item_wand_ammo, fix_xy(link_x, 1)+dir_to_sprite_xy_modder(link_direction, 1, 6)	, fix_xy(link_y, 2)+dir_to_sprite_xy_modder(link_direction, 2, 6),item_wand_ammo);
				set_object(loc, obj_dir, link_direction);// these set up the objects	
				mod_link(dual_state,0, TRUE);
				link_frame=-1;
		}		
		sword_display(link_direction, 0, 0, A_NORMAL);
		link_picture = LINK_THRUST2;
	
}


//=================================================================================================

void hole_walkling()
{
				if (link_stat(dual_state)==LINK_HOOKSHOT){return;}// dont fall down holes when using a hookshot

				int i=0;

				if	((i=touching_sprite_range(link_x, link_y, 170, 174, TRUE))>=170)
				{// if you are touching a hole, then fall into it.

					if ((item_type_exists(hover_boots,4)) && (hover<9)){hover++;}
					else{
						set_link_sprite_loc(link_x, link_y, i);// align with the hole sprite (in ezelda) 
					
						link_x=link_stat(inv_link_x);// fix the stats from ezelda to here.
						link_y=link_stat(inv_link_y);
						mod_link(state,LINK_STUN,TRUE);
						mod_link(dual_state,LINK_HOLE_FALL,TRUE);
						link_frame=0;
						
					}// end if not hovering
				}// end if touching a hole.
				else {hover=0;}

}// end hole walking

void change_link_frame(int pic){
			switch (link_frame)
			{
				case 0 ... 2:	link_picture = pic;			break;
				case 3 ... 5:	link_picture = pic+1;		break;
				default:	//Reset frame
					link_picture = pic;
					link_frame = 0;
				break;	
			}// end switch
	}// end change link frame



//=================================================================================================

void set_inv_xy()
{
	mod_link(inv_link_x, link_x, TRUE);// make sure to add his x/y pos to the inv so it can be accessed in ezelda			
	mod_link(inv_link_y, link_y, TRUE);//			int which, int number, int replace

}

void move_link(int speed)
{
						switch (link_direction)
					{
						case up:		link_y-=speed;	break;
						case down:	link_y+=speed;	break;
						case left:	link_x-=speed;	break;
						case right:	link_x+=speed;	break;
					}// end switch
// prevent link from going too far out of bounds.					
if (link_y<(-16)){link_y=(-16);}
if (link_y>128){link_y=128;}
if (link_x<(-16)){link_x=(-16);}
if (link_x>160){link_x=160;}	
set_inv_xy();
}

//=================================================================================================

void generaic_item_use()
{
			switch (link_frame)
			{
				case 0:				link_picture = LINK_THRUST2-1;	break;
				case 1 ... 2:	link_picture = LINK_THRUST2;		break;
				default:			mod_link(dual_state,0, TRUE);	link_frame = -1;	break;//reset
			}// end switch
}// end generic item useage

//=================================================================================================



//=================================================================================================
void gfx_spin_slash()
{
	spinslash_active=TRUE;
	int half=FALSE,  dir=link_direction;
	if ((spins%2)==0){link_direction=circle_dir(link_direction);half=TRUE;}

	if (half){
		switch (link_direction)
		{
			case up:		dir=upright;			break;
			case down: 	dir=downleft;			break;
			case left:	dir=upleft;				break;
			case right:	dir=downright;		break;
		}// end switch
	}//end if half
	sword_display(dir, 1, 1, A_NORMAL);
	spins++; // 7 spins is a perfect circle.  the 8 goes one click further.
	if (spins>8){spinslash_active=FALSE;double_damamge=FALSE;mod_link(state, LINK_NORMAL, TRUE);sword_charge=0;}
}




//==================================================================================
extern int argh;



int chk_for_lift()
{

	if ((keya==TRUE) || (keyb==TRUE)){return FALSE;}
	if (!item_type_exists(gauntlet,4)){return FALSE;}
	
	int x=link_x, y=link_y, old_x=0, old_y=0, new_oj=0;// this is for the new object you are getting.
	switch (link_direction)
	{
		case up:		y-=4;		break;
		case down:	y+=10;	break;
		case left:	x-=4;		break;
		case right:	x+=4;		break;
	}// end switch

	if (argh>3){return FALSE;}
	int obj=0, redoish=FALSE;
	if (link_stat(dual_state)!=LINK_CARRY){
		if (link_stat(dual_state)==LINK_LIFT1){return TRUE;}// just do it quickly.
		if ((new_oj=touch_object(x, y, LINK, 0, TRUE))!=555)
		{


			obj=get_object(new_oj,obj_type);//get_item_info(get_object(new_oj, obj_num),item_type);
			old_x=get_object(new_oj,obj_x);
		  old_y=get_object(new_oj,obj_y);
		  // the below section is to fix grabbing the wrong object when facing down.

		  if ((link_direction==down) && (old_x>=link_x+11))// if touching to the right
		  {if ((new_oj=touch_object(x-10, y, LINK, 0, TRUE))!=555){redoish=TRUE;} }
		  else if ((link_direction==down) && (old_x<=link_x-9))// if touching to the left
		  {if ((new_oj=touch_object(x+10, y, LINK, 0, TRUE))!=555){redoish=TRUE;} }

		  if (((link_direction==right) || (link_direction==left)) && (old_y>=link_y+6))// if touching to the above
		  {if ((new_oj=touch_object(x, y-6, LINK, 0, TRUE))!=555){redoish=TRUE;} }
		  else if (((link_direction==right) || (link_direction==left))  && (old_y<=link_y-6))// if touching to the left
		  {if ((new_oj=touch_object(x, y+6, LINK, 0, TRUE))!=555){redoish=TRUE;} }
		 
		  if (redoish)
		  {// redo the object info if the wrong item was gotten.
			//	if ((new_oj=touch_object(x, y, LINK, 0, TRUE))!=555){
					obj=get_object(new_oj,obj_type);//get_item_info(get_object(new_oj, obj_num),item_type);
					old_x=get_object(new_oj,obj_x);
			  	old_y=get_object(new_oj,obj_y);

		  }
//printf_xy(0,0,"%i %i %i %i %i",new_oj, old_x, old_y, redoish, obj);wait_for_key(b_ko);		  
		  
			if (obj==rock || obj==boulder  || obj==boom_bomb){
				mod_link(dual_state,LINK_LIFT1,TRUE);
				mod_link(hold_carry,new_oj,TRUE);//store the object # so it can be used later
				if (link_direction==up)
				{//tokubetsu
				// when link is facing up, the obj is already -16 to him, so reduce the y to his, to make it look 
				// like he is actually lifting the object.
					set_object(new_oj,obj_y,link_y);
				}
				if (obj==rock){set_all_maps(rmapx, rmapy,gter(old_y),gter(old_x), get_room_info(base_sprite));}
				return TRUE;
			}// end if (obj==rock || obj==boulder || obj==slashable_terrain || obj==pushable
		}// end if you are touching the object
	}// end if not lift2
	else{toss_object();}	
	
	return FALSE;
}// end chk for lift object



//==================================================================================
int chk_for_treasure()// this can be used for doors, too.
{
		if ((keya==TRUE) || (keyb==TRUE)){return FALSE;}
	int x=link_x;
	int y=link_y;
	int count1=0;

	switch (link_direction)
	{
		case up:		y-=4;	break;
		case left:	x-=2;	break;
		case right:	x+=2;	break;
//		case down:// this was removed, because it kept on picking up the wrong objects
//			y+=16;// you need to adjust x to a very slim section in order to make this work.
//		break;		
	}// end switch

	int obj=0, obj_id=0, extended=FALSE, got=FALSE;
			if ((obj_id=touch_object(x, y, LINK, 0, TRUE))!=555)
		{

			obj=get_object(obj_id,obj_type);

			if (obj==treasure_box){
					
					x=get_object(obj_id,obj_var2);//treasure_amt);
					y=get_object(obj_id,obj_var1);//treasure_item);
			if (!(get_treasure_marker(get_object(obj_id,obj_dam)))){// if you have not gotten the treasure
			// im using obj_dam as treasure_slot
					if ((y==rupie) && (x>0))// assuming gold
					{
						mod_link(rupies, x,FALSE);// add the number of rupies to link
						// show link getting a rupie object
						got=TRUE;

					}// end if rupies
					else if (y>=1000)
					{
					
					count1=get_item_info(y,item_type);
					
					x=1;
					if ((count1==bomb_bag) || (count1==rupie_bag) || (count1==heart_container) || (count1==quiver))
					{add_special_item(count1, y);got=TRUE;goto ending;}
					
// a check here will have to be made for regular inventory or extended inventory.
// if wallet, gauntlets, keys, tunic are all extended inventory					
// for now, nothing extended exists.			
// bottles, sowrds, are main inventory. - need about 2 bottles. - maybe 3 - but only 4 inventory slots are left for main.	
				//		printf("x=%i %i %i",x,get_object(obj_id,treasure_amt), obj_id);wait_for_key(esc_ko);	
						got=TRUE;
						if (y>=5000){extended=TRUE;}// if the item has an id # of over 5k, then it is an extended item.
						if (count1==type_map){fill_dung_map(oob());}
					//	else if (count1==type_compass){compass_add();}
						else {add_item_inv(y,x);}//int item, int amt, int ext);
					}
					
					ending:
					if (got)
					{// if you got the treasure, then do this:
					//	link_direction=down;
				
						set_treasure_marker(get_object(obj_id,obj_dam),TRUE);// show that you got the treasure
						mod_link(dual_state,LINK_GET_ITEM,TRUE);
						mod_link(state,LINK_STUN,TRUE);// make it so that you cannot move for the time being.
							link_frame=0;

					delete_obj(obj_id);// delete the treasure box
					if (y==rupie){y=item_rupie;}// fix it for link_get_item
						mod_link(hold_carry,y,TRUE);//store the object # so we know what to delete later

					}// end got
				}// end if something is in the box or not.	
				
					// treasure boxes start at set 7, so you may want to hard code it here, or soft code it in ezelda.
					//	#define treasure_amt 3// for either gold or item amount.
					//	#define treasure_slot 4// for the inventory slot to say that the treasure has been gotten.
					//	#define treasure_item 5/
			}// end if a treasure box
		}// end checking to see if treasure box is there.	
		return got;
}// end check for treasure





//==================================================================================
//get_room_info(base_sprite) - use for doors - set_room_maps(gter(old_y),gter(old_x), get_room_info(base_sprite));
//==================================================================================
int unlock_door()// this can be used for doors, too.
{
		if ((keya==TRUE) || (keyb==TRUE)){return FALSE;}
	int x=link_x;
	int y=link_y;
	int un=FALSE;// for unlocked
	int chk=0;
//int chk=0;
//	int old_x=0;
//	int old_y=0;
	switch (link_direction)
	{
		case up:		y-=9;		break;
		case down:	y+=18;	break;//21
		case left:	x-=9;		break;
		case right:	x+=18;	break;
	}// end switch
//175->182
		int mstr=item_type_exists(key_master,4);// let me know that the master key exists
		int i=175,bs=0;
		while (i<183)
		{
			if (touching_sprite(x, y, i)){
				if (i<179){
					if ((item_amt(item_key_normal, TRUE)>=1) || (mstr))
					{	
				
						chk=precision_sprite_find(x, y,i);
						if (chk>=100 && chk<200){x+=(chk-111);}
						else if (chk>=200){y+=(chk-211);}
						
							y=gter(y);
							x=gter(x);
							bs=get_room_info(base_sprite);
						set_all_maps(rmapx, rmapy,y,x, bs );	
				
				// ================== added stuff =================================
				// this should check the next room to see if there is a locked door on the other side of the locked
				// door you are touching.  if so, then it will make it dissappear, too.  did this b/c the original zelda maps
				// would allow you to unlock the door from either side...  - this is not needed for the boss key, though.
							//y=gter(y);
							//x=gter(x);
							int rmapx2=rmapx, rmapy2=rmapy;
							
							if (y==0){y=7;rmapx2=rmapx-1;}
							else if (y==7){y=0;rmapx2=rmapx+1;}
							else if (x==0){x=9;rmapy2=rmapy-1;}
							else if (x==9){x=0;rmapy2=rmapy+1;}
							un=get_all_maps(rmapx2, rmapy2,y,x);
							if ((un<179) && (un>=175)){set_all_maps(rmapx2, rmapy2,y,x, bs);}
				//   ================== end added stuff =======================	
				
							bs=1;un=TRUE;
				
					}// end if master key
				}// end if <179
				else
				{
					if (((item_amt(item_key_boss, TRUE)>=1)) || (mstr))
					{	
						chk=precision_sprite_find(x, y,i);
						if (chk>=100 && chk<200){x+=(chk-111);}
						else if (chk>=200){y+=(chk-211);}
						
					
				set_all_maps(rmapx, rmapy,gter(y),gter(x), get_room_info(base_sprite));bs=2;un=TRUE;
		
						
						}// end if boss key
				}
				
				
				if (!mstr){
					if (bs==1){add_item_inv(item_key_normal,-1);}
					else if (bs==2){add_item_inv(item_key_boss,-1);}
					}// end if not master key
			}// end if touching the sprite
			i++;
		}// end while	
		return un;
}// end unlock door.


//==================================================================================

void mod_link(int which, int number, int replace){md_link(which, number, replace);}// end mod link


//==================================================================================

int link_facing(int who)
{
	/*
			this routine will check to see if the mob and link are facing eachother.  
			if they are then it will return true.  if not, then it will return false.
	*///27530 ->27479
	if (link_direction==opposite_dir(get_mob_stat(who,mob_dir))){return TRUE;}

	return FALSE;
}//end link_facing


//==================================================================================
int chk_for_message()
{
	int who=0;
	int modx=0, mody=0;
	switch (link_direction)
	{
		case up: 	   mody= -10;		break;
		case down:   mody=10; 		break;
		case left:   modx=-10;		break;
		case right:  modx=10;			break;
	}

	if ((who=touch_mob(link_x+modx, link_y+mody, LINK))!=555)
	{

		
		switch (get_mob_stat(who,mob_type))
		{
				case towns_people:
					if (get_mob_stat(who,mob_msg_id)>0)
					{
						msg(get_mob_stat(who,mob_msg_id),get_mob_stat(who,mob_msg_num), TRUE);
						return TRUE;
					}// end if it has a msg				
				break;
				
				case quest_master:
				// the doubles allows me to kill the quest master, too, thus allowing for 2 different sls to execute.
				// this was mainly done for zelda simple quest so i could have an alternate ending if zelda was killed.
					if (get_mob_stat(who,mob_msg_id)>0)
						{
							 get_story(get_mob_stat(who,mob_msg_id));// pull the storyline file	
							 story_main();// execute the storyline file.
							return TRUE;
						}// end if it has a sl
					else if (get_mob_stat(who,mob_sl_exec)>0)
						{
						 get_story(get_mob_stat(who,mob_sl_exec));// pull the storyline file	
						 story_main();// execute the storyline file.
						return TRUE;
						}// end if it has a sl							
				break;
		}// end switch		
	}// end if touching a mob.
	return FALSE;
}// end chk for message
//==================================================================================









