// C Source File
// Created 10/25/2015; 7:30:16 PM

#include <tigcclib.h>
// C Source File
// Created 7/15/2011; 3:12:38 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                       */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"

//60487

#define line_type 23// this is the number location in the array that shows how to display
// the message.  numbers 1,2,3,6 are used.
#define msg_length 22 // the length of a normal message in chars and spaces
// msg_arr_size - this is in defines shows how many messages there are per file
#define msg_ttl_length 25 // this is the total length of the real message including the line_type and the \0


extern char *light;                         //Pointer to virtual light plane
extern char *dark; 


char msgs[msg_arr_size][msg_ttl_length];// this array will hold the messages - 50 lines of messages, each 21 chars long.
// the last 4 will be used for the number system.
// you may not need more than one or two message files.

	
//=================================================================================================
/*
		ynbox()
		this will display a little box with the words "yes" and "No" in it.  It will also have a
		pointer to allow you to choose yes or no.  it will return "true" or "false" depending on
		whether yes or no is chosen.  yes=true.  no=false.  to use this, first, display a msg()
		then call ynbox().  this allows the game to have options.
		- the ynbox will only display in one place, so keep that in mind. 
*/
//=================================================================================================	


int ynbox()
{


TRY
	//blk_menu(int x, int y, int torp, int box_color, int line_color)
		blk_menu(95,34,3, COLOR_WHITE, COLOR_DARKGRAY);// display the box
		
		int ypos_arrow=40, fin=FALSE, key=0;
		select(108, ypos_arrow, COLOR_BLACK, arrow);	// add the arrow

		while (!fin)
		{	
				key = get_key();// see if a key has been pressed.
				key_is_pressed(key);
				switch (key)
				{
					case 1:// 2nd
						
						if (ypos_arrow==40){return TRUE;}else {return FALSE;}
					
					case 2:// shift
						 return FALSE;
					
					case 3:// up
							//------------------------------------------------------------------
							//  first use a white arrow to "delete" the black arrow.  then move
							//  the arrow.  check for out of bounds and then draw the black 
							//  arrow in the corect spot.  case 4: does the sameish thing.
							//------------------------------------------------------------------
							select(108, ypos_arrow, COLOR_WHITE, arrow);
           		ypos_arrow =ypos_arrow-14;
          	  if (ypos_arrow<40){ypos_arrow=54;}           
          	  select(108, ypos_arrow, COLOR_BLACK, arrow);

            					
					break;
					
					case 4:// down
						

						select(108, ypos_arrow, COLOR_WHITE, arrow);
           	ypos_arrow =ypos_arrow+14;
           	if (ypos_arrow>54){ypos_arrow=40;}          
          	select(108, ypos_arrow, COLOR_BLACK, arrow);
					
					break;
					
					case 9:	all_keys_pressed(FALSE);break;
					default:break;
				
				}// end switch
				
		}// end while
			

   ONERR
   ENDTRY 
    return FALSE;
}// end message yes or no


//=================================================================================================
/*
		pull_msg_file
		get the message file and store it into msgs[]
*/
//=================================================================================================	


int pull_msg_file(int id)
{
	TRY

    FILE *f = NULL;
    //short int fileio = TRUE;
		char messa[10];
		sprintf(messa,"zmsg%i",id);
    FolderCur(SYMSTR("msgs"),TRUE);
    // open file for reading in binary mode
    if ((f = fopen(messa,"rb")) == NULL){return FALSE;}
     else {
        // read data from file into inv
        if (fread(msgs,sizeof(msgs),1,f) != 1) {return FALSE;}
	
       // close the file
        fclose(f);
    }
 ONERR
 		return FALSE;
 ENDTRY   
 return TRUE;
}// end pull msg file

//=================================================================================================
/*
		msg
		this is the main message routine.  you can pass in 3 different things:
		file_id - this is the ID # of the file to pull with pull_msg_file()
		msg_id - this is the location in the msgs[] array.  msgs[msg_id][]. it is used to decide what 
							message to show.
		pauseyn - a true/false variable.  if true, then pause after showing the message.
																			if false, then do not pause after message.  only pass in false
																			in the event that you are using ynbox() afterwards, otherwise
																			the message will display and dissappear in an instant.
							if you are using ynbox() after msg() then be sure to pass false to pauseyn.  if you 
							pass true to it, then it will display the message, remove message, then display
							the yes/no box, which will look strange. 												
*/
//=================================================================================================	

//------------------------------------------------------------------
//  each line in the message needs to have a number at the end of it: 
//  1,2,3, or 6.  these numbers will be at position "line_type" in 
//  the array.  at the time of the writing of this, it was #23.
//  this is what the numbers stand for:

//  1 - display a single line (in the middle) and pause after displaying
//  2 - display as the top line, but grab the next line, so 2 lines
//			can be displayed in the message.  
//  3	- display on bottom line, but is a number to let you know that
// 			there is more of the message to be displayed, so after esc
//      is pressed, then it will display the next message in line.
//  6 - display on bottom line, but let the system know that this is
//      the final line of the message to display.

//  if using a simple message of 2 lines, then you would use "2" on
//  the first line and then "6" on the second line.

//  if using a message of 3 lines (or an odd number of lines), then 
//	you would use "2" on line one, "3" on line two and "1" on line 
//  three

//	if using a message with 4 lines (or an even number >2), then
//  line 1 would be "2", line two would be "3", line three would be"2"
//  line four would be "6"

//  if doing a single line, then that line would be "1"
//------------------------------------------------------------------

void msg(int file_id, int msg_id, int pauseyn)
{
//------------------------------------------------------------------
//  first check for out of bounds errors.  if there are errors, then
//  reset the file_id and msg_id to show the correct error message.
//------------------------------------------------------------------

	if ((file_id<1) || (file_id>999)){file_id=1; msg_id=22;}//out of bounds error message
	if ((msg_id>=msg_arr_size)){msg_id=18;file_id=1;}// msg id out of bounds error message
	if (!pull_msg_file(file_id)){file_id=1; msg_id=30;}// make an error message


	int num=0, i=0, x=0, y=0;
	char info[msg_length+1];
	char numc[1];


start:
	blk_menu(0,0,1,COLOR_WHITE, COLOR_DARKGRAY);// creates the message menu
redo:


	if (msg_id>=msg_arr_size){goto end;}

	//------------------------------------------------------------------
	//  grab the number at the end of the message line, ie get line_type
	//  then turn it into an int.
	//------------------------------------------------------------------

	sprintf(numc, "%c", msgs[msg_id][line_type]);
	num=atoi(numc);

	//------------------------------------------------------------------
	//  loop through each char of the message and store it into info[]
	//------------------------------------------------------------------


	for (i=0; i<msg_length; i++)
	{
		x=0;		
		//------------------------------------------------------------------
		//  if the char is '@', then we know it is for links name, so loop
		//  for the next 6 spaces and replace the '@@@@@@' with links name
		//------------------------------------------------------------------

		if (msgs[msg_id][i]=='@')
		{
			while (x<6)
			{
				if (i>=msg_length){goto disp_string;}

				y=link_stat(link_letter_1+x);
				if (y!=0){info[i]=((char)y);}// get links name.  
				else {info[i]=' ';}// the #0 represents \0, so make it a space instead
				i++;x++;
			}

		}			
		info[i]=msgs[msg_id][i];// transferring the message to info[]

	}// end for

	info[msg_length]='\0';// force the message to end.  if you dont, then you get strange things appearing.
	
disp_string:
	
	//------------------------------------------------------------------
	//  line_type determines the placing of the message in the message 
	//  box, as explained at the beginning of this routine.
	//------------------------------------------------------------------
	
	switch (num)
	{
		case 1:  x=12; y=14; break;
		case 2:  x=12; y=7; break;
		default:		
		case 6:		
		case 3:  x=12; y=18; break;
		
	}// end switch
	
	
	add_print(x,y,info); // display the message in the box.

	msg_id++;
	//------------------------------------------------------------------
	// the order of the below is important, so dont change. some things
	// need to happen before the others.
	//------------------------------------------------------------------
	
	if (num==2){goto redo;}
	if (num==3){select(146, 24, COLOR_BLACK, msg_arrow);}
	
	//------------------------------------------------------------------
	//  if we are to pause, then wait for x_ko, ie the escape key to be 
	//	pressed.
	//------------------------------------------------------------------
	if (pauseyn){wait_for_keys(x_ko, b_ko);}
	if (num==3){goto start;}// erase and redo
	
	end:
}//end msg

//=================================================================================================
/*
		clr_white
		this is part of the prologue()
		it just clears out a line by diaplying all spaces.
*/
//=================================================================================================	


char temp[msg_length+1];	

void clr_white(int y){sprintf(temp, "                        \0");GrayDrawStr(12,y,temp,0);}

//=================================================================================================
/*
		print_white
		this will display the message in prologue.  
		this is separated from prologue, b/c it is called more than once.
*/
//=================================================================================================	


void print_white(int y, int loc)
{
			clr_white(y+3);// clear out the message
			sprintf(temp, "%s\0",msgs[loc]);
			temp[line_type]=' ';// clear out the number
			GrayDrawStr(12,y,temp,0);// display message in different location
}

//=================================================================================================
/*
		prologue
		this will either scroll or print letters 1 by one.  
		this will take an entire message file and start at the top and display everything until
		it reaches 9 or the end of the msgs[][] array.
*/
//=================================================================================================	

//------------------------------------------------------------------
// there will be 2 modes: scroll or slowly print the stuff from top 
// to bottom scroll will start at the bottom, recall blk_menu(), then 
// reprint all +1, to give the impression of scrolling. the slow write 
// will slowly write accross the screen until it reaches the bottom.  
// when finished it will blank screen and then restart.

// these 2 modes are handled by "torp"

// passing 1 to torp will cause the message file to print the characters
// 	1 at a time - similar to zelda gameboy style.

// passing 2 to torp will use scroll mode, where it scrolls like
//  credits at the end of a movie.
//------------------------------------------------------------------


void prologue(int id, int torp)
{

	int  i=0, loc=0, y=0, x=0, inc=0;
	char num2[1];
	if (!(pull_msg_file(id))){return;}
	blk_menu(0,0,4,COLOR_BLACK, COLOR_WHITE);
	if (torp==1){

		redo:
				//------------------------------------------------------------------
				// check to see if out of bounds or if you are at the end of the
				// message.
				//------------------------------------------------------------------
				if (loc>=msg_arr_size){goto end;}
				sprintf(num2, "%c",msgs[loc][line_type]);	
				if (atoi(num2)==9){goto end;}// 9 tells it to stop displaying a message
				
				//------------------------------------------------------------------
				// loop through, adding a letter at a time to temp[] and then 
				// display temp.
				//------------------------------------------------------------------				
				
				for (i=0;i<msg_length;i++)
				{
					sprintf(temp, "%c\0",msgs[loc][i]);
					GrayDrawStr(12+(i*6),9+(y*9),temp,0);
					if (get_key()==x_ko){goto end;}// if esc key is pressed, quit message
					slow(15000);// slow things down so it doesnt go too fast.
				}
				loc++;y++;
				if (y>=9){y=0;slow(30000);blk_menu(0,0,4,COLOR_BLACK, COLOR_WHITE);}
					
			goto redo;
	}// end if torp==1
	else if (torp==2)
	{
		y=81;
		start:
					inc=0;x=0;
				//------------------------------------------------------------------
				// check to see if out of bounds or if you are at the end of the
				// message.
				//------------------------------------------------------------------

				if (loc+6>=msg_arr_size){goto end;}
					sprintf(num2, "%c",msgs[loc+6][line_type]);	
					if (atoi(num2)==9){goto end;}
					 
					//------------------------------------------------------------------
					// print or delete the first line.
					//------------------------------------------------------------------
					if (y>9){print_white(y,loc);}
					else{clr_white(y+2);y+=11;loc++;}
					
					//------------------------------------------------------------------
					//  print in a loop and keep scrolling the lines upwards
					//------------------------------------------------------------------					
					cloop:
// print everything below the first line
						x++;inc+=9;
						clr_white(86);
						if (((y+inc)<82) && ((loc+x)<=msg_arr_size)){print_white(y+inc, loc+x);}// end if
						else {y-=2; goto start;}
						if (get_key()==x_ko){goto end;}
					goto cloop;
					
					
		goto start;
	}
end:	
	
	//add_print(8,7,temp);
}// end prologue

//------------------------------------------------------------------
//
//------------------------------------------------------------------

//=================================================================================================
/*

*/
//=================================================================================================	
