/*******************************************************************************/
/* The Legend of Zelda: Link's Awakening                                       */
/* By: Jason Ho                                                                */
/*                                                                             */
/* This header contains data pertaining to objects in the game. Objects        */
/* include such things as hearts, crystals, bombs, arrows, swords, shields,    */
/* etc. Objects also include such animations like the sword swing, explosions, */
/* dissolving leaves, etc. Anything that is not a terrain or mob is probably   */
/* an object.                                                                  */
/*******************************************************************************/


/*---------------------------------------------------------------------------*/
/* Aliases                                                                   */
/*---------------------------------------------------------------------------*/
enum {OBJECT_NUMBER, OBJECT_X, OBJECT_Y, OBJECT_FRAME}; //Used in object_list


//Shadows found under mobs when jumping
#define SHADOW1    0

//Link's sword, representing 7 swing directions


//Displayed when Link chops a bush
#define LEAF1      8
#define LEAF2      9
#define LEAF3      10
#define LEAF4      11

//Displayed when enemies get killed
#define EXPLODE1   12
#define EXPLODE2   13
#define EXPLODE3   14

//After chopping bushes or enemies you can get hearts and crystals
#define HEART1     15
#define CRYSTAL1   16


/*---------------------------------------------------------------------------*/
/* Function Prototypes                                                       */
/*---------------------------------------------------------------------------*/
void AnimateObject(void);

void AddObject(short, short, short);
void DeleteObject(short);
int obj_loc(int id);
void clr_object();

/*---------------------------------------------------------------------------*/
/* Pictures                                                                  */
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/* Functions                                                                 */
/*---------------------------------------------------------------------------*/




//-------------------------------------------------------------------
// Deletes an object from object_list by shifting all objects above
// it down. This way adding and deleting objects will never leave
// "holes" in object_list. 
//-------------------------------------------------------------------

/*
			baka..
			holes in the obj list should not matter. you should cycle through the list
			and animate the objects reguardless.  just zero out the current section.  
			moving everything down is simply causing errors anyways and you may lose the last/first thing
			in the object list.  sigh.  *bangs head up against wall*

*/

/*
int num_of_objects()// tells how many objects are in the list
{
	int i=0,k=0;
	while (i<50)
	{
		if (object_list[i][OBJECT_NUMBER] >= 0){k++;}
		i++;
	}
	return k;
}//end num of objects

*/



















