/****************************************************************************/
/* The Legend of Zelda: Link's Awakening                                    */
/* By: Jason Ho                                                             */
/*                                                                          */
/* This header contains data pertaining to rooms in the Zelda world.        */
/****************************************************************************/

/*---------------------------------------------------------------------------*/
/* Function Prototypes                                                       */
/*---------------------------------------------------------------------------*/

//void ScrollRoomup(void);
//void ScrollRoomDown(void);
//void ScrollRoomLeft(void);
//void ScrollRoomright(void);
//extern unsigned short int gfx_light[200][16],gfx_dark[200][16];
//extern unsigned short image_buffer_light[16];	 //Used to store temporarily modified pictures
//extern unsigned short image_buffer_dark[16];    //Used to store temporarily modified pictures
//extern unsigned short image_buffer_mask[16]; 
/*---------------------------------------------------------------------------*/
/* Global Variables                                                          */
/*---------------------------------------------------------------------------*/
//extern short screen_shift;                  //screen shift is explained in function DrawTerrain() from "terrain.h"
//extern short screen_row_gain;               //screen_row_gain is explained in function DrawTerrain() from "terrain.h"

//------------------------------------------------
// room_list [ROOM #] [ROW] [COLUMN] [TERRAIN] 
// TERRAIN information is defined in "terrain.h"
//------------------------------------------------

/*
	{0  ,130  ,131 ,132 ,133 ,0  ,0  ,0  		,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  },// 9 //144
	{145 ,146  ,147 ,148  ,149 ,0  ,0  ,0  		,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  },// 10 //160
	{161 ,162  ,163  ,164  ,0  ,0  ,0  ,0  		,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  },// 11 // 176
	{177 ,178  ,179  ,180  ,0  ,0  ,0  ,0  		,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  },// 12 // 192
	{193 ,194 ,195 ,196 ,0  ,0  ,0  ,0  		,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  },// 13 // 208
	{209 ,210 ,211 ,212 ,0  ,0  ,0  ,0  		,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  },// 14 // 224
	{225 ,226 ,227 ,228 ,229 ,230 ,0  ,0  		,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  },// 15 // 240
	{241 ,242 ,243 ,244 ,245 ,246 ,0  ,0  		,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  } // 16 // 256


*/


/*

		WARNING do not save the above world map.  it doesnt work right.  in reality, it
		places the houses on the world map!!??!   really? wow.  ok those need to be in 
		seperate maps.  38-> 48 are house maps.  im sure i can make an 8x8 map or something
		that would house these things.  the world map only needs the world map on it.
		
		actually, having the rooms numbered as they are is really fucked up.  it is way too
		confusing.  redo the mapping system and start with A1 as #1.  it should go from 1->256
		
		8*8 = 64*8 =128*4 =256*2 = 512+256 = 768 possible total possible rooms?  + random rooms for
		the houses 
		
		1000 * 100 = 100k sprites total.  room 0 = null.   well.. in reality, you could just redo
		some random things and allow for up to 9999 rooms total.  you could end up with over 1 mil 
		sprite game.  that would be awesome.  easy to make, too.  i probably should have gone with
		this idea for afw instead of the ff idea.  this could be so much bigger with only such a 
		minor improvements.
		
		ok here is a thought.  lets say that you link the mobs to a certain room# right, well what
		would happen if you decide to use that room multiple times in the same dungeon, then you
		would end up loading like 4*X mobs into that room each time.  well, that would be hell.  
		actually, here is another idea - match the mobs to the coords of the world map instead of the
		room, that way only a certain number of mobs will show up in that room when loaded. 

*/


//---------------------------------------------------------------------------
// room_mob_list [ROOM] [MOB #] [MOB DATA]
// Lists the mobs in each room, where MOB DATA are the 
// initial values of that MOB (mob number, mob coordinate x, mob coordinate y). 
// MOB # refers which mob in the room; Each room can have a max of 5 mobs
//
// These arent the only variables that keep track of mob data. The reason
// only these 3 are listed, however, is so it wont take up so much memory.
// Only the room-specific data is recorded here.
//---------------------------------------------------------------------------
int room_mob_list[49][5][3] = 
{
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{CHICKEN1,3,5},{BUTTERFLY1,3,1},{DOG1,7,1},{SANDMOB1,4,4},{MONSTER1,4,2}}, //Room 1
	{{BUTTERFLY1,2,3},{BUTTERFLY1,3,1},{BUTTERFLY1,7,5},{-1,0,0},{-1,0,0}},
	{{BUTTERFLY1,3,3},{BUTTERFLY1,6,2},{BUTTERFLY1,7,4},{DOG1,2,2},{-1,0,0}},
	{{BUTTERFLY1,3,2},{CHICKEN1,7,2},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{BUTTERFLY1,3,3},{BUTTERFLY1,8,5},{DOG1,7,1},{-1,0,0},{-1,0,0}}, //Room 5
	{{CHICKEN1,3,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{BUTTERFLY1,2,3},{BUTTERFLY1,6,2},{CHICKEN1,4,4},{-1,0,0},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{BUTTERFLY1,6,4},{CHICKEN1,2,2},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{BUTTERFLY1,3,2},{BUTTERFLY1,1,1},{BUTTERFLY1,7,1},{DOG1,3,6},{-1,0,0}}, //Room 10
	{{BUTTERFLY1,2,2},{BUTTERFLY1,6,5},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{BUTTERFLY1,2,3},{BUTTERFLY1,5,5},{BUTTERFLY1,6,2},{-1,0,0},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{BUTTERFLY1,3,2},{BUTTERFLY1,1,4},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{BUTTERFLY1,2,5},{BUTTERFLY1,3,2},{BUTTERFLY1,6,2},{-1,0,0},{-1,0,0}}, //Room 15
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{BUTTERFLY1,5,1},{BUTTERFLY1,7,1},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{MONSTER1,3,3},{MONSTER1,4,5},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{MONSTER1,3,1},{MONSTER1,6,2},{MONSTER1,6,5},{-1,0,0},{-1,0,0}}, //Room 20
	{{MONSTER1,2,5},{MONSTER1,4,2},{MONSTER1,7,4},{-1,0,0},{-1,0,0}},
	{{MONSTER1,7,1},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{MONSTER1,3,4},{MONSTER1,7,3},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}}, //Room 25
	{{MONSTER1,4,1},{MONSTER1,2,4},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{URCHIN1,3,2},{URCHIN1,6,4},{URCHIN1,7,4},{-1,0,0},{-1,0,0}},
	{{MONSTER1,6,2},{MONSTER1,5,5},{URCHIN1,2,5},{URCHIN1,2,6},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}}, //Room 30
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{MONSTER1,2,3},{SANDMOB1,4,4},{SANDMOB1,7,4},{-1,0,0},{-1,0,0}},
	{{MONSTER1,3,1},{SANDMOB1,3,2},{SANDMOB1,5,4},{-1,0,0},{-1,0,0}},
	{{URCHIN1,2,3},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{CRAB1,2,3},{CRAB1,6,4},{-1,0,0},{-1,0,0},{-1,0,0}}, //Room 35
	{{CRAB1,8,2},{SANDMOB1,4,2},{-1,6,2},{-1,0,0},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}}, //Room 40
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}}, //Room 45
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
	{{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0},{-1,0,0}},
};




/*---------------------------------------------------------------------------*/
/* Functions                                                                 */
/*---------------------------------------------------------------------------*/

/*===========================================================================*/
/* Loads a room from room_list into room_buffer. This is executed everytime  */
/* Link moves to a new room, so that the original room wont be modified.     */
/* Also adds animated terrain to the terrain_animation_list, and loads       */
/* mobs into mob_list.                                                       */
/*===========================================================================*/
void LoadRoom()
{
	int count1, count2, count3;
	int index = 0;
	int room=random(35);
	//------------------------------------
	// Load Terrain and Animated Terrain
	//------------------------------------
/*	for (count1=0;count1<8;count1++)  //Row
	{
		for (count2=0;count2<10;count2++)  //Column
		{
			for (count3=0;count3<2;count3++)  //Terrain Data
			{
				room_buffer[count1][count2][count3] = room_list[room][count1][count2][count3];
			}
			
			//--------------------------------------------------  this section is officially broken - recreate
			// Scrolls through all the terrain, and if they are 
			// animated, add it to the terrain_animation_list
			//--------------------------------------------------
			if (room_buffer[count1][count2][TERRAIN_PROPERTIES] &  ANIMATED)
			{
				terrain_animation_list[index][0] = room_buffer[count1][count2][TERRAIN_PIC];
				terrain_animation_list[index][1] = count1;
				terrain_animation_list[index][2] = count2;
				terrain_animation_list[index][3] = 1;
				index++;
			}
		}
	}*/
	//-----------------------------------------------------------------------------
	// Sets the last value in terrain_animation_list to -1. This allows the 
	// loop in AnimateTerrain to know when to stop checking for animated terrains
	//-----------------------------------------------------------------------------
	//terrain_animation_list[index][0] = -1;
	
	
	//------------------------------
	// Clears all mobs in mob_list
	//------------------------------
	for (count1=0;count1<5;count1++)
		mob_list[count1][MOB_NUMBER] = -1;
		
	//-----------------------------
	// Load mobs into the room
	//-----------------------------
	index = 0;
	//room=1;
	for (count1=0;count1<5;count1++)  //Each room can hold 5 mobs; count1 scrolls through all 5
	{
	//	room=1;
		if (room_mob_list[room][count1][MOB_NUMBER] >= 0)	//If mob number is -1, it doesnt load the mob
		{
			//------------------------------	
			//Sets room-specific variables
			//------------------------------
			mob_list[index][MOB_NUMBER] = room_mob_list[room][count1][MOB_NUMBER];
			
			//------------------------------------------------
			// Convert the mob coordinates into pixel x,y's.
			//------------------------------------------------
			mob_list[index][MOB_X] = 16 * room_mob_list[room][count1][MOB_X];
			mob_list[index][MOB_Y] = 16 * room_mob_list[room][count1][MOB_Y];
			
			//---------------------------------------------	----------------------------------------
			//Sets the variables that arent room-specific (can be set to whatever - doesnt matter.)
			//--------------------------------------------------------------------------------------
			mob_list[index][MOB_FRAME] = 0;
			mob_list[index][MOB_DIRECTION] = down;
			mob_list[index][MOB_PAUSE] = 0;
			mob_list[index][MOB_VAR1] = 0;	//Free variable to store mob_specific data
			mob_list[index][MOB_VAR2] = 0;	//Free variable to store mob_specific data
			index++;	//Increase the load number in mob_list
		}
	}
		
	//---------------------------------
	// Clears all objects in the room
	//---------------------------------
	for (count1=0;count1<50;count1++)
		object_list[count1][OBJECT_NUMBER] = -1;
}


/*===========================================================================*/
/* Scrolls into the room up from current room                                */
/*===========================================================================*/
/*

		ok these room scrollings most likely can be combined into 1 major routine, thus reducing size
		by like 60->70%  having 4 is just total bs. - i sigh again -  im glad i never went to gt. - no
		concept of space saving or optimization.

*//*
void ScrollRoomUp(void)
{
	int count1, count2;
	int row_gain=0;
	int shift=0;
	
	//---------------------
	// Scrolls 100 pixels
	//---------------------
	while (row_gain*16+shift < 100)
	{
		//---------------
		// Scroll Speed
		//---------------
		shift+=10;
		
		//--------------------------------------------------------------------------
		// A shift of 16 is essentially moving another row and having a shift of 0
		//--------------------------------------------------------------------------
		if (shift >= 16)
		{
			shift -= 16;
			row_gain++;
		}
		
		//--------------------
		// Clears the screen
		//--------------------
		memset(light,0,LCD_SIZE);
		memset(dark,0,LCD_SIZE);
		
		//----------------------------------------------------------
		// This loop scrolls the current room out from the bottom
		//----------------------------------------------------------
		for (count1=0;count1<10;count1++)
		{
			for (count2=0;count2<6-row_gain;count2++)	//Row
			{
				Sprite16(count1*16, count2*16+shift+row_gain*16, 16, gfx_light[ get_room_maps(rmapx(),rmapy(),count2,count1) ], light, SPRT_XOR);
				Sprite16(count1*16, count2*16+shift+row_gain*16, 16, gfx_dark[ get_room_maps(rmapx(),rmapy(),count2,count1) ], dark, SPRT_XOR);
			}
		}
		
		//----------------------------------------------------------
		// This loop scrolls the next room in from the top
		//----------------------------------------------------------
		for (count1=0;count1<10;count1++)	//Column
		{

			//--------------------------------------------------------------------
			// Draw's first row (with shift), using pictures from the next room
			//--------------------------------------------------------------------
			ShiftImage(TERRAIN, get_room_maps(rmapx()-1,rmapy(), 7-row_gain,count1), up, 16-shift, FALSE);
			Sprite16(count1*16, 0, 16, image_buffer_light, light, SPRT_XOR);
			Sprite16(count1*16, 0, 16, image_buffer_dark, dark, SPRT_XOR);
			
			//---------------------------------------------
			// Fills in the remaining next room pictures
			//---------------------------------------------
			for (count2=0;count2<row_gain;count2++)
			{
				Sprite16(count1*16, (row_gain-1-count2)*16+shift, 16, gfx_light[get_room_maps(rmapx()-1,rmapy(),7-count2,count1)], light, SPRT_XOR);
				Sprite16(count1*16, (row_gain-1-count2)*16+shift, 16, gfx_dark[get_room_maps(rmapx()-1,rmapy(),7-count2,count1)], dark, SPRT_XOR);
			}
		}
		
		//------------------------------------------------
		// Scrolls current room enemies out from the bottom
		//------------------------------------------------
		for (count1=0;count1<5;count1++)
		{
			if (mob_list[count1][MOB_NUMBER] >= 0)
				DrawImage(MOB, mob_list[count1][MOB_NUMBER],
				        mob_list[count1][MOB_X],
				        mob_list[count1][MOB_Y] + shift + row_gain*16, A_NORMAL);
		}
		
		//------------------------------------------------
		// Scrolls next room enemies in from the top
		//------------------------------------------------
	/*	for (count1=0;count1<5;count1++)
		{
			if (room_mob_list[world_map[link_map_row-1][link_map_col]][count1][MOB_NUMBER] >= 0)
				DrawImage(MOB, room_mob_list[world_map[link_map_row-1][link_map_col]][count1][MOB_NUMBER],
				        room_mob_list[world_map[link_map_row-1][link_map_col]][count1][MOB_X]*16,
				        room_mob_list[world_map[link_map_row-1][link_map_col]][count1][MOB_Y]*16 - 8*16 + (row_gain*16+shift), A_NORMAL);
		}*//*
		
		//----------------------------------------------------
		// Draw Link in sync with the moving screen. The 
		// row_gain*16+shift<100 check is so Link doesnt get 
		// pushed too far down until hes not visible.
		//----------------------------------------------------
		if (row_gain*16+shift < 100)
			link_y += 10;
		DrawImage(LINK, link_picture, link_x, link_y, A_NORMAL);
		
		//--------------------------------------
		// Copy virtual screens to real screen
		//--------------------------------------
		memcpy(GetPlane(0),light,LCD_SIZE);
		memcpy(GetPlane(1),dark,LCD_SIZE);
	}
	
	//---------------------------------------
	// Since Link's total screen shift is 0 
	// when he enters up, add it to his Y
	//---------------------------------------
	link_y += 16+12;
	
	//--------------------------
	// Set Link's new position
	//--------------------------
	link_map_row--;

	//-----------------------------------------
	// Load the new room into the room_buffer
	//-----------------------------------------
//	LoadRoom(world_map[link_map_row][link_map_col]);
}


/*===========================================================================*/
/* Scrolls into the room down from current room                              */
/*===========================================================================*/
/*
void ScrollRoomDown(void)
{
	int count1, count2;
	int row_gain=0;
	int shift=0;
	
	//---------------------
	// Scrolls 100 pixels
	//---------------------
	while (row_gain*16+shift < 100)
	{
		//---------------
		// Scroll Speed
		//---------------
		shift+=10;
		
		//--------------------------------------------------------------------------
		// A shift of 16 is essentially moving another row and having a shift of 0
		//--------------------------------------------------------------------------
		if (shift >= 16)
		{
			shift -= 16;
			row_gain++;
		}
		
		//--------------------
		// Clears the screen
		//--------------------
		memset(light,0,LCD_SIZE);
		memset(dark,0,LCD_SIZE);
		
		//----------------------------------------------------------
		// This loop scrolls the current room out from the top
		//----------------------------------------------------------
		for (count1=0;count1<10;count1++)	//Column
		{
			//----------------------------------------
			// Draws first row pictures with shift
			//----------------------------------------
			
			ShiftImage(TERRAIN, get_room_maps(rmapx(),rmapy(),screen_row_gain+row_gain,count1), up, screen_shift+shift, FALSE);
			Sprite16(count1*16, 0, 16, image_buffer_light, light, SPRT_XOR);
			Sprite16(count1*16, 0, 16, image_buffer_dark, dark, SPRT_XOR);
			
			//---------------------------------------------------------------
			// Starts on the 2nd row of pictures, and finishes the screen.
			//---------------------------------------------------------------
			for (count2=1;count2<7-row_gain;count2++)	//Row
			{
				Sprite16(count1*16,count2*16-screen_shift-shift,16,gfx_light[ get_room_maps(rmapx(),rmapy(),count2+screen_row_gain+row_gain,count1) ],light,SPRT_XOR);
				Sprite16(count1*16,count2*16-screen_shift-shift,16,gfx_dark[ get_room_maps(rmapx(),rmapy(),count2+screen_row_gain+row_gain,count1) ],dark,SPRT_XOR);
			}
		}
		
		//----------------------------------------------------------
		// This loop scrolls the next room in from the bottom
		//----------------------------------------------------------
		for (count1=0;count1<10;count1++)	//Column
		{
			for (count2=0;count2<row_gain+1;count2++)	//Row
			{
				Sprite16(count1*16,(6-row_gain+count2)*16+4-shift,16,gfx_light[ get_room_maps(rmapx()+1,rmapy(),count2,count1) ],light,SPRT_XOR);
				Sprite16(count1*16,(6-row_gain+count2)*16+4-shift,16,gfx_dark[ get_room_maps(rmapx()+1,rmapy(),count2,count1) ],dark,SPRT_XOR);
			}
		}
		
		//------------------------------------------------
		// Scrolls current room enemies out from the top
		//------------------------------------------------
		for (count1=0;count1<5;count1++)
		{
			if (mob_list[count1][MOB_NUMBER] >= 0)
				DrawImage(MOB, mob_list[count1][MOB_NUMBER],
				        mob_list[count1][MOB_X],
				        mob_list[count1][MOB_Y] - shift - row_gain*16, A_NORMAL);
		}
		
		//------------------------------------------------
		// Scrolls next room enemies in from the bottom
		//------------------------------------------------
		/*for (count1=0;count1<5;count1++)
		{
			if (room_mob_list[world_map[link_map_row+1][link_map_col]][count1][MOB_NUMBER] >= 0)
				DrawImage(MOB, room_mob_list[world_map[link_map_row+1][link_map_col]][count1][MOB_NUMBER],
				        room_mob_list[world_map[link_map_row+1][link_map_col]][count1][MOB_X]*16,
				        room_mob_list[world_map[link_map_row+1][link_map_col]][count1][MOB_Y]*16 + screen_row_gain*16 + screen_shift + 100 - (row_gain*16+shift), A_NORMAL);
		}*//*
		
		//----------------------------------------------------------------
		// Draw Link in sync with the moving screen
		// 8*16-16 is where link is when he moves down. subtracting 100-16
		// is where you want him to be when the screen is done scrolling.
		//----------------------------------------------------------------
		if (row_gain*16+shift < 100)
			link_y -= 10;
		DrawImage(LINK, link_picture, link_x, link_y, A_NORMAL);
		
		//--------------------------------------
		// Copy virtual screens to real screen
		//--------------------------------------
		memcpy(GetPlane(0),light,LCD_SIZE);
		memcpy(GetPlane(1),dark,LCD_SIZE);
	}
	
	//--------------------------------------------
	// Since Link's total screen shift is 16+12 
	// when he enters down, subtract it to his Y
	//--------------------------------------------
	link_y -= 16+12;
	
	//--------------------------
	// Set Link's new position
	//--------------------------
	link_map_row++;
	
	//-----------------------------------------
	// Load the new room into the room_buffer
	//-----------------------------------------
	//LoadRoom(world_map[link_map_row][link_map_col]);
}


/*===========================================================================*/
/* Scrolls into the room left from current room                              */
/*===========================================================================*/
/*
void ScrollRoomLeft(void)
{
	int count1, count2;
	int column_gain = 0;
	
	//---------------------------------------------------------------------------------------------
	// This loop assumes that the screen shifts 16 pixels at a time. This is because
	// room scrolling up, and down takes 10 loops to finish (a shift of 10 each time), so
	// with this knowledge we can omit the shift aspect of this function and just use column_gain
	//---------------------------------------------------------------------------------------------
	while (column_gain < 10)
	{
		column_gain++;
		
		//--------------------
		// Clears the screen
		//--------------------
		memset(light,0,LCD_SIZE);
		memset(dark,0,LCD_SIZE);
		
		//----------------------------------------------------------
		// This loop scrolls the current room out to the right
		//----------------------------------------------------------
		for (count1=0;count1<(10-column_gain);count1++)	//Column
		{
			//----------------------------------------
			// Draws first row pictures with shift
			//----------------------------------------
			ShiftImage(TERRAIN, get_room_maps(rmapx(),rmapy(),screen_row_gain,count1), up, screen_shift, FALSE);
			Sprite16((column_gain+count1)*16, 0, 16, image_buffer_light, light, SPRT_XOR);
			Sprite16((column_gain+count1)*16, 0, 16, image_buffer_dark, dark, SPRT_XOR);
			
			//------------------------------------------------
			// Draws rest of the rows to complete the screen
			//------------------------------------------------
			for (count2=1;count2<7;count2++)	//Row
			{
				Sprite16((column_gain+count1)*16, count2*16-screen_shift, 16, gfx_light[get_room_maps(rmapx(),rmapy(),count2+screen_row_gain,count1)], light, SPRT_XOR);
				Sprite16((column_gain+count1)*16, count2*16-screen_shift, 16, gfx_dark[get_room_maps(rmapx(),rmapy(),count2+screen_row_gain,count1)], dark, SPRT_XOR);
			}
		}
		
		//---------------------------------------------------
		// This loop scrolls the next room in from the left
		//---------------------------------------------------
		for (count1=0;count1<column_gain;count1++)	//Column
		{
			//----------------------------------------
			// Draws first row pictures with shift
			//----------------------------------------
			ShiftImage(TERRAIN, get_room_maps(rmapx(),rmapy()-1,screen_row_gain,9-count1), up, screen_shift, FALSE);
			Sprite16((column_gain-1-count1)*16, 0, 16, image_buffer_light, light, SPRT_XOR);
			Sprite16((column_gain-1-count1)*16, 0, 16, image_buffer_dark, dark, SPRT_XOR);
			
			
			//------------------------------------------------
			// Draws rest of the rows to complete the screen
			//------------------------------------------------
			for (count2=1;count2<7;count2++)	//Row
			{
				Sprite16((column_gain-1-count1)*16, count2*16-screen_shift, 16, gfx_light[get_room_maps(rmapx(),rmapy()-1,count2+screen_row_gain,9-count1)], light, SPRT_XOR);
				Sprite16((column_gain-1-count1)*16, count2*16-screen_shift, 16, gfx_dark[get_room_maps(rmapx(),rmapy()-1,count2+screen_row_gain,9-count1)], dark, SPRT_XOR);
			}
		}
		
		//------------------------------------------------
		// Scrolls current room enemies out to the right
		//------------------------------------------------
		for (count1=0;count1<5;count1++)
		{
			if (mob_list[count1][MOB_NUMBER] >= 0)
				DrawImage(MOB, mob_list[count1][MOB_NUMBER],
				        mob_list[count1][MOB_X] + column_gain*16,
				        mob_list[count1][MOB_Y], A_NORMAL);
		}
		
		//---------------------------------------------
		// Scrolls next room enemies in from the left
		//---------------------------------------------
	/*	for (count1=0;count1<5;count1++)
		{
			if (room_mob_list[world_map[link_map_row][link_map_col-1]][count1][MOB_NUMBER] >= 0)
				DrawImage(MOB, room_mob_list[world_map[link_map_row][link_map_col-1]][count1][MOB_NUMBER],
				        room_mob_list[world_map[link_map_row][link_map_col-1]][count1][MOB_X]*16 - (10-column_gain)*16,
				        room_mob_list[world_map[link_map_row][link_map_col-1]][count1][MOB_Y]*16, A_NORMAL);
		}*//*
		
		//--------------------------------------------
		// Draw Link in sync with the moving screen.
		//--------------------------------------------
		if (column_gain != 10)
			link_x += 16;
		DrawImage(LINK, link_picture, link_x, link_y, A_NORMAL);
		
		//--------------------------------------
		// Copy virtual screens to real screen
		//--------------------------------------
		memcpy(GetPlane(0),light,LCD_SIZE);
		memcpy(GetPlane(1),dark,LCD_SIZE);
	}
	
	//--------------------------
	// Set Link's new position
	//--------------------------
	link_map_col--;
	
	//-----------------------------------------
	// Load the new room into the room_buffer
	//-----------------------------------------
//	LoadRoom(world_map[link_map_row][link_map_col]);
}


/*===========================================================================*/
/* Scrolls into the room right from current room                             */
/*===========================================================================*/
/*
void ScrollRoomright(void)
{
	int count1, count2;
	int column_gain = 0;
	
	//---------------------------------------------------------------------------------------------
	// This loop assumes that the screen shifts 16 pixels at a time. This is because
	// room scrolling up, and down takes 10 loops to finish (a shift of 10 each time), so
	// with this knowledge we can omit the shift aspect of this function and just use column_gain
	//---------------------------------------------------------------------------------------------
	while (column_gain < 10)
	{
		column_gain++;
		
		//--------------------
		// Clears the screen
		//--------------------
		memset(light,0,LCD_SIZE);
		memset(dark,0,LCD_SIZE);
		
		//----------------------------------------------------------
		// This loop scrolls the current room out to the left
		//----------------------------------------------------------
		for (count1=column_gain;count1<10;count1++)	//Column
		{
			//----------------------------------------
			// Draws first row pictures with shift
			//----------------------------------------
			ShiftImage(TERRAIN, get_room_maps(rmapx(),rmapy(),screen_row_gain,count1), up, screen_shift, FALSE);
			Sprite16((count1-column_gain)*16, 0, 16, image_buffer_light, light, SPRT_XOR);
			Sprite16((count1-column_gain)*16, 0, 16, image_buffer_dark, dark, SPRT_XOR);
			
			//------------------------------------------------
			// Draws rest of the rows to complete the screen
			//------------------------------------------------
			for (count2=1;count2<7;count2++)	//Row
			{
				Sprite16((count1-column_gain)*16, count2*16-screen_shift, 16, gfx_light[get_room_maps(rmapx(),rmapy(),count2+screen_row_gain,count1)], light, SPRT_XOR);
				Sprite16((count1-column_gain)*16, count2*16-screen_shift, 16, gfx_dark[get_room_maps(rmapx(),rmapy(),count2+screen_row_gain,count1)], dark, SPRT_XOR);
			}
		}
		
		//---------------------------------------------------
		// This loop scrolls the next room in from the right
		//---------------------------------------------------
		for (count1=0;count1<column_gain;count1++)	//Column
		{
			//----------------------------------------
			// Draws first row pictures with shift
			//----------------------------------------
			ShiftImage(TERRAIN, get_room_maps(rmapx(),rmapy()+1,screen_row_gain,count1), up, screen_shift, FALSE);
			Sprite16((10-column_gain+count1)*16, 0, 16, image_buffer_light, light, SPRT_XOR);
			Sprite16((10-column_gain+count1)*16, 0, 16, image_buffer_dark, dark, SPRT_XOR);
			
			//------------------------------------------------
			// Draws rest of the rows to complete the screen
			//------------------------------------------------
			for (count2=1;count2<7;count2++)	//Row
			{
				Sprite16((10-column_gain+count1)*16, count2*16-screen_shift, 16, gfx_light[get_room_maps(rmapx(),rmapy()+1,count2+screen_row_gain,count1)], light, SPRT_XOR);
				Sprite16((10-column_gain+count1)*16, count2*16-screen_shift, 16, gfx_dark[get_room_maps(rmapx(),rmapy()+1,count2+screen_row_gain,count1)], dark, SPRT_XOR);
			}
		}
		
		//------------------------------------------------
		// Scrolls current room enemies out to the left
		//------------------------------------------------
		for (count1=0;count1<5;count1++)
		{
			if (mob_list[count1][MOB_NUMBER] >= 0)
				DrawImage(MOB, mob_list[count1][MOB_NUMBER],
				        mob_list[count1][MOB_X] - column_gain*16,
				        mob_list[count1][MOB_Y], A_NORMAL);
		}
		
		//---------------------------------------------
		// Scrolls next room enemies in from the right
		//---------------------------------------------
	/*	for (count1=0;count1<5;count1++)
		{
			if (room_mob_list[world_map[link_map_row][link_map_col+1]][count1][MOB_NUMBER] >= 0)
				DrawImage(MOB, room_mob_list[world_map[link_map_row][link_map_col+1]][count1][MOB_NUMBER],
				        room_mob_list[world_map[link_map_row][link_map_col+1]][count1][MOB_X]*16 + (10-column_gain)*16,
				        room_mob_list[world_map[link_map_row][link_map_col+1]][count1][MOB_Y]*16, A_NORMAL);
		}*//*
		
		//--------------------------------------------
		// Draw Link in sync with the moving screen
		//--------------------------------------------
		if (column_gain != 10)
		{
			link_x -= 16;
			//------------------------------------------------------------------
			// DrawImage cannot draw pictures that have both a negative X 
			// coordinate, and a negative Y coordinate, so to prevent Link 
			// from disappearing, if his X is negative, set it to 0. This is
			// the only one of the ScrollRoom functions that needs this check.
			//------------------------------------------------------------------
			if (link_x < 0)
				link_x = 0;
		}
		
		DrawImage(LINK, link_picture, link_x, link_y, A_NORMAL);
		
		//--------------------------------------
		// Copy virtual screens to real screen
		//--------------------------------------
		memcpy(GetPlane(0),light,LCD_SIZE);
		memcpy(GetPlane(1),dark,LCD_SIZE);
	}
	
	//--------------------------
	// Set Link's new position
	//--------------------------
	link_map_col++;
	
	//-----------------------------------------
	// Load the new room into the room_buffer
	//-----------------------------------------
	//LoadRoom(world_map[link_map_row][link_map_col]);
}*/





