// C Source File
// Created 10/10/2012; 1:50:23 PM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"
#include "extgraph.h"

unsigned short gfx_light[gfx_list_size][16],gfx_dark[gfx_list_size][16];
 
int over_world[overworld_rows][overworld_cols];

int all_maps[8][8][10][10];


extern int btn_pressed, link_dir, dk_room;

extern unsigned short object_pic_light[object_gfx_size][16];
extern unsigned short object_pic_dark[object_gfx_size][16];
extern unsigned short object_pic_mask[object_gfx_size][16];


unsigned short mob_pic_light[mob_gfx_list_size][16];
unsigned short mob_pic_dark[mob_gfx_list_size][16];
unsigned short mob_pic_mask[mob_gfx_list_size][16];

unsigned short link_pic_light[4][link_gfx_size][16];
unsigned short link_pic_dark[4][link_gfx_size][16];
unsigned short link_pic_mask[4][link_gfx_size][16];


int animate=0;

int screen_shift = 0;                  //screen shift is explained in function DrawTerrain() from "terrain.h"
int screen_row_gain = 0; 
char *light2 = 0;                         //Pointer to virtual light plane
char *dark2 = 0; 
//extern int link_frame2;

void set_planes(char *light,char *dark)
{
	light2=light;
	dark2=dark;
}// end set planes




inline	int g_animate(){return animate;}
inline	void s_animate(int x){animate=x;}

//==================================================================================================

inline	int g_screen_shift(){return screen_shift;}
inline	void s_screen_shift(int x){screen_shift=x;}

//==================================================================================================

	int g_screen_row_gain(){return screen_row_gain;}
	void s_screen_row_gain(int x){screen_row_gain=x;}
//==================================================================================================


inline int g_over_world(int x, int y){
	if ((x<0) || (y<0) || (x>=overworld_rows) || (y>=overworld_cols)){return -6666;}
	return over_world[x][y];}


//==================================================================================================


inline void s_over_world(int x, int y, int amt){
	if ((x<0) || (y<0) || (x>=overworld_rows) || (y>=overworld_cols)){return;}
over_world[x][y]=chk_num(amt);}

/*

#define overworld_gfx_file 0
#define overworld_dungeon_num 1
#define overworld_mob_stat_list 2
#define overworld_mob_gfx_file 3

#define overworld_repop 10
#define overworld_rset_start 11
#define overworld_rmapx_start 12
#define overworld_rmapy_start 13

#define overworld_link_xpos_start 20
#define overworld_link_ypos_start 21

#define overworld_world_to_left 30
#define overworld_world_to_right 31
#define overworld_world_to_up 32
#define overworld_world_to_down 33

#define overworld_map_nums 20 // where all the map numbers are stored
[4][0] = gfx file to use
[4][1] = dungeon number
[4][2] = mob stat list
[4][3] = mob gfx file

[5][0] = repop timer
[5][1] = rset # where link starts
[5][2] = rmapx of room where link starts (inside of rset) (old world[10][5])
[5][3] = rmapy of room where link starts 

[6][0] = link starting X pos in room (old world[9][5])
[6][1] = link starting Y pos in room
[6][2] = 

[7][0] = left world warp
[7][1] = right world warp
[7][2] = up world warp
[7][3] = down world warp

[10][7]=ow
11,6=rset

*/
// this returns the location of world.
int world_loc(int world)
{
	int k=0;
	while (k<4){if (world==over_world[overworld_map_nums][k]){return k;}else{k++;}}
	return 555;
}// end world location

int g_over_world_stat(int i, int world)
{
	if ((i<0) || (i>34)){return 555;}
	int  x=0, y=0;
	
	x=4+((int)(i/10))+(world_loc(world)*4);
	y=i-(((int)(i/10))*10);

/*	switch (i)
	{
		case 0 ... 4:
			x=4+(k*4);
			y=i;
		break;
		case 10 ... 14:
			x=5+(k*4);
			y=i-10;
		break;
		case 20 ... 24:
			x=6+(k*4);
			y=i-20;
		break;
		case 30 ... 34:
			x=7+(k*4);
			y=i-30;
		break;		
		default: return 555; break;
	}// end switch*/
	return g_over_world(x, y);
}// end get overworld stat

//==================================================================================================
void s_over_world_stat(int i, int world, int num)
{
	if ((i<0) || (i>34)){return;}
	int  x=0, y=0;

	x=4+((int)(i/10))+(world_loc(world)*4);
	y=i-(((int)(i/10))*10);

	s_over_world(x, y,num);
}// end get overworld stat

//==================================================================================================

int get_all_maps(int a, int b, int c, int d)
{
	if ((a<0) || (b<0) || (c<0) || (d<0) || (a>8) || (b>8) || (c>9) || (d>9)){return -6666;}
	return all_maps[a][b][c][d];
}

//==================================================================================================

void set_all_maps(int a, int b, int c, int d, int num)
{
	//room_maps[4][4][10][10];
	if ((a<0) || (b<0) || (c<0) || (d<0) || (a>8) || (b>8) || (c>9) || (d>9)){return;}
	
 all_maps[a][b][c][d]=chk_num(num);
}
//*/


//==================================================================================================

void s_gfx_light(int x, int y, unsigned short num){
if ((x<0) || (y<0) || (x>=gfx_list_size) || (y>=16)){return;}	
gfx_light[x][y]=num;}


//==================================================================================================

void s_gfx_dark(int x, int y, unsigned short num){
	if ((x<0) || (y<0) || (x>=gfx_list_size) || (y>=16)){return;}	
	
	gfx_dark[x][y]=num;}



//==================================================================================================
void DrawImage(int pic_type, int pic_num, int pic_x, int pic_y, int draw_type, int shift, int rotate)//,
								//int button_pressed, int link_direction, int dark_room)
{
	/*
			shift was added as a t/f var to let me know whether i wanted to shift it or not.
	*/
//	unsigned short lp[16], dp[16], mk[16];

	if (draw_type==dissappear) {return;}// made so i have 2 different blink types - one is reverse planes and the other is
	// to not draw the picture at all - a_xor is to not draw the picture.
	if ((pic_type==LINK) && link_stat(link_blink)>0){// this will make link blink
			if  ((link_stat(link_blink)%2)==0){draw_type=A_REVERSE;}// make link blink
			md_link(link_blink,-1,FALSE);	}	
	if (pic_type==MOB){ if ((get_mob_stat(draw_type,mob_hit)>0) && ((get_mob_stat(draw_type,mob_hit)%2)==0)){draw_type=A_REVERSE;}else{draw_type=A_NORMAL;}}
	
	if (pic_num==SHADOW1){pic_num=0;}// this will fix the shadow error.

	pic_num=fix_pic(pic_num,pic_type);// make sure the pic does not go out of bounds.
	
	if (shift){	pic_y -= (screen_shift+screen_row_gain*16);}

	if (rotate>0){if (rotate_image(pic_x, pic_y, rotate, pic_num, draw_type)){return;}}


		char *lp=light2, *dp=dark2;
		if (draw_type==A_REVERSE){lp=dark2; dp=light2;}
		
		
			switch (pic_type)
		{

			case MOB:
		
					GrayClipSprite16_SMASK_R(pic_x,pic_y,16,mob_pic_light[pic_num], mob_pic_dark[pic_num],  
					mob_pic_mask[pic_num], lp , dp);

			break;
			case OBJECT:
				
					GrayClipSprite16_SMASK_R(pic_x,pic_y,16,object_pic_light[pic_num], object_pic_dark[pic_num], 
					object_pic_mask[pic_num],  lp , dp);

			break;
			case LINK:	

					GrayClipSprite16_SMASK_R(pic_x,pic_y,16, link_pic_light[link_dir][pic_num],link_pic_dark[link_dir][pic_num], 
					link_pic_mask[link_dir][pic_num], lp , dp);

			break;
		}	

}// end draw image



//==================================================================================================


int fix_pic(int pic,int pic_type)
{
	
	if (pic<0){pic=0;}
	else{
			switch (pic_type)
		{
			case TERRAIN:
					if (pic >=gfx_list_size){pic=gfx_list_size-1;}
				break;
			case MOB:
					if (pic >=mob_gfx_list_size){pic=mob_gfx_list_size-1;}
				break;
			case OBJECT:
					if (pic >=object_gfx_size){pic=object_gfx_size-1;}
				break;
			case LINK:
					if (pic >=link_gfx_size){pic=link_gfx_size-1;}
				break;
		}//end switch
	}// end if pic is not <0
	return pic;
	
}




void DrawTerrain(int link_y)
{// uses room maps
	//int count1,count2,num;//,dk=FALSE;

//------------------------------------------------------------------------------------------------
// Screen Shift Concept:
// Beceboy,ause the TI-89 screen can only fit 6 rows of tiles instead of 8 like the gam
// A routine must be implemented to scroll the screen up and Down so that the player can see the whole room.
// screen_shift represents how any pixels from the top of the room the routine must scroll down.
// if screen_shift reaches 16, it resets and adds 1 to screen_row_gain
//
// Conceptually, the routine does:
// 1) Takes the first row pictures on the screen, and shifts the horizontal pixels up,
//    truncating its height to whatever it should be (using function ShiftImage).
// 2) Shifts the rest of the rows on the screen up to complete the picture.
//------------------------------------------------------------------------------------------------
	screen_shift = 0;
	screen_row_gain = 0;
	int count1=0,i=0,k=0,num=0;
	//--------------------------------------------------------------------
	// If Link goes beyond the 4th row of terrain, increase screen shift
	//--------------------------------------------------------------------
	if (link_y >= 3*16)
	{
		count1 = link_y - 3*16;
		screen_row_gain = (int)(count1/16);
		screen_shift = count1 % 16;
	}
//printf("q");	
	//--------------------------------------------------------------------------------------
	// Total screen shift must not exceed 28, because there are 16*2 rows, +4 extra pixels 
	// to display (because after 6 rows, 96 pixels, 4 pixels remain from LCD_HEIGHT
	//--------------------------------------------------------------------------------------
	if (screen_shift + screen_row_gain*16 > 2*16-4)
	{
		screen_row_gain = 1;
		screen_shift = 12;
	}

			int x=link_stat(map_x);
			int y=link_stat(map_y);
	redo:// this seems to be faster and smaller than the previous attempt
			if (i>9){return;}

				r2:
					if (k>7){goto r3;}
						num=get_all_maps(x, y,k+screen_row_gain,i);
						if (num>=500){num=get_room_info(base_sprite);}// all of the replace object sprites are out of bounds,
						// so in order to fix this, then make the thing print the base sprite instead. - it prevents errors.
						if (dk_room){if (num !=58){num=157;}}// this will default all of the rooms to black
						if (((num>=34)&&(num<46)) || ((num>=50)&&(num<82))){num+=animate;}// this will animate the terrtain
						num=fix_pic(num,TERRAIN);// this will prevent out of bounds errors.
						
							if ((y<=0) || (y>=112))// if at the top or bottom, always clip
							{GrayClipSprite16_XOR_R(i*16,k*16-screen_shift,16, gfx_light[num], gfx_dark[num], light2,dark2);}
							else{GraySprite16_XOR_R(i*16,k*16-screen_shift,16, gfx_light[ num ], gfx_dark[ num ], light2, dark2);}

					k++;
					goto r2;
				r3:
				i++;k=0;
			goto redo;		
		
		

}// end draw terrain 53125 -> 53121 - the gotos seem to be more effecient





//==================================================================================================

void clr_room()//int x, int y)
{
			// it will clear out a room map.
			int a=0,b=0, i=0,k=0;
				
			while (i<8){
				while (k<8){	
					while (a<10){
						while (b<10){
								
								all_maps[i][k][a][b]=0;
								b++;
							}// end while b<10
								a++; b=0;					
						}// end while a<10
							a=0;b=0;k++;
					}// end while k	
					i++;a=0;b=0;k=0;
				}	// end while i
						//clr_room_stats(); //dont do this, b/c it will erase the world map info.
						clr_mob_list(1);// clear the mob stats of that room, too.
}



//==================================================================================================




//==================================================================================================

void clr_world()//int x, int y)
{
			// it will clear out a room map.
			//world[12][8]
			int a=0,b=0;
					while (a<overworld_rows){
							
						while (b<overworld_cols){
								
								over_world[a][b]=0;
								b++;
							}// end while b<10
								a++; b=0;					
						}// end while a<10
						//clr_room_stats(); //dont do this, b/c it will erase the world map info.
						clr_mob_list(2);// clear the mob stats of that room, too.
}// end clr world

//==================================================================================================

void clr_gfx()//int x, int y)
{
			// it will clear out a room map.
			//world[12][8]
			int a=0,b=0;
					while (a<gfx_list_size){
							
						while (b<16){
								
								gfx_light[a][b]=0;
								gfx_dark[a][b]=0;
								b++;
							}// end while b<10
								a++; b=0;					
						}// end while a<10

}// end clr gfx


//=================================================================================================

void s_link_pic(int w,int x, int y,unsigned short num, int which){
		if ((w<0) || (w>=4) || (x<0) || (x>=link_gfx_size) || (y<0) || (y>=16)){return;}
		
		switch (which)
		{
			case 1:
				link_pic_light[w][x][y]=num;
			break;
			case 2:
				link_pic_dark[w][x][y]=num;
			break;
			case 3:
				link_pic_mask[w][x][y]=num;
			break;
		}
		
	
}// end set link pic

//=================================================================================================

void s_mob_pic(int x, int y, unsigned short num, int which){
		if ((x<0) || (x>=mob_gfx_list_size) || (y<0) || (y>=16)){return;}
		
		switch (which)
		{
			case 1:
				mob_pic_light[x][y]=num;
			break;
			case 2:
				mob_pic_dark[x][y]=num;
			break;
			case 3:
				mob_pic_mask[x][y]=num;
			break;
		}
		
	
}// end set mob pic

//=================================================================================================

