// C Source File
// Created 2/3/2013; 3:29:52 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"

int btn_pressed=0, link_dir=0, dk_room=0;

void set_object_animate_info(int btn, int dir, int dk)
{
	btn_pressed=btn;
	link_dir=dir;
	dk_room=dk;
}


void animate_leaf(int list_num, int pic, int items)
{
			
				int a=0,b=0,c=0,d=0,x1=0,x2=0,x3=0,x4=0,y1=0,y2=0,y3=0,y4=0;
	/*
			this routine has been revamped so that any exploding object can use it.
			just pass in a list num and a pic id# and it will draw the explosion.
			i got lazy and decided to not program in anything new for exploding jars
			and rocks.  that is just too much of a pain.
	*/			
	
				a=b=c=d=pic;// just in case there is only 1 item.

				switch (get_object(list_num, OBJECT_FRAME))
				{
					case 0:
					
					if (items==4){		a=c=(d=(b=pic)+1)+1;}

						x4=(x3=(x2=(x1=get_object(list_num,OBJECT_X)-4)+8)+2)+4;
						y4=(y3=(y2=(y1=get_object(list_num,OBJECT_Y))+1)+2)-5;

						break;
					case 1:

					if (items==4){	a=b=d=(c=pic)+1;}

						x4=(x3=(x2=(x1=get_object(list_num,OBJECT_X)+1)+4)-4)+6;
						y4=(y3=(y2=(y1=get_object(list_num,OBJECT_Y)-6)+6)+9);

						break;
					case 2:

					if (items==4){	a=c=d=(b=pic)+1;}

						x4=(x3=(x2=(x1=get_object(list_num,OBJECT_X)+1)-2)+10)+1;
						y4=(y3=(y2=(y1=get_object(list_num,OBJECT_Y)-6)+5)+6)+6;

						break;
					case 3:
					if (items==4){	b=(a=d=(c=(pic+1)+1)+1);}

						x4=(x3=(x2=(x1=get_object(list_num,OBJECT_X)+1)-5)+15)+1;
						y4=(y3=(y2=(y1=get_object(list_num,OBJECT_Y)-8)+16)-4)+7;

						break;
					case 4:
					if (items==4){	b=(a=d=c=(pic+2))+1;}

						x4=(x3=(x2=(x1=get_object(list_num,OBJECT_X)-1)-5)+19)-1;
						y4=(y3=(y2=(y1=get_object(list_num,OBJECT_Y)-10)+16)-3)+9;

						break;
					default:
						delete_obj(list_num);
						return;// this will prevent a null object from being drawn.
					break;
				}

				DrawImage(OBJECT, a, x1, y1, A_NORMAL, TRUE,0);
				DrawImage(OBJECT, b, x2, y2, A_NORMAL, TRUE,0);
				DrawImage(OBJECT, c, x3, y3, A_NORMAL, TRUE,0);
				DrawImage(OBJECT, d, x4, y4, A_NORMAL, TRUE,0);
					increase_object(list_num, OBJECT_FRAME, 1);

}// end animate_leaf()



//============================================================================================

void slash_terrain(int row, int col)
{
	if ((row>7) || (row<0) || (col<0) || (col>9)){return;}
	switch (get_all_maps(rmapx, rmapy,row,col))
	{
		//--------------------------------------------------------
		// If Link slashes PLANT1 or GRASS1, change it to GRASS2
		//--------------------------------------------------------
		case 0:	//plant (aka sprite #0)
		case 82: //GRASS1

			set_all_maps(rmapx, rmapy,row,col, get_room_info(base_sprite));
			// this will change the sprite to what the room base sprite should be.
			// that way it can be anything and not just 25 all of the time, which is gay.

			//---------------------------------------------------
			// Add the dissolving leaf animation to object_list
			//---------------------------------------------------
			add_object(LEAF1, col*16, row*16,0);
			
			//---------------------------------------------------
			// Random chance of getting a heart or crystal
			//---------------------------------------------------
			
			drop_item(col*16, row*16,0);
		break;
	}// end switch
}// end slash terrain.


//============================================================================================
/*  drop item with ai */
void drop_item(int x,int y,int who)
{
//65327 -> 65533 ~206 bytes more
//	ths will decide if an item should be dropped or not.

		int item=get_mob_stat(who,mob_item);
		if (item>999){add_object(item, x,y,item);goto end;}
		int rnd=7,type=CRYSTAL1, lhp=link_stat(hp), lmhp=link_stat(max_hp), type2=0;
		int bombs_exists=item_type_exists( bomb, either), arrows_exists=item_type_exists( arrow, either);
		int bombs_amt=item_amt(item_bomb, FALSE), arrows_amt=item_amt(item_bow, FALSE);
		if (lhp<((int)(lmhp*.3))){rnd-=2;}
	 item=0;
	if (!random(rnd))//x>0)//!random(8))//8
	{
	
		if ((lhp>((int)(lmhp/2))) && (bombs_exists) && (bombs_amt<=0)){type2=bomb;type=BOMB2;goto bypass;}
		if ((lhp>((int)(lmhp/2))) && (arrows_exists) && (arrows_amt<=0)){type2=arrow;type=ARROW2;goto bypass;}
		if (lhp>=lmhp)
		{
			if ((bombs_amt<link_stat(max_bombs))&& (bombs_exists)){type2=bomb;type=BOMB2;}
			else if ((arrows_amt<link_stat(max_arrows)) && (arrows_exists)){type2=arrow;type=ARROW2;}
			else {type=CRYSTAL1;}
			
		}else {
			type=HEART1;item=0;
			if (!random(120)){type=item=item_faerie;}
		}		

		bypass:
		if ((type2==arrow) || (type2==bomb)){item=item_type_exists(type2,3);}
		add_object(type, x,y,item);
	}// end if rand()
	end:
}// end drop item*/
/*
void drop_item(int x,int y,int who)
{
65327
	ths will decide if an item should be dropped or not.

		int item=get_mob_stat(who,mob_item),type=CRYSTAL1;
		if (item>999){add_object(item, x,y,item);goto end;}

	 item=0;
	if (!random(7))//x>0)//!random(8))//8
	{
		switch (random(12))// more range of variety
		{
			case 0 ... 2:
				type=HEART1;
			break;
			case 6 ... 8:
				type=HEART1;
				if (!(random(2))){
						if (item_type_exists( arrow, either))// || item_type_exists( arrow, bag)) - 4 was created to examine all
						{// only add the arrow if the arrows exist.
							type=ARROW2;
							item=item_type_exists( arrow,3);
						}// end if arrow exists
						else {goto trybomb;}
				}// end fi random
				else 
				{
					trybomb:
					if (item_type_exists( bomb, either))// || item_type_exists( arrow, bag)) - 4 was created to examine all
					{// only add the arrow if the arrows exist.
						type=BOMB2;
						item=item_type_exists( bomb,3);
					}// end if a bomb exists
					else if (item_type_exists( arrow, either))// in the event that the random number chooses bomb
					// instead of arrow, then test to see if you have bombs. if not, then test to see if you have
					// arrows.  if all testing fails, then you will end up getting a heart instead.
						{// only add the arrow if the arrows exist.
							type=ARROW2;
							item=item_type_exists( arrow,3);
						}// end if arrow exists
				else{	type=HEART1;}
					
				}// end if bomb
				
			break;

		}
		add_object(type, x,y,item);
	}// end if rand()
	end:
}// end drop item*/


//============================================================================================



void animate_bomb(int loc)
{
	
	int type=A_NORMAL;
	if (get_object(loc,OBJECT_FRAME)>30){
	if (!(get_object(loc,OBJECT_FRAME)%2)){type=dissappear;}// make the bomb blink in a different way.
	}// end if >80
	
	
	DrawImage(OBJECT, get_item_info(get_object(loc,OBJECT_NUMBER),item_pic_id), get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), type, TRUE,0);
	increase_object(loc, OBJECT_FRAME, 1);//object_list[loc][OBJECT_FRAME]++;
	if (get_object(loc,OBJECT_FRAME)>48)
	{

		if ((type=add_object(EXPLOSION, 0,  0,0))!=555)
		{
			set_object(type,OBJECT_FRAME,0);
			set_object(type,OBJECT_X, fix_xy(get_object(loc,OBJECT_X)-8,1));
			set_object(type,OBJECT_Y, fix_xy(get_object(loc,OBJECT_Y)-8,2));
		}// end if the object was added.

		delete_obj(loc);
	}//
	
	
}// end animate bomb

//============================================================================================

int fix_xy(int x, int which)
{
	if (x<object_x_min_oob){x=object_x_min_oob;}
	if (which==1)// for x.  any other number will be for y
	{	if (x>object_x_max_oob){x=object_x_max_oob;}}
	else if (which==2){if (x>object_y_max_oob){x=object_y_max_oob;}}// for y
	
	return x;
}

//============================================================================================

void animate_explode(int list_num)
{
			int a=0,c=0,d=0,x1=0,x2=0,y1=0,y2=0;
			
				d=get_object(list_num, OBJECT_FRAME);
				x1=get_object(list_num,OBJECT_X);
				y1=get_object(list_num,OBJECT_Y);

				
				switch (d)
				{

					case 0 ... 3:
						a=EXPLODE1;
						x2=x1-4; y2=y1-4;// do this before you change the x1/y1
						x1+=4; y1+=4; 
						c=A_NORMAL;
						if (d<2){c=A_REVERSE;}
						

						break;
	
					case 4 ... 7:
						a=EXPLODE2;
						x2=x1+4; y2=y1-4;
						x1-=4; y1+=4; 
						c=A_NORMAL;
						if (d<6){c=A_REVERSE;}
						
							break;
					case 8 ... 11:
						a=EXPLODE2;
			
						c=A_NORMAL;
						if (d>9){a=EXPLODE3;}
						break;
					default:

						
						//----------------------------------------
						// Delete the explosion when it is over.
						//----------------------------------------
						delete_obj(list_num);
						break;
				}// end switch  - 25913 -> 25851
					if (d<12 && d>=0)
					{
						DrawImage(OBJECT, a, x1, y1, c , TRUE,0);
						if (d<8){DrawImage(OBJECT, a, x2, y2, c, TRUE,0);}
						increase_object(list_num, OBJECT_FRAME, 1);
	
					}// end if d<>
}// end animate explode

//============================================================================================
// you cant use drop_obj in eafw
//============================================================================================

void animate_boomerang(int loc)
{
	//object_list[loc][obj_dir]//=which direction it is travelling
	int link_x=link_stat(inv_link_x);// get link_x
	int link_y=link_stat(inv_link_y);// get link_y	
	int rotate=0;
	int o_touched=0, o_type=555;
	if (get_object(loc, obj_var2)>1)// this means that the boomerang is returining to link
	{
		if (get_object(loc,OBJECT_Y) > link_y){	set_object(loc, obj_dir, up);}
			else{ set_object(loc, obj_dir, down);}
			
			o_touched= touch_object(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), boomerang,  loc, TRUE);
			if (o_touched<obj_list_size) {o_type = get_object(o_touched, OBJECT_NUMBER);}//object_list[o_touched][OBJECT_NUMBER];}
			if ((o_type==BOMB2) || (o_type==ARROW2)  || (o_type==CRYSTAL1) || (o_type==HEART1) || 
						(get_object(o_touched, obj_type)==key_normal))
			// this prevents anything but bombs, arrow, crystals, and hearts from moving.
			{		move_object(o_touched, 6, get_object(loc,obj_dir)) ; 	}
			
	}// end if var2>1
	

		move_object( loc, 6, get_object(loc,obj_dir));
		
		
// these switches are seperate so that the boomerang can travel in 2 directions when returing to link.
	if (get_object(loc, obj_var2)>1)
	{
		if (get_object(loc,OBJECT_X) > link_x)	{	set_object(loc, obj_dir, left);}//object_list[loc][obj_dir]=left;	}
			else{	set_object(loc, obj_dir, right);}//object_list[loc][obj_dir]=right;	}
			
			o_touched= touch_object(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), boomerang,  loc, TRUE);
			if (o_touched<obj_list_size) {o_type = get_object(o_touched, OBJECT_NUMBER);}//object_list[o_touched][OBJECT_NUMBER];}
			if ((o_type==BOMB2) || (o_type==ARROW2)  || (o_type==CRYSTAL1) || (o_type==HEART1))
			// this prevents anything but bombs, arrow, crystals, and hearts from moving.
			{		move_object(o_touched, 6, get_object(loc,obj_dir)) ; }
			
			move_object( loc, 6, get_object(loc,obj_dir));
			if (get_object(loc,OBJECT_Y)<link_y+11 &&  get_object(loc,OBJECT_Y)>link_y-6  &&
			get_object(loc,OBJECT_X)<link_x+11 &&  get_object(loc,OBJECT_X)>link_x-6)
			{      delete_obj(loc); return;}// if the boomerang manages to get back into links range, then delete it.
	}// end if var2>1
		


				switch (get_object(loc, obj_var1))
					{// make it animate
						case up:	 	rotate=0;				break;
						case down: 	rotate=rot_180;	break;
						case left: 	rotate=rot_270;	break;
						case right:	rotate=rot_90;	break;
					}// end switch			



			set_object(loc, obj_var1,circle_dir(get_object(loc, obj_var1))); 

	 
	 int who=0;
	 if ((who=touch_mob(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), boomerang))!=555)
	 {// ie if the boomerang hit a mob, then do the following:
	 	//	pain(who, get_object(loc, obj_dam),0,0);// for now it will do a perm 4 damamge
	 		stun_mob(who, 30);// stun the mob for 30 loops.
	 		set_object(loc, obj_var2, 2);
	 		//set_object(loc, obj_var2, 2);
	 }
	 else if (get_object(loc,OBJECT_X)<2 || get_object(loc,OBJECT_X) >=144 || get_object(loc,OBJECT_Y)<2 || get_object(loc,OBJECT_Y)>=112)
	 {// if the boomerang reaches the edge of the room, then do this.
	 	set_object(loc, obj_var2, 2);
	 }
	 else if (touch_object(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), boomerang,  loc, TRUE)!=555)  
	 {
	 	set_object(loc, obj_var2, 2);
	 }

	DrawImage(OBJECT, BOOMERANG, get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), A_NORMAL,TRUE,rotate);
	
}// end animate boomerang


//=================================================================================================
void delete_me(){}
/* takes ~700 bytes

void exploding_bomb(int loc)
{
	int i=0,k=0,n=25,chk=0,x=0,y=0;
	int link_x=link_stat(inv_link_x);// get link_x
	int link_y=link_stat(inv_link_y);// get link_y	
	//if (get_object(loc,OBJECT_FRAME)<5)
	int ax=0,ay=0;
	//{	
	while (i<2){
		while (k<2)
		{
			if (get_object(loc,OBJECT_FRAME)>=5 && get_object(loc,OBJECT_FRAME)<=7){n=29;}
			DrawImage(OBJECT,n , get_object(loc,OBJECT_X)+(k*16), get_object(loc,OBJECT_Y)+(i*16), A_NORMAL, TRUE,0);
			n++;
			k++;
		}// end while k
		i++;k=0;
	}// end while i	

	increase_object(loc, OBJECT_FRAME, 1);
	
	 if (get_object(loc,OBJECT_FRAME)>=8){
	i=0;
		while (i<max_mobs)
			{// this will deal damage to each mob that is caught in the blast
				if (get_mob_stat(i,mob_id)>0)
				{			
					if (collide(get_object(loc,OBJECT_X),32, get_object(loc,OBJECT_Y), 32, get_mob_stat(i,mob_x), 13, get_mob_stat(i,mob_y), 13))
						{
							if (get_mob_stat(i,mob_underground)<=0){pain(i, 8 , EXPLOSION,0);}// if the mob is not underground, then harm them
						}// end if they do collide
				}// end if stat>0
				i++;
			}// end while <max_mobs	
		if (collide(get_object(loc,OBJECT_X),32, get_object(loc,OBJECT_Y), 32, link_x+1, 14, link_y+1, 14)){
			pain(LINK, 8 , EXPLOSION,0);
		}// end if hits link
		i=192;
		while (i<200){// search through to see if a wall is bombed.
				ax=0;ay=0;
				while (ax<3){
				while (ay<3){
					if (touching_sprite( get_object(loc,OBJECT_X)+(ax*10)-2,get_object(loc,OBJECT_Y)+(ay*10)-2, i)){
							
							x=get_object(loc,OBJECT_X)+(ax*10)-2;
							y=get_object(loc,OBJECT_Y)+(ay*10)-2;	
							chk=precision_sprite_find(x, y,i);// get and fix the sprite location.
							if (chk>=100 && chk<200){x+=(chk-111);}
							else if (chk>=200){y+=(chk-211);}
							y=gter(y);x=gter(x);

							if ((chk=get_all_maps(rmapx, rmapy,y,x))<196){chk+=4;}
							chk-=150;// this does the same thing as the switch below.

						
							if (chk>45 && chk<50){set_all_maps(rmapx, rmapy,y,x, chk);}// had strange atrifacts show up, so this will
							// prevent some odd out of bounds errors.
				}// end if touching sprite
				ay++;
			}// end ay
				ay=0;ax++;
			}//end while ax
			i++;
		}// end while search for wall bombed.
		
	delete_obj(loc);}

}// end exploding bomb

*/
//============================================================================================

void animate_fire(int loc)
{
			int draw_type=A_NORMAL, who=0;
		int link_x=link_stat(inv_link_x);
		int link_y=link_stat(inv_link_y);	
		switch (get_object(loc,OBJECT_FRAME))
				{// makle it blink
					case 0 ... 2:
						draw_type=A_REVERSE;
					break;
					case 3:
					 	draw_type=dissappear;
					break;
					case 4 ... 5:		break;
					default:
						set_object(loc, OBJECT_FRAME, -1);
					break;
									
				
				}// end switch

		increase_object(loc, obj_var1, 1);
		if (get_object(loc, obj_var1)>17){ delete_obj(loc);}// end if delete obj after 16 frames			
		if ((get_object(loc, obj_var1)%3)==0){
			if ((who=touch_mob(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), boomerang))!=555)
				 { pain(who, 7, type_fire,0);}// for now it will do 2 damamge ever 3 fames. - it will deal about 35 damage

		}// end if mod 3
				 //
	if	(touch_object(link_x, link_y, LINK, loc, FALSE)==TRUE){pain(LINK,2,type_fire,0);}// if it touches link, then deal 4 damage
		DrawImage(OBJECT, 24, get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), draw_type,TRUE,0);
		increase_object(loc, OBJECT_FRAME, 1);
}// end animate fire

//============================================================================================

void animate_throw_object(int loc)// uses pain. cant use it
{

	int i=0,who=0;
		increase_object(loc, obj_var1, 1);
	if (get_object(loc, obj_var1)<=8)// move the object
	{
		move_object(loc,5,get_object(loc, obj_dir));
	
	if (get_object(loc, obj_dir)==right || get_object(loc, obj_dir)==left){
		if (get_object(loc, obj_var1)>=5){move_object(loc,4,down);}
		}// end if moving right or left.
	}// end if rand var1<=8
	
	if (get_object(loc,obj_type)==flying_bomb){
	// if it is a bomb, then do the following:	
	// make sure it doesnt go out of bounds and then bypass the flying object stuff.
		if (get_object(loc,OBJECT_X)<2){set_object(loc, OBJECT_X ,6);}
		if (get_object(loc,OBJECT_X) >=144){set_object(loc, OBJECT_X ,138);}
		if (get_object(loc,OBJECT_Y)<2) {set_object(loc, OBJECT_Y ,6);}
		if (get_object(loc,OBJECT_Y)>=112 ){set_object(loc, OBJECT_Y ,106);}
		increase_object(loc, OBJECT_FRAME, 1);// continue to increase the frame reguardless
		if (get_object(loc, obj_var1)>8){increase_object(loc, obj_var2, 1);}
		goto bypass; 
	}// end if a bomb
	
	
	if (get_object(loc,OBJECT_X)<2 || get_object(loc,OBJECT_X) >=144 || get_object(loc,OBJECT_Y)<2 || get_object(loc,OBJECT_Y)>=112 
			|| get_object(loc, obj_var1)>8 )
	{
		 i=add_object(LEAF2, get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y),0);

		 set_object(i,obj_var1, get_item_info(get_object(loc,OBJECT_NUMBER),item_pic_2));// set the pic1
		 set_object(i,obj_var2, get_item_info(get_object(loc,OBJECT_NUMBER),item_pic_3));// set the pic2
		 
		 increase_object(loc, obj_var2, 1);
	}
	else if ((who=touch_mob(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), loc))!=555)  
	 {
	 	 i=add_object(LEAF2, get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y),0);
	 	 set_object(i,obj_var1, get_item_info(get_object(loc,OBJECT_NUMBER),item_pic_2));// set the pic1
		 set_object(i,obj_var2, get_item_info(get_object(loc,OBJECT_NUMBER),item_pic_3));// set the pic2
		 increase_object(loc, obj_var2, 1);
		 pain(who,get_item_info(get_object(loc,OBJECT_NUMBER),item_damage),0,0);
	 }
	 
	 bypass:
	 
	 if (get_object(loc, obj_var2)<=0)
	 {// var2 is used to decide whether to draw the object or not.  if 0 or less, then draw it, otherwise delete the object.
	 	DrawImage(OBJECT, get_item_info(get_object(loc,OBJECT_NUMBER),item_pic_id), get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), A_NORMAL,TRUE,0);
	 	
	 	if (get_object(loc, obj_var1)<5)
	 	{// this will draw the shadow benieth the rock when thrown.  2 things needed b/c it first travels linear then diagnal.
	 		DrawImage(OBJECT, SHADOW1, get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y)+16, A_NORMAL,TRUE,0);
	 	}
	 	else{// this part is when the rock travels diagnal.
	 		DrawImage(OBJECT, SHADOW1, get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y)+(16-((get_object(loc, obj_var1)-5)*4)), A_NORMAL,TRUE,0);
	 	}// end else if the var>=5
	 	
	 }// end if var2<=0

	 else  {// if var2>=1
//	 	printf("\nin here");wait_for_key(b_ko);
	 	if (get_object(loc,obj_type)==flying_bomb)
	 	{
	 		set_object(loc,obj_type, boom_bomb);// return the bomb back to normal.
	 		
	 	}
	 	else{
	 	drop_item(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y),0);// chance of items being dropped once
	 	// a rock or jar explodes.	
	 	delete_obj(loc);}
	 }// end if var2>0
}


//============================================================================================

