// C Source File
// Created 2/3/2013; 4:41:31 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"


int object_list2[obj_list_size][obj_stat_size];



inline int get_object(int a, int b)
{

	if ((a<0) || (b<0) || (a>=obj_list_size) || (b>=obj_stat_size)) {return -6666;}
	return object_list2[a][b];
}// end get object

//============================================================================================


inline void set_object(int a, int b, int num)// use in place of mod_object()
{

	if ((a<0) || (b<0) || (a>=obj_list_size) || (b>=obj_stat_size)){return;}
		object_list2[a][b]=chk_num(num);
}// end get object

//============================================================================================


void increase_object(int a, int b, int num)
{// this was added b/c i didnt want to call 2 routines to do an object_list[a][b]++;
	if ((a<0) || (b<0) || (a>=obj_list_size) || (b>=obj_stat_size))
	{return;}// dont do anything if out of bounds
	num+=object_list2[a][b];
		object_list2[a][b]=chk_num(num);
}// end increase object
//============================================================================================


void move_object(int loc, int speed, int dir)//object_list[loc][obj_dir]
{// 36964 ->36944
//OBJECT_NUMBER, OBJECT_X, OBJECT_Y, OBJECT_FRAME, obj_dir, obj_var1, obj_var2, obj_dam,obj_type
	if ((loc<0) || (loc>=obj_list_size)){return;}
	int d1=0,d2=0;
	// the above was added to prevent address errors, which i kept getting with the raft.
	// basically, the raft would delete and then the obj_loc() would return 555 and this would
	// attempt to move loc==555, so i would get an out of bounds error; thus, crash.  this will
	// prevent that from happening.
	switch (dir)//object_list[loc][obj_dir]
	{// make it move.
		case up: speed= speed*(-1);
		case down:  d1=OBJECT_Y; d2=OBJECT_X;
		break;
		case left: speed= speed*(-1);
		case right: d1=OBJECT_X; d2=OBJECT_Y;
		break;
	}// end switch ud
	
		increase_object(loc, d1, speed);
		if (get_object(loc,obj_type)==arrow_foe_diagnal){increase_object(loc, d2, get_object(loc,obj_var2));}
		int y=get_object(loc,OBJECT_Y);
		int x=get_object(loc,OBJECT_X);	
		if (x>object_x_max_oob){set_object(loc, OBJECT_X, object_x_max_oob);}
		if (x<object_x_min_oob){set_object(loc, OBJECT_X, object_x_min_oob);}
		if (y>object_y_max_oob){set_object(loc, OBJECT_Y, object_y_max_oob);}
		if (y<object_y_min_oob){set_object(loc, OBJECT_Y, object_y_min_oob);}	
}// end move object

//============================================================================================
int duplicate_checker(int obj, int x, int y)//42979
{// this will check for duplicate items being added
	int i=0;
	while (i<obj_list_size){
		if ((x<=get_object(i,OBJECT_X)+3 && x>=get_object(i,OBJECT_X)-3)
				&& (y<=get_object(i,OBJECT_Y)+5 && y>=get_object(i,OBJECT_Y)-5))
				{// return that there is a duplicate of the exact same item in the vacinity.
					if (get_object(i,OBJECT_NUMBER)==obj) {return TRUE;}
				}
				i++;
	}// end while
	return FALSE;
}

//============================================================================================
// 61861 ->61883 = 22 bytes. ->61789
int add_object(int object_number, int object_x, int object_y, int item)
{
//	printf("\nobj=%i, %i %i",object_number, object_x, object_y);wait_for_key(b_ko);
	int list_num=0;
	if (object_number<=0){return 555;}// this should prevent shadows from being added to the list.
	if (duplicate_checker(object_number,object_x, object_y)){return 555;}

	int h=8,w=8;
	if ((list_num = obj_loc(-1))!=555){// if you find a place, then insert
	

	
	set_object(list_num, OBJECT_NUMBER, object_number);
	set_object(list_num, OBJECT_X, object_x); 
	set_object(list_num, OBJECT_Y, object_y); 
	set_object(list_num, OBJECT_FRAME, 0);
	//set_object(list_num, item_x_whitespace, 
			if (item>999){
				
				h=get_item_info(item, item_H);
				w=get_item_info(item, item_W);
				set_object(list_num, obj_type, get_item_info(item,item_type));
			}
			else 
			{
				switch (object_number)
					{
						case HEART1:	 h=6;  w=6;		break;
						case CRYSTAL1: h=12; w=6;		break;
						case BOMB2: 	 h=6;  w=6;		break;
						case ARROW2:   h=14; w=6;		break;
						case 500 ... 599:		h=w=16;	break;
					}// end switch	
					
			}// end else
					set_object(list_num, item_H,h);
					set_object(list_num, item_W,w);
	}
	return list_num;
}//and add object
//============================================================================================

int obj_loc(int id)
{
	int i=0;
	while (i<obj_list_size){if (get_object(i,OBJECT_NUMBER) == id){return i;} i++;}// end while
	return 555;
}// find an object location
//============================================================================================


void clr_object()
{
	int i=0;
	while (i<obj_list_size){set_object(i, OBJECT_NUMBER, -1);i++;}// end while
}// end clr object
//============================================================================================

void delete_obj(int list_num)
{

	if ((list_num<0) || (list_num>=obj_list_size)){return;}// to prevent out of bounds errors.
	int i=0;
	while (i<obj_stat_size){set_object(list_num,i,-1);i++;}//object_list[list_num][i] = -1; i++;}
	
}


//============================================================================================

int num_of_objects()
{
	int i=0,k=0;
	while (i<obj_list_size){if (get_object(i,OBJECT_NUMBER) >= 0){k++;}; i++;}
	return k;
}

//============================================================================================


