// Header File
// Created 10/10/2012; 1:50:59 PM
// Header File
// Created 7/18/2011; 12:23:49 AM

//  link stats location defines.  you should define the mobs in the same manor.

/*******************************************************************************/
/* The Legend of Zelda: Link's Awakening  v2.3                                 */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#define hp 0
#define max_hp 1
#define mana 2
#define max_mana 3
#define rupies 4
#define max_rupies 5
#define hold_a 6
#define hold_b 7
#define hold_c 8
#define hold_d 9
#define worn_a 10
#define worn_b 11
#define worn_c 12
#define worn_d 13
#define max_bombs 14
#define max_arrows 15
#define map_id 16
#define map_x 17
#define map_y 18
#define room_x 19
#define room_y 20
#define hc_pieces 21
#define def 22
#define state 23
#define hold_a_amt 24  // if you mod these then you will have to mod switch_item(), too in inventory.c
#define hold_b_amt 25
#define hold_c_amt 26
#define hold_d_amt 27
#define link_blink 28
#define dual_state 29// this exists so link can return back to his previous state

#define save_x 30
#define save_y 31
#define save_map_x 32
#define save_map_y 33
#define save_map_id 34
#define link_rand_var1 35

#define up 0
#define down 1
#define left 2
#define right 3

#define hold 1
#define bag 2
#define either 4// this is for either hold or bag

#define TERRAIN 0
#define MOB 1
#define LINK 100
#define OBJECT 3

//State when he is just standing
#define LINK_NORMAL   0

//State when player pushes the movement keys
#define LINK_WALK     1

//State when Link thrusts his sword
#define LINK_THRUST   2
#define LINK_THRUST2  3
#define LINK_SPIN_SLASH 10
#define LINK_WALKING_SWORD 11
#define LINK_REEL_BACK 12
#define LINK_STUN 13
#define LINK_PUSH 14
#define LINK_SHIELD 15// when he walks with the sword
#define LINK_GENERIC_ITEM 16
#define LINK_WAND 17
#define LINK_LIFT1 18
#define LINK_LIFT2 19
#define LINK_GET_ITEM 20
//State when Link is jumping or falling
#define LINK_JUMP     4
//#define LINK_JUMP2    5
//#define LINK_JUMP3    6


#define BOOMERANG     1
//#define SWORD2     2
//#define SWORD3     3
//#define SWORD4     4
//#define SWORD5     5
//#define SWORD6     4
#define WAND   7 // this is used for the object list
#define ARROW   31
#define BOMB2  39
#define ARROW2   5
#define FIRE     30

#define blk_heart 18
#define half_heart 19
// but there are a total of 8 swords.. b/c the last is for the spin slash.


// each one of the mob stats are for a specific x pos in the mob_stat array

#define mob_msg_id 1//mob_def 1
#define mob_msg_num  10 //mob_shield 10
// the above 2 are special.  for the towns person, the defence and shield is not needed,
// so they will be used to show what message.  right now the message is static, but
// it could be modded if you add in mod_mob into the sl. 



#define mob_hp 0
#define mob_def 1
#define mob_dam 2
#define mob_x 3
#define mob_y 4
#define mob_pause 5// used for the movement to know if the mob is paused or not. 
#define mob_sprites 6 // # of frames
#define mob_walk_sprites 7 // # of frames to allocate to walking
#define mob_sprite_id 8
#define mob_special_atk 9 // for like revenge attack (dog), shooting projectiles, chicken attack
#define mob_shield 10 // does it have a shield or not
#define mob_item 11 // items the mob holds?
#define mob_sl_exec 12 //execute a sl when they die - might be imped later for the bosses or for key
// drop
#define mob_stunned 13
#define mob_underground 14
#define mob_type 15 // like gohst(which can travel through walls)
#define mob_frame 16 // this is to let you know which pic to animate them with
#define mob_id 17
#define mob_dir 18
#define mob_rand_var1 19// used in the movement to set specific special movements 
#define mob_speed  20// tell the speed that the mob should move.  if 0, then dont move, but animate.
#define mob_stops 21 // 0 for constantly moving, 1 for random, 2 moves when link in proximety
#define mob_animation_type 22// 0 always animate, 1 animate when moving.
#define mob_rand_var2 23// used in the movement to set specific special movements 
// rand var 2 will also be used after the mob is hit.
#define mob_animation_speed 24// used to tell how fast to speed thorugh the frames.  
					// 1 will animate every frame.  2, every other frame ... 10 every 10 frames ... 20 every
					// 20 frames, etc.
#define mob_current_sprite 25
#define mob_move_type 26// tells how the mob should move, such as MOB_WANDER, MOB_FLUTTER, 
					//MOB_HOP, MOB_FOLLOW
#define mob_hit 27// this lets me know if the mob has been hit by a weapon or not.					

#define sometimes 1// this is related to mob_stops

#define flyer 7// this goes along with mob_type
#define ghost 8
#define digger 3

#define chicken 0
#define dog 1
#define butterfly 2

#define monster 4
#define urchin 5
#define crab 6
#define generic 10
#define towns_people 12

// these defines are for room_maps[8][x]
#define gfx_list 0  // this will not be used, b/c it is now placed in the world[][]
#define mob_gfx_list 1
#define mob_file 2
#define warp_list 3
#define treasure_list 4
#define locked_door_list 5
#define story_file 6
#define shop_list 7
#define hidden 8  // mod dung_maps if you ever change this. (int room_hidden(int room))
#define msg_list 9

// these defines are for room_maps[9][x]
#define room_dark 10  // just do <define> - 10 to get the thingie.
//room id=19
#define mobs_killed 11 // this will tell you whether to load the mob file for the room or not.
#define mobs_start 12// these let me know the range of mobs to use in the mob list
#define mobs_end 13 
#define no_save 14
#define torches_to_be_lit 15
#define torches_lit 16
#define mobs_amount 17  // the amount of mobs to randomly create for a room.
#define base_sprite 18 // this is used as the base ground, so when you cut or move an object, then
// it will replace it with that sprite.
enum {MOB_WANDER, MOB_FLUTTER, MOB_HOP, MOB_FOLLOW};  //Movement Types, used in function MoveMob


#define max_mobs 6//8 // if you ever want to change the amt of mobs in the mob list then just redo this
// number
#define mob_num_of_stats 28 // this is the number of stats per mob.

///


enum {OBJECT_NUMBER, OBJECT_X, OBJECT_Y, OBJECT_FRAME, obj_dir, obj_var1, obj_var2, obj_dam,obj_type}; //Used in object_list
// obj dir is the direction the object if flying.
// obj dam is the damage the object does
// obj type is the type of object.

//====================================================================================
//												defines for item object (used for addobject)
//====================================================================================
#define item_rock 1009
#define item_pot 2000// not imped
#define item_dark_torch 1013
#define item_light_torch 1014


//Shadows found under mobs when jumping
#define SHADOW1    0

//Link's sword, representing 7 swing directions


//Displayed when Link chops a bush
#define LEAF1      8
#define LEAF2      9
#define LEAF3      10
#define LEAF4      11

//Displayed when enemies get killed
#define EXPLODE1   12
#define EXPLODE2   13
#define EXPLODE3   14

//After chopping bushes or enemies you can get hearts and crystals
#define HEART1     15
#define CRYSTAL1   16
#define EXPLOSION  55
#define HOOKSHOT 40

//#define sword 1000
//#define msword 1001

#define immortal -77
#define death_by_fire -66// this lets me know if the mob can only be killed by fire.

// item stat info defines

#define item_id 0
#define item_type 1
#define item_pic_id 2
#define item_cost 3
#define item_damage 4
#define item_hold 5
#define item_duration 6
#define item_pic_2 7
#define item_pic_3 8
#define item_H 9
#define item_W 10
#define item_x_whitespace 11
#define item_y_whitespace 12
// these are for the item types
#define bomb 20 //normal displaying purposes only
#define arrow 1
#define wand 2
#define weapon 3
#define shield 4
#define boomerang 205
#define sword 6
#define heart 7
#define arrow_ammo 8
#define rock 9
#define boulder 10
#define slashable_terrain 11
#define pushable 12
#define throw_object 13  // this is when link is lifting the object.
#define follow_object 14 // this is when the object is already been lifted
#define boom_bomb 15 //the bomb that goes boom
#define flying_bomb 16
#define hookshot 17
#define torch 30//the torch is an item type that you cannot walk on, but you can
// hit it with fire and when it does get hit by fire, it will dissappear and
// and add +1 to the torch_lit count.


#define arrow_foe 21


#define chi_arrow 7
#define msg_arrow 8

#define box 0 // this is used for the pointer type in the inventory selecting.

//#define overwrite 10// this is for the drawtype.  it will overwrite the plane.


#define a_mob (who!=LINK)
#define a_player (who==LINK)

#define message 1
#define message_n_selector 3
#define message_n_yn_box 4

#define rot_90 90
#define rot_180 180
#define rot_270 270


// defines for buttons ==================================

#define a_ko 1
#define b_ko 2
#define up_ko 3
#define down_ko 4
#define left_ko 5
#define right_ko 6
#define start_ko 7

#define esc_ko 33
#define with *10+
#define f3_ko 8
#define f5_ko 10
#define c_ko 200
//===========================================


// damage types:

#define type_lit 8000
#define type_fire 8001
#define type_ice 8002


//  defines for quest items =============================

#define dungeon_map 0
#define compass 1
#define crystal 2


//  gfx list sizes

#define mob_gfx_list_size 32//48
#define gfx_list_size 200
#define link_gfx_size 15
#define object_gfx_size 50



#define obj_list_size 50
#define obj_stat_size 13