// C Source File
// Created 7/14/2011; 11:39:01 PM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"


//=================================================================================================
/*
			map_gfx.c has the routines to load map files and the gfx files.
*/
//=================================================================================================


extern char *light, *dark; 
extern int exited;
extern int link_direction, link_speed, link_frame,link_y, link_x, link_picture, button_pressed,link_frame2;
int  current_gfx_file=0, dark_room=TRUE,room_entry_x=0,room_entry_y=0, current_map_set=0;



//=================================================================================================
/*
		gfx_loader will attemp to load both the dark and light gfx files of the same ID#.  Instead of
		copy and pasting 2 file loads, I use one file load and the "loop" var to know which gfx file 
		i am loading (light or dark).  0 is for Light and 1 is for the Dark gfx file.  This makes things
		smaller.  after it loads a file, it will pass the info to the dll.
*/
//=================================================================================================

void gfx_loader(int id)
{

		if ((current_gfx_file==id) || (id<=0)){return;}
		else {current_gfx_file=id;}
		clr_gfx();// clear out the gfx
		char messa[10];
		unsigned short tmp[gfx_list_size][16];
		int i=0,k=0,loop=0;
		
		FolderCur(SYMSTR("gfx"),TRUE);// transfer to the mob filder.
		FILE *q = NULL;

redo:	

	q = NULL;
	if (loop==0){sprintf(messa,"gfxl%i",id);}
	else {sprintf(messa,"gfxd%i",id);}

	TRY
		

    if ((q = fopen(messa,"rb")) == NULL) {return;}else {
         if (fread(tmp,sizeof(tmp),1,q) != 1) {}else{
        	// if successful, then transfer over the gfx file.
        	for (i=0;i<gfx_list_size;i++) {for (k=0;k<16;k++){
        		
        		if (loop==0){s_gfx_light(i,k,tmp[i][k]);}
        		else {s_gfx_dark(i,k,tmp[i][k]);}
        	
        	}}// end fors
        }// end if successful.
        fclose(q);
    }
 

 ONERR
 ENDTRY     

 loop++;
 if (loop<2){goto redo;}
	
}// end gfx_loader()

/*
void exp_gfx_load(int id, int type)
{

		 if (id<=0){return;}
		
switch(type)
{
 case world_gfx:
 clr_gfx();// clear out the gfx
 sprintf(messa,"gfxl%i",id);
 sprintf(messa,"gfxd%i",id);
	a_maxer=gfx_list_size;
	b_maxer=16;
	if (current_gfx_file==id){return;}
	else {current_gfx_file=id;}
//	c_maxer=
//	d_maxer=
	f_maxer=gfx_list_size;
 break;
case mob_gfx:
a_maxer=mob_gfx_list_size;
f_maxer=mob_gfx_list_size*3;
if (current_mob_gfx==id){return;}
	else {current_mob_gfx=id;}
break;
}// end switch		
		
	maloc	char messa[10];
	maloc	unsigned short tmp[gfx_list_size][16];
		int i=0,k=0,loop=0;
		
		FolderCur(SYMSTR("gfx"),TRUE);// transfer to the mob filder.
		FILE *q = NULL;

redo:	

	q = NULL;
	if (loop==0){sprintf(messa,"gfxl%i",id);}
	else {sprintf(messa,"gfxd%i",id);}

	TRY
		

    if ((q = fopen(messa,"rb")) == NULL) {return;}else {
         if (fread(tmp,sizeof((unsigned short)(f_maxor*b_maxor) ),1,q) != 1) {}else{
        	// if successful, then transfer over the gfx file.
        	
        	for (a=0; a<a_maxer; a++)
        	for (b=0; b<b_maxer; b++)
     //   	for (c=0; c<c_maxer; c++)
       // 	for (d=0; d<d_maxer; d++)

        		
        		
        		switch (type)
        		{
        			case world_gfx:
        				if (loop==0){s_gfx_light(a,b,tmp[a][b]);}
        				else if (loop==1) {s_gfx_dark(a,b,tmp[a][b]);}
        				else {goto end;}
        			break;
        			case mob_gfx:
        				s_mob_pic(a,b,tmp[a][b],1);
	        			s_mob_pic(a,b,tmp[a+mob_gfx_list_size][b],2);
	        			s_mob_pic(a,b,tmp[a+(mob_gfx_list_size*2)][b],3);
        			break;
        		}
        		
        	
        	}}// end fors
        }// end if successful.
        fclose(q);
    }
 

 ONERR
 ENDTRY     

 loop++;
 if (loop<2){goto redo;}
 end
	unmalloc tmp
	unmalloc messa
}// end gfx_loader()
*/
//=================================================================================================
/*
		load_ow_map() attempts to load the overworld map and then pass it into the dll.
*/
//=================================================================================================

int load_ow_map(int file)
{

	  if (link_stat(ow_id)==file){return TRUE;}
	  if (file<=0){return FALSE;}
	  FILE *f = NULL;
    int fileio = TRUE;
		char mapa[8];
   	int i=0,k=0;
   	int tmp[overworld_rows][overworld_cols];


	TRY
			sprintf(mapa,"zow%i",file);
	    FolderCur(SYMSTR("maps"),TRUE);

	    if ((f = fopen(mapa,"rb")) == NULL) {fileio = FALSE;} else {
	        if (fread(tmp,sizeof(tmp),1,f) != 1) {fileio = FALSE;}else{
						clr_world();// if you get the file, be sure to clear out the overworld before you send the new one over.
	        	for (i=0;i<overworld_rows;i++) {for (k=0;k<overworld_cols;k++){s_over_world(i,k,tmp[i][k]);}}
	        }// end if successful.
	        fclose(f);
	    }
	
	
	ONERR
		fileio=FALSE;
	ENDTRY
	
	    if (fileio){mod_link(ow_id,file,TRUE);}// end if things worked

	    return fileio;
}// end load the overworld map


//=================================================================================================
/*
		load rset gets an rset file, which is a 4x4 set of rooms, and loads it into the 8x8 room set in ezelda.
		due to space restrictions, ie how large of a file i can load at once, i split the 8x8 world into 4 files,
		each one being a 4x4 square.  this routine will load a single file and will put it into the proper place
		based upon what numbers you pass into x/y.  x/y are the coordinates of the location of the rset id# in the
		overworld file.  remember that the overworld is a 4x4 in size that holds 16 total rset files. or a total of 
		4 "worlds" (world maps)
*/
//=================================================================================================

int load_rset(int file, int x, int y)
{

	  if (file<=0){return FALSE;}
	  FILE *f = NULL;
    int fileio = TRUE;
		char mapa[8];
   	int	a=0,b=0, i=0, k=0; 
   	int tmp[4][4][10][10];
   	if (x<2){x=0;}else {x=1;}// this is so we can do some simple math later on to decide where i want to load
   	if (y<2){y=0;}else {y=1;}// the rlist into the 8x8 square.
	TRY

			sprintf(mapa,"rset%i",file);
	    FolderCur(SYMSTR("rooms"),TRUE);

	    if ((f = fopen(mapa,"rb")) == NULL) {fileio = FALSE;} 
	    else {
	    			if (fread(tmp,sizeof(tmp),1,f) != 1) {fileio = FALSE;}
					 	else{
					 	
        				// do NOT clr_room().  do this before all the load rsets are called.		
								for (a=0;a<4;a++) {for (b=0;b<4;b++){ for (i=0;i<10;i++){for (k=0;k<10;k++)
// add transistion effect in here.
								{set_all_maps((x*4)+a,(y*4)+b,i,k,tmp[a][b][i][k]);}}}}
   	
	           }// end if successful.
	        fclose(f);
	   		}// end else if you can open the file
	
	
	ONERR
		fileio=FALSE;
	ENDTRY

	    return fileio;
}// end load the rset

//=================================================================================================
/*
		world_init() will attempt to load all the info for the current world[][], such as which gfx
		file to use, and the mobs to use for that world[][].  If it is a dungeon, then it will attempt
		to load the current dungeon map for that room.
*/
//=================================================================================================

void world_init()
{

	clr_mob_list(2);// clear out the mob list, if loading a new world map
	mob_gfx_loader(g_over_world_stat(overworld_mob_gfx_file, oob()));
	compile_mobs(g_over_world_stat(overworld_mob_stat_list, oob()), 0, 0, 2, 0);add_print(42,87,".");
	gfx_loader(g_over_world_stat(overworld_gfx_file, oob()));// load the correct gfx file for this.
//printf("g=%i",g_over_world_stat(overworld_gfx_file, current_world()));	
	 if (g_over_world_stat(overworld_dungeon_num, oob())>0){// if it is a dungeon, then do the following:
      	 	if (quest_exists(dungeon_map, g_over_world_stat(overworld_dungeon_num, oob())))
      	 	{fill_dung_map(g_over_world_stat(overworld_dungeon_num, oob()));}
   	 	else {get_dung_map(g_over_world_stat(overworld_dungeon_num, oob()));}
   	 }// end if it is a dungeon.*/
}// end rooms init

//=================================================================================================
/*
		get_world_map() attempts to load all the files that would be in the world[][] map and the 
		rsets[][] that goes along with it.  Due to the longer loading process of this, I added
		in a "loading..." section at the bottom left of the screen. This has 2 abilities:
		
		1) you can pass in a map ID# and if you are already in that map, then it will attempt to 
			 load everything.
		2) if the map ID# is not the same, then it will change the id and then attmpt to load the 
			 rsets[][].  The reason for the separation is so the link save files could load properly
			 in the beginning screens.
*/
//=================================================================================================

int get_world_map(int map)
{
	if ((map<0) || (map>999)){return -6666;}
		int i=0,k=0;
			if (oob()==map){
			
				try2:
					i=link_stat(ow_x);
					k=link_stat(ow_y);
	        
	        GrayDrawRect(0,85,65,95,COLOR_WHITE,RECT_FILLED);
					add_print(0,87,"Loading");
					
					clr_room();
					world_init();					
					
					load_rset(g_over_world(i,k), 0, 0);add_print(47,87,".");
					load_rset(g_over_world(i,k+1), 0, 2);add_print(52,87,".");
					load_rset(g_over_world(i+1,k), 2, 0);add_print(57,87,".");
					load_rset(g_over_world(i+1,k+1), 2, 2);
					return TRUE;
				}
				else {if (set_oob(map)){goto try2;}}

			return FALSE;
}// end get world map

//=================================================================================================
/*
		pull_new_map() will attempt to load the overworld first and if successful, then it will attempt
		to load the corresponding world map.  however, if you pass in a number, which would not work
		with a file name, then it will pass back the out of bounds number of -6666.
*/
//=================================================================================================

int pull_new_map(int ow, int map)
{
	if ((ow<0) || (ow>9999) || (map<0) || (map>999)){return -6666;}
	if (g_over_world_stat(overworld_dungeon_num, oob())>0)
	{save_dung_map(g_over_world_stat(overworld_dungeon_num, oob()));}
	if (load_ow_map(ow)){	return get_world_map(map);}// end if found
	return FALSE;	
}// end pull_new_map()

//=================================================================================================
/*
		init_terrain() attempts to pull a new overworld and corresponding map.  If successfuly, then
		it will load the room that link is set to be in.  If it fails then it will display an error
		and restart the game.
*/
//=================================================================================================

int init_terrain(int ow, int map)
{
	if (pull_new_map(ow, map)){get_map_vars();}
	else{disp_error("Failed to load map.");exited=3;return FALSE;}// if the map fails to load, then restart the game.
	return TRUE;
}// end init terrain

//=================================================================================================
/*
			world shift will return which world is set to the left right up or down of the current world
			this will normally be used to figure out if you can move from one world map to another
*/
//=================================================================================================

int world_shift(int dir,int wld)
{
	int i=777;// this will force the g_over_world_stat to error out if the switch doesnt fix it
	switch (dir)
	{
		case left:  i=overworld_world_to_left; 	 break;
		case right: i=overworld_world_to_right;  break;
		case down:  i=overworld_world_to_down; 	 break;
		case up: 		i=overworld_world_to_up; 		 break;
	}// end switch
		
	return g_over_world_stat(i, wld);
}// end world shift

//=================================================================================================
/*
		scroll_room works with warper() to move to different rooms.  warper() will call scroll_room()
		in the event that link goes out of bounds.  other checks do exist to make sure link is out
		of bounds, because scroll_room() could be used elsewhere in the code, like when link jumps.
		First scroll room will check the direction of link and, depending on his direction, will modify
		either link_stat() of map_x or map_y.  This will cause link to change rooms.  If you leave the
		entire array, then it will do checks to see if another world map can be called.  if it can, 
		then it will load the new world map.
*/
//=================================================================================================

void scroll_room(int dir)
{
				//------------------------------------------------------------------
				//		set the map_x/y before doing anything.  this will prevent
				//		needless calls when checking things.  it makes code smaller.
				//		remember: map_x/y is set in this fassion: world[map_x][map_y]
				//		however, link_x/y is set in this fassion: room[link_y][link_x]
				//    so map_x would correspond to link_y.
				//------------------------------------------------------------------			
				int mx=link_stat(map_x);
				int my=link_stat(map_y);
								
				//------------------------------------------------------------------
				// check links direction and modify map_x/y if he his out of bounds
				//------------------------------------------------------------------
				switch (dir)
				{
					//------------------------------------------------------------------
					//	if link is NOT out of bounds, then modify map_x/y and then modify
					//  the directional coordinate in relation to it to be on the other
					//  side of the screen.
					//------------------------------------------------------------------
					case up:		if ((mx-1)>-1){mod_link(map_x,-1,FALSE);	link_y=114;}else {return;} break;
					case down:  if ((mx+1)<8){mod_link(map_x,1,FALSE); link_y=0;}	else {return;}     break;
					case left:  if ((my-1)>-1){mod_link(map_y,-1,FALSE);	link_x=146;}else {return;} break;
					case right: if ((my+1)<8){mod_link(map_y,1,FALSE);	link_x=-2;}else {return;}	   break;
				}// end switch dir
				
				
				//------------------------------------------------------------------
				//  fix out of bounds errors and keep the map_x/y coords of link 
				//  the same.  if you dont fix the xy coords, then link will loop 
				//  to the opposite side of that room.  In the future, this is where
				//  you will change world maps.
				//  this was removed to help prevent errors with dont_get_stuck()
				//  it was also removed due to the fact that it was pointless
				//  if you add it again, then remove the 4x "else {return;}" from above
				//------------------------------------------------------------------				
		//		if 			(mx<0) {mod_link(map_x,0,TRUE);}
		//		else if (mx>7) {mod_link(map_x,7,TRUE);}
		//		if 			(my<0) {mod_link(map_y,0,TRUE);}
		//		else if (my>7) {mod_link(map_y,7,TRUE);}
				
				//------------------------------------------------------------------
				//  now set the room entry points and pull the variables of the room
				//  so the room will load correctly.
				//------------------------------------------------------------------				
		 		
		 	//	room_entry_x=link_x;
			//	room_entry_y=link_y;

						get_map_vars();
						dont_get_stuck();


}// end new scroll room



//================================================================================================



