// C Source File
// Created 2/2/2013; 9:30:23 PM
// contains all the move animations for the mob except chicken
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/



#include <tigcclib.h>
#include "all.h"
extern int link_x, link_y;
float circle_v[2][32];

void fill_circle_values()
{
	float k=.1;
	int i=0;
	
			for (i=0;i<32;i++)
			{
				circle_v[0][i]=cos(k);//+q)*radius  +72;
				circle_v[1][i]=sin(k);//+q)*radius +42;
				k+=.2;
				//q+=.9;
				//if (q>5.4){q=0;k+=.2;}
			}// end for		
			
}// end fill circle values.							

int circle_y(int loc, int radius, int center){return (int)(circle_v[1][loc]*radius + center);}
int circle_x(int loc, int radius, int center){return (int)(circle_v[0][loc]*radius + center);}							

int disp_circle_object(int i, int pic)
{
							
		int q=0, obj=1;//,  cx=0,cy=0;
	//	slow(400);
		redo:
				
					DrawImage(OBJECT, pic, circle_x(i, 32, link_x), circle_y(i, 32, link_y), A_NORMAL, TRUE,0);
	
				
				if ((q==1) || (q==3)){i+=4;} else {i+=5;}
				q++;obj++;
				if (i>=32){i=i-32;}
				if (q<7){goto redo;}					
		return i;					

}// end circle objects

int disp_circle_mobs(int x, int y, int radius, int i)
{
							
		int q=0, obj=1, pic=0, cx=0,cy=0;
		redo:
				
				if (get_mob_stat(obj,mob_hp)>0)
				{
					// animate the mob and then draw its pic
					pic=picture_rotator(obj, get_mob_stat(obj, mob_current_sprite));
					mod_mob(obj,mob_current_sprite,pic,TRUE);
					cy=circle_y(i, radius, y);// the main reason why i could not kill them was b/c i did not set their
					cx=circle_x(i, radius, x);// x/y coords.  now i am setting them.
					DrawImage(MOB, pic, cx, cy, obj, TRUE,0);
					mod_mob(obj,mob_y, cy, TRUE);
					mod_mob(obj,mob_x, cx, TRUE);
					mob_attack(i);// now the eyes can throw fireballs at you
				}//end if
				
				
				if ((q==1) || (q==3)){i+=4;} else {i+=5;}
				q++;obj++;
				if (i>=32){i=i-32;}
				if (q<7){goto redo;}					
		return i;					
							/*  this will add 1k to the code.
							DrawImage(OBJECT, get_object(obj, obj_var2), circle_x(i, radius, x), circle_y(i, radius, y), A_NORMAL,TRUE,0);
							i+=4; if (i>=32){i=i-32;}
							DrawImage(OBJECT, get_object(obj, obj_var2), circle_x(i, radius, x), circle_y(i, radius, y), A_NORMAL,TRUE,0);
							i+=5; if (i>=32){i=i-32;}
							DrawImage(OBJECT, get_object(obj, obj_var2), circle_x(i, radius, x), circle_y(i, radius, y), A_NORMAL,TRUE,0);
							i+=4; if (i>=32){i=i-32;}
							DrawImage(OBJECT, get_object(obj, obj_var2), circle_x(i, radius, x), circle_y(i, radius, y), A_NORMAL,TRUE,0);
							i+=5; if (i>=32){i=i-32;}
							DrawImage(OBJECT, get_object(obj, obj_var2), circle_x(i, radius, x), circle_y(i, radius, y), A_NORMAL,TRUE,0);
							i+=5; if (i>=32){i=i-32;}
							DrawImage(OBJECT, get_object(obj, obj_var2), circle_x(i, radius, x), circle_y(i, radius, y), A_NORMAL,TRUE,0);
							i+=5; if (i>=32){i=i-32;}
							DrawImage(OBJECT, get_object(obj, obj_var2), circle_x(i, radius, x), circle_y(i, radius, y), A_NORMAL,TRUE,0);
							i+=5; if (i>=32){i=i-32;}
							
							//i++; if (i>=32){i=i-32;}
							*/
}// end circle mobs

							
int link_in_range(int loc, int which)
{
	
	// which:
	// 1 - liniar, either x range or y range - returns either 1 for y or 2 for x
	// 2 - for limited distance of all ranges.
	int x=get_mob_stat(loc,mob_x);
	int y=get_mob_stat(loc,mob_y);
	int w=0, h=0;
	if (which==2)// about a 28 pixel radius
	{
		w=mob_stat_flip(loc,mob_w);
		h=mob_stat_flip(loc,mob_h);
		w=x+offset_calculate(x,w);
		h=y+offset_calculate(y,h);
	if (collide(x-26, x+w+26, y-26, y+h+26, link_x+1, 14, link_y+1, 14)){return 3;}}
	else if (which==1)
	{
		if ((x<=link_x) && (x>=link_x)){return 2;}// made for the spikes
		if ((y<=link_y) && (y>=link_y)){return 1;}
	}
	return 0;
}
//=================================================================================================
/*

*/
//=================================================================================================	

void move_constant(int loc, int ani_speed)
{// created for pede, b/c the pede segments only follow the leader
	int d1=mob_x, spd=ani_speed;
		switch (get_mob_stat(loc,mob_dir))
		{
			case right:  break;// the defaults take care of right
			case left:	spd=ani_speed * -1; 					break;
			case up:		d1=mob_y; spd=ani_speed * -1; break;
			case down:	d1=mob_y; 										break;
		}
		mod_mob(loc,d1, spd,FALSE);
}// end move constant
//=================================================================================================
/*

*/
//=================================================================================================



void move_wander(int loc, int ani_speed)
{
		move_constant(loc, ani_speed);// used the same routine, so it was split into 2
		//---------------------------------------------
		// Randomly change directions once in a while
		//---------------------------------------------
		if(!random(80)){change_dir(loc);}
}// end move wander

//=================================================================================================
/*

*/
//=================================================================================================


void move_ghost(int loc, int ani_speed)
{
	
	int d1=up, d2=left, exec=FALSE, dir=get_mob_stat(loc,mob_dir);
	switch (dir)
	{
		case up ... right:	 move_constant(loc, ani_speed); break;
		case upleft: 			 d1=up; d2=left; exec=TRUE;			break;
		case upright: 		 d1=up; d2=right; exec=TRUE; 		break;
		case downleft: 		 d1=down; d2=left; exec=TRUE;		break;
		case downright:		 d1=down; d2=right; exec=TRUE;	break;
	}// end switch
	if (exec)
	{
		// to make the mobs move diagnally, first change the direction of the mob, then move it.
		// then change the dir again and move it again.
		mod_mob(loc,mob_dir, d1,TRUE);
		move_constant(loc, ani_speed);
		mod_mob(loc,mob_dir, d2,TRUE);
		move_constant(loc, ani_speed);
		mod_mob(loc,mob_dir,dir,TRUE);// finally, restore the old direction.
	}// end if exec
	
	if(!random(80)){change_dir(loc);}
	
}

//=================================================================================================
/*

*/
//=================================================================================================

		//---------------------------------------------------
		// Follow makes the mob move towards where Link is.
		//---------------------------------------------------	
void move_follow(int loc, int ani_speed)
{
		    //--------------------------------------------------------------------
			// These routines are pretty simple. Move the mob toward link, while 
			// checking if it hit anything in its path. 
			//--------------------------------------------------------------------
			if (get_mob_stat(loc,mob_x) > link_stat(inv_link_x))
			{
				mod_mob(loc,mob_dir, left, TRUE);
			//	if (!CheckTerrainCollision(get_mob_stat(loc,mob_x)-ani_speed, get_mob_stat(loc,mob_y), 16, 16))
					mod_mob(loc,mob_x, ani_speed* -1, FALSE);
			}
			else
			{
				mod_mob(loc,mob_dir, right, TRUE);
		//		if (!CheckTerrainCollision(mod_mob(loc,mob_x)+ani_speed, mod_mob(loc,mob_y), 16, 16))
					mod_mob(loc,mob_x, ani_speed, FALSE);
			}
				
			if (get_mob_stat(loc,mob_y) > link_stat(inv_link_y))
			{
				mod_mob(loc,mob_dir, up,TRUE);
		//		if (!CheckTerrainCollision(get_mob_stat(loc,mob_x), get_mob_stat(loc,mob_y)-ani_speed-2, 16, 16))
					mod_mob(loc,mob_y, ani_speed* -1, FALSE);
			}
			else
			{
				mod_mob(loc,mob_dir, down, TRUE);
			//	if (!CheckTerrainCollision(get_mob_stat(loc,mob_x), get_mob_stat(loc,mob_y)+ani_speed, 16, 16))
					mod_mob(loc,mob_y, ani_speed, FALSE);
			}	
}// end move follow






//=================================================================================================
/*

*/
//=================================================================================================
		//---------------------------------------------------------------------
		// Move randomly - doesnt check for collision - (example: BUTTERFLY1)
		//---------------------------------------------------------------------

void move_flutter(int loc)
{
			//------------------------------------------------------------------------------------
			// These cases make the mob flutter towards a certain direction
			// 2-random(5) means the range of numbers is: -2 -1 0 1 2, meaning there is an equal opportunity to go any direction.
			// 2-random(2) means the range of numbers is: 1 2, meaning it moves toward a direction
			//------------------------------------------------------------------------------------
		int d1=0, spd=0;
			switch (get_mob_stat(loc,mob_dir))
			{
				case up: 		d1=(2-random(2))* -1; spd=2-random(5);	break;
				case right: d1=2-random(5); spd=2-random(2);				break;
				case down:  d1=2-random(2); spd=2-random(5);				break;
				case left: 	d1=2-random(5); spd=(2-random(2))* -1;	break;
			}
					mod_mob(loc,mob_y, d1, FALSE);
					mod_mob(loc,mob_x, spd, FALSE);
			//---------------------------------------------
			// Randomly change directions once in a while
			//---------------------------------------------
			if(!random(20))
			{
				mod_mob(loc,mob_dir, -1, FALSE);
				if (get_mob_stat(loc,mob_dir) < up)
					mod_mob(loc,mob_dir, right, TRUE);
			}
}// end move flutter


//=================================================================================================
/*

*/
//=================================================================================================

void move_wizard(int loc, int ani_speed)
{
	
	// no you need to base everything off of var2
	// once he hits a certain number, then make him move between those numbers
	// once he hits a higher number, make him blink
	// once he hits a higher number, make him go under ground
	// once he hits another number, make him teleport and reset number.
	int v=get_mob_stat(loc,mob_rand_var2);

	switch(v)
	{
		case 0 ... 80:  move_wander(loc, ani_speed); break;
		case 81 ... 100: // make the guy blink
				if (v%3) {mod_mob(loc,mob_underground,3, TRUE);} else {mod_mob(loc,mob_underground,0, TRUE);}  break;
		case 101 ... 157: mod_mob(loc,mob_underground,3, TRUE); mod_mob(loc,mob_pause,-1,TRUE);break;
		default:
			mod_mob(loc,mob_underground,0, TRUE);
			mod_mob(loc,mob_frame,0,TRUE);
			mod_mob(loc,mob_pause,2,TRUE);
			mod_mob(loc,mob_rand_var2,0,TRUE);
			mod_mob(loc,mob_y, 32, FALSE);
			random_mob_placer(loc);// make him warp. - break intentionally left out.
			return;	
		break;
	}
	v++; 
	if(!random(22)){v+=2;}// randomly increase him 2 instead of 1, just to mess with the algos so he cant be
	if(!random(44)){v++;}// as predictable.
	mod_mob(loc,mob_rand_var2,v,TRUE);
}

//=================================================================================================
/*

*/
//=================================================================================================

void move_bat(int loc, int ani_speed)
{
	if (link_in_range(loc, 2) == 3){move_follow(loc, ani_speed);}
	else{
			mod_mob(loc,mob_frame,0,TRUE);
			mod_mob(loc,mob_pause,2,TRUE);
		}// end else
}// end move bat
//=================================================================================================
/*

*/
//=================================================================================================
/*
void move_random(int loc, int ani_speed)
{
	if (get_mob_stat(loc,mob_rand_var1)>222){
		switch (random(5))
		{
			case 0:		move_wander(loc, ani_speed);  					break;
			case 1:		move_follow(loc,ani_speed);							break;
			case 2:		move_bat(loc,ani_speed);								break;
			case 3: 	move_wizard(loc,ani_speed);   					break;
			case 4:		move_ghost(loc, ani_speed);							break;
		}// end switch
	}// end if >222
}
*/



void move_mob(int loc, int move_type, int ani_speed)
{

	// do not move is paused.
	if (get_mob_stat(loc,mob_pause)>0){mod_mob(loc,mob_pause,-1,FALSE);return;}


	switch (move_type)
	{
		case MOB_WANDER:			move_wander(loc, ani_speed);  					break;
		case MOB_FLUTTER:			move_flutter(loc);											break;
		//case MOB_HOP:					move_hop(loc,ani_speed);								break;
		case MOB_FOLLOW:			move_follow(loc,ani_speed);							break;
		case MOB_BAT:					move_bat(loc,ani_speed);								break;
		case MOB_WIZARD: 			move_wizard(loc,ani_speed);   					break;
		case MOB_CONSTANT:		move_constant(loc, ani_speed); return;	break;
		case MOB_GHOST:				move_ghost(loc, ani_speed);							break;
//		case MOB_CIRCLE_EYE:	move_circle_eye(loc, ani_speed); 				break;
	//	case MOB_CIRCLER:			return;	break;// this is handled by mob circle eye.
//		case MOB_RANDOM:		move_random(loc, ani_speed);						break; 
	}// end switch
	
	prevent_mob_oob(loc);
	// mob_stops is used to slow the mob even more, but only if it has a number >=5
	if (get_mob_stat(loc,mob_stops)>=5){mod_mob(loc,mob_pause,get_mob_stat(loc,mob_stops)-4,TRUE);}

}//end move mob
