// C Source File
// Created 10/11/2012; 9:52:53 PM

#include <tigcclib.h>
#include "all.h"
#include "start.h"
#include "story_line.h"
#include "inventory.h"


//=================================================================================================
/*
			these routines handle the beginning and ending screens.
*/
//=================================================================================================



extern int link_x, link_y, link_picture, exited, link_direction,current_warp,skip_animate_mob;

extern int keya, keyb,keyl, keyr,keyu,keyd, keys,current_game,slowdown, loop, ter_ani_speed;


//=================================================================================================
/*
		draw_beg_screen() will display the beginning screen, while setting the direction of link so things
		will display corretly. 
*/
//=================================================================================================
void draw_beg_screen()
{
		clr_planes();
		set_object_animate_info(0, down, FALSE);// set links direction to be down, so things will work right
		DrawTerrain(0);
}// end draw_beg_screen()

//=================================================================================================
/*
		screen_ready() will draw the begging screens.   Link x/y coordinates must be set corretly
		for it to work.  otherwise, it will not load the corret room.  Due to the funny way greyscale
		works, this has to be separate from draw_beg_screen(), just so i can load things in parts or
		in whole, so it will look right.
*/
//=================================================================================================
void screen_ready(int x, int y)
{
		mod_link(map_x,x,TRUE);
		mod_link(map_y,y,TRUE);
		link_x=0, link_y=0;
		set_inv_xy();
		mod_link(inv_link_speed,4, TRUE);
		get_map_vars();	
		draw_beg_screen();
}// end screen_ready(int x, int y)

//=================================================================================================
/*
		reload() will load an overworld map, a world map, and then place link onto that map into the
		correct room.
*/
//=================================================================================================
void reload()
{
				mod_link(ow_id, 32000,TRUE);// *WARNING* dont remove this or put below init_terrain() - read 	notes.c (* 12/27/13 *)
				current_warp=(-666);// make sure it gets the warp file
				mod_link(map_x, link_stat(save_map_x),TRUE);
				mod_link(map_y, link_stat(save_map_y),TRUE);
				init_terrain(link_stat(save_ow_id), link_stat(save_world_map));
				link_x = link_stat(save_x);
				link_y = link_stat(save_y);
				set_inv_xy();
				mod_link(inv_link_speed,4, TRUE);// set his speed so it can be accessed in ezelda
				restore_link_config();
				skip_animate_mob=FALSE;
}// end reload()

//=================================================================================================
/*
		select_menu() is the menu screen after the ZELDA screen.  It is where you choose what save 
		you want to play with.  First, it gets each save file and stores specific info into an array.
		Then it displays that info on the screen.
*/
//=================================================================================================

void select_menu()
{
	
	int y=11, key=0, pause =6660;
	int tmp[3][8];
	int i=0,hy=11;//hx=40,
	char n[7];
	onceagain:
	//------------------------------------------------------------------
	//  load the 3 save files and store the info into tmp[][].
	//------------------------------------------------------------------
	for (i=0;i<3;i++){
		if (get_inv(i+1))// if you get the save file, then add it do the disp list
		{
			tmp[i][0]=link_stat(max_hp);
			tmp[i][1]=link_stat(rupies);
			tmp[i][2]=link_stat(link_letter_1);// save link's name
			tmp[i][3]=link_stat(link_letter_2);
			tmp[i][4]=link_stat(link_letter_3);
			tmp[i][5]=link_stat(link_letter_4);
			tmp[i][6]=link_stat(link_letter_5);
			tmp[i][7]=link_stat(link_letter_6);
		}
		else
		{
			tmp[i][0]=(-5);// failsafe
		}
	}// end for
	
			screen_ready(0, 1);

	beg:
			//------------------------------------------------------------------
			//  draw the 3 save files, if they exist.
			//------------------------------------------------------------------
			if (pause>500){
				link_picture++;
				if (link_picture>1){link_picture=0;}
				pause =0;

						draw_beg_screen();
					DrawImage(LINK, link_picture, 12, y, A_NORMAL, TRUE,0);
					
					for (i=0;i<3;i++){// draw the hearts
							if (tmp[i][0]>=24){// if hp>= 3 hearts then show the info
									mod_link(max_hp,tmp[i][0],TRUE);// forces it to draw full hearts
									mod_link(hp,tmp[i][0],TRUE);
									draw_hearts2(80, hy,0);
									DrawImage(OBJECT, CRYSTAL1, 47, hy+12, A_NORMAL, FALSE,0);
								}// end if >=24
								hy+=24;
					}//end for
					hy=16;
					save_scr();
					for (i=0;i<3;i++){// display the names and rupies
						if (tmp[i][0]>=24){
								sprintf(n,"%c%c%c%c%c%c ",tmp[i][2],tmp[i][3],tmp[i][4],tmp[i][5],tmp[i][6],tmp[i][7]);// quest
								GrayDrawStr(40,hy,n,0);
								sprintf(n, "%i \0", tmp[i][1]);	
								GrayDrawStr(59,hy+11,n,0);
							}// end if >=24
						hy+=24;
					}// end for
			}// end if pause>350
				
		hy=11;
		
			key = get_key();
					switch (key)
					{
						case a_ko:
						keya=TRUE;
							//------------------------------------------------------------------
							//  if a save exists, then load it.
							//------------------------------------------------------------------
							if (get_inv(((y-11)/24)+1))
							{	// 62502
					
							if (link_stat(zelda_game_number)==g_over_world_stat(overworld_game_num, 999)){
									reload();	goto end;
									}else {msg(1,19,FALSE,message);goto delthis;}
							
							
								}
							//------------------------------------------------------------------
							// if a save file does not exist, then get the name and pull the 
							// storyline file in order to set begging map and stats.
							//------------------------------------------------------------------
							else
							{	

									//------------------------------------------------------------------
									//  clear out the inventory to prevent overlapping of save files, 
									// 	however, make sure it is above the name_screen() and get_story()
									//  otherwise it will zero out the info.
									//------------------------------------------------------------------
									clr_inv();
																		
									current_game=((y-11)/24)+1;// set the save file ID#
									if (!name_screen()){goto onceagain;}// so you can esc out of the name screen
									get_story(1);// pull the storyline file	
									story_main();// execute the storyline file.
									slowdown=2;// set the slowdown to the default of 2, so it doesnt run too fast.
									goto end;	
							}
						break;
						case start_ko:// this will be where you delete a section.
						
						keys=TRUE;
								msg(1,11,FALSE,message);
								delthis:
								if (ynbox()){delete_save(((y-11)/24)+1);y=11;}
								goto onceagain;
						break;
						case down_ko:
							y+=24;
							if (y>59){y=11;}
							keyd=TRUE;
						break;
						case up_ko:
							y-=24;
							if (y<11){y=59;}
							keyu=TRUE;
						break;
						case esc_ko:// allows me to quit if i wish.
							exited=TRUE;
							goto end;
						break;
						case 9:// reset the keys, otherwise they will repeat.
							all_keys_unpressed();
						break;
					}// end switch 
			pause++;

	goto beg;
	end:
}// end select menu


//=================================================================================================
/*
			the name screen will allow the user to create a name for link.  Instead of having a number
			to Char translation for the characters, I exploit an error, where i pass an int into char,
			which will force a char of that ascii # to display.  Works on the Ti-89 titanium, but not
			too sure about the other calculators.
*/
//=================================================================================================
int name_screen()
{
		
		screen_ready(0, 2);

	int x=36, key=0, pause =5000;
	int n[]={0,0,0,0,0,0};// this is used for the name.  the name is stored in variables.
	int i=0,k=0;
	char t[1];
	beg:
			if (pause>400){
			
				pause=0;
				draw_beg_screen();
				disp_pointer(x,64);
				save_scr();
				
				GrayDrawStr(8,8, "Use the up and down keys",0);
				GrayDrawStr(8,17,"to choose a letter. Use ",0);
				GrayDrawStr(8,26,"  left & right to move. ",0);
				GrayDrawStr(8,80,"Press F1 to confirm name",0);
				
				//------------------------------------------------------------------
				//  display the chosen letters for links name
				//------------------------------------------------------------------				
				
				for (i=36;i<=116;i+=16){if (k<6){sprintf(t,"%c",n[k]);add_print(i,49,t);}k++;} 
			}
				
			k=0;
					//------------------------------------------------------------------
					//  choose a letter loop
					//------------------------------------------------------------------		
			key = get_key();
					switch (key)
					{
						case a_ko:// force it to become the letter "A"
							keya=TRUE;
							n[((x-36)/16)]=65;// the Letter A
							pause=444;
						break;
						case b_ko:
							keyb=TRUE;
							n[((x-36)/16)]=0;// clears out the letter.
							pause=444;
						break;
						case right_ko:
							x+=16;
							if (x>116){x=36;}
							keyr=TRUE;
							pause=444;
						break;
						case left_ko:
							x-=16;
							if (x<36){x=116;}
							keyl=TRUE;
							pause=444;
						break;
						case up_ko:
							keyu=TRUE;
							n[((x-36)/16)]++;
							pause=444;
						break;
						case down_ko:
							keyd=TRUE;
							n[((x-36)/16)]--;
							pause=444;
						break;
						case start_ko://save name to array.  
							keys=TRUE;
							//------------------------------------------------------------------
							// this will set the name you choose to links save array
							//------------------------------------------------------------------
							for (i=0;i<6;i++){mod_link(link_letter_1+i,n[i],TRUE);}
							goto end;
						break;
						case esc_ko:
							return FALSE;
						break;
						case 9:
									all_keys_unpressed();
									break;
					}// end switch 
				 
			//pause++;

	goto beg;
	end:
	return TRUE;
}// end name screen

//=================================================================================================
/*
		st_game() displays the beginning screen.
*/
//=================================================================================================
void st_game()
{
	int i=0;
	beg:

		screen_ready(0, 0);
		save_scr();
		
		loop+=5;// this var is used for the animation.
		if (loop>ter_ani_speed){loop=0;s_animate(g_animate()+1);}
		if (g_animate()>=4){s_animate(0);}// this is good for the right left}
		
		
		add_print(16,86, "     Simple Quest");
										//crystalline destiny
		add_print(25,7, " Press F1 to Begin");
		for (i=0;i<500;i++){if (get_key()==start_ko){keys=TRUE; return;}}
		//------------------------------------------------------------------
		//  wait for f1 (the start key) to be pressed.
		//------------------------------------------------------------------

		goto beg;
};//end start game.	*/


//=================================================================================================
/*
			After link dies, game_over() is called.  It will display the black screen and allow you to
			choose if you want to save, continue, or quit.
*/
//=================================================================================================
void game_over()
{
		//------------------------------------------------------------------
		//  first, save the basic map info so link can reload to the same
		//  map where he died.  This is done because, the beginning screens
		//  are based off another map, so the maps change.  This will allow
		//  the maps to change back.
		//------------------------------------------------------------------	
		set_link_save_info();
		save_link_config();

		int key=0;
		mod_link(state,LINK_NORMAL,TRUE);// return him back to normal
		init_terrain(999,999);//load the beginning stuff
		screen_ready(0, 3);
		draw_beg_screen();
		save_scr();

		//------------------------------------------------------------------
		//  display the words on the game over screen:
		//------------------------------------------------------------------
		GrayDrawStr(34,8, "  GAME  OVER!!  ",0);
		GrayDrawStr(55,34," Save ",0);
		GrayDrawStr(55,54," Continue ",0);
		GrayDrawStr(55,74," Quit ",0);

//------------------------------------------------------------------
//  loop for the key pressing events
//------------------------------------------------------------------
	beg:
	key= inv_selector(45,45, 45, 0, 32, 32, 72, 20, 1, white_arrow)	;
	
		switch (key)
		{
			case 32:// save
				mod_link(hp,24,TRUE);// reset his hp to 24
				save();
				exited=3; // this will take you back to the beginning screen.
				goto end;
			break;
			case 52://continue
				exited=FALSE;
				link_direction=down;
				mod_link(hp,24,TRUE);
				reload();// reload the map where he died from	
				goto end;
			break;
			case 72://quit
				exited=TRUE;goto end;
			break;
		}
		goto beg;
		
		end:
		
}// end game_over()

//=================================================================================================
/*
			delete_save() does as it suggests: it deletes all save info inside of a save folder.
*/
//=================================================================================================

void delete_save(int fle)
{

	char sav[5];//, sav2[20];

    sprintf(sav,"zsv%i",fle);

 		
 		TRY
 			FolderClear(SYMSTR (sav));
 		ONERR
 		ENDTRY	

    

}

//------------------------------------------------------------------
//
//------------------------------------------------------------------

//=================================================================================================
/*

*/
//=================================================================================================