/*******************************************************************************/
/* Zelda Crystal Engine v0.9                                                   */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/



#include <tigcclib.h>                    //Include All Header Files
#define EXECUTE_IN_GHOST_SPACE
#include "all.h"
#include "story_line.h"
#include "start.h"

/*---------------------------------------------------------------------------*/
/* Global Variables                                                          */
/*---------------------------------------------------------------------------*/

char *light = 0;                         //Pointer to virtual light plane
char *dark = 0;                          //Pointer to virtual dark plane

INT_HANDLER save_int_1;                  //Save interrupt 1 (replaced with DUMMY_HANDLER)

int exited = FALSE, mobs_loaded=FALSE, shop_active=FALSE; 



//--------------------------------------
// Global Variables pertaining to Link
//--------------------------------------
int link_x = 5*16;                       //Link's x position on the screen
int link_y = 5*16;                        //Link's y position on the screen

int link_speed = 4, link_speed_adjust=0;//How fast link is walking (in pixels)
// link_speed_adjust is the speed the mobs and link are adjusted in the config.


int link_direction = down;               //Direction link is facing
int button_pressed=0;// this is used for hold_a or hold_b, so we can get the info from that hold
// pos in other routines 
int link_picture = LINK_NORMAL;        //Stores current picture of Link.
int debug_mode=FALSE;// this allows me to use debug ingame if need be, w/o recoding.
int   link_frame = 0, ter_ani_speed=4, link_frame2=0, current_game=0;  
//link_frame - Keeps track of link's frame #.
// current game is used for the current save file.  you could use this later on when you make it more zelda like.
// you can force save to use current game as the save.  then continue to set the current game.  it basically holds
// the current save file.
extern int keya, keyb, current_gfx_file,current_mob_gfx, keyu,keyd,	last_story,current_warp,
						heart_x,heart_y,disp_hearts, dark_room,skip_animate_mob;
int loop=0;//this is used for the terrain animation
int slowdown=0; // this puts a speed limiter and slows down the game the higher the number
void DrawScreen();



//------------------------------------------------------------------
//  folder_check checks to see if the folders exists on the system.
//  if not, then it will either error out or create them.
//  the save folders are not vital to running the game, so they 
//  cease to exists and the game still run.  however, the other 
//  folders are vital to the game, so error out if they dont exist.
//------------------------------------------------------------------

int folder_check()
{

			char sav[6];
			int i=0;
		redo:	
			switch (i)
			{
				case 0: sprintf(sav,"maps"); 	break;
				case 1: sprintf(sav,"sl"); 		break;
				case 2: sprintf(sav,"items"); break;
				case 3: sprintf(sav,"msgs"); 	break;
				case 4: sprintf(sav,"mobs"); 	break;
				case 5: sprintf(sav,"gfx"); 	break;
				case 6: sprintf(sav,"rooms"); break;
				case 7: sprintf(sav,"etc"); 	break;
				case 8: goto done; 						break;
			}
			if (FolderFind(SYMSTR (sav))==NOT_FOUND) {printf("\n%s folder not found",sav); return TRUE;}
			i++;
		goto redo;
		done:	

   	for (i=1;i<4; i++) {
		    sprintf(sav,"zsv%i",i);			
				
				TRY
					if (FolderFind(SYMSTR (sav))==NOT_FOUND)	{FolderAdd (SYMSTR (sav));}
				ONERR
				ENDTRY
		}
		return FALSE;
}// end folder_check()
/*===========================================================================*/
/* Main Function                                                             */
/*===========================================================================*/
/*void test()
{
	GrayFillScreen2B_R(GrayGetPlane(light), GrayGetPlane(dark), 0xffffffff, 0xffffffff);
}
void tester()
{

		
		which--;// it will allow from 1 to 90 in the sl section, so to prevent

	if ((which<0) || (which>=(inv_cols*3))){return 555;}

	int a=inv_treasure_loc+((int)(which/inv_cols));// get the correct spot.

	int i= g_inv(a,which);
	if (i>TRUE){i=TRUE;}// true for have gotten the treasure - flase for not have gotten it.
	else if (i<FALSE){i=FALSE;}// this is so it will only return true or false.
	// however, if it returns 555, then you have an error
	
	}//*/
/*		
		set_planes(light, dark);
	///	DrawTerrain(0);
	int radius=24;
			int i=0,item=0, obj=0;
			float k=.1,q=0;
			float tmp[2][32];
										item=9005;
							obj=add_object(item, 0, 0,item);
							
							set_object(obj,obj_dam, get_item_info(item,item_damage));
							set_object(obj,obj_var2, get_item_info(item,item_pic_id));
							set_object(obj, obj_type, get_item_info(item,item_type));
							
							
							for (i=0;i<32;i++)
							{
								tmp[0][i]=cos(k);//+q)*radius  +72;
								tmp[1][i]=sin(k);//+q)*radius +42;
								k+=.2;
								//q+=.9;
								//if (q>5.4){q=0;k+=.2;}
							}// end for		
							i=0;
							k=.1;					
						for (q=0;q<1000;q++)
						{
// k-.1, 1, 2.1, 3.2... (foir 6)
// .9 for 7
								clr_planes();
						//	xpos= cos(i)*radius + xpos_of_center_creature
							DrawImage(LINK, link_picture, 72, 42, A_NORMAL, TRUE,0);
						//	DrawImage(OBJECT, get_object(obj, obj_var2), (int)tmp[0][i] , (int)tmp[1][i] , A_NORMAL,TRUE,0);
							DrawImage(OBJECT, get_object(obj, obj_var2), tmp[0][i]*radius +72, tmp[1][i]*radius + 42, A_NORMAL,TRUE,0);
							i+=4; if (i>=32){i=i-32;}
							DrawImage(OBJECT, get_object(obj, obj_var2), tmp[0][i]*radius +72, tmp[1][i]*radius + 42, A_NORMAL,TRUE,0);
							i+=5; if (i>=32){i=i-32;}
							DrawImage(OBJECT, get_object(obj, obj_var2), tmp[0][i]*radius +72, tmp[1][i]*radius + 42, A_NORMAL,TRUE,0);
							i+=4; if (i>=32){i=i-32;}
							DrawImage(OBJECT, get_object(obj, obj_var2), tmp[0][i]*radius +72, tmp[1][i]*radius + 42, A_NORMAL,TRUE,0);
							i+=5; if (i>=32){i=i-32;}
							DrawImage(OBJECT, get_object(obj, obj_var2), tmp[0][i]*radius +72, tmp[1][i]*radius + 42, A_NORMAL,TRUE,0);
							i+=5; if (i>=32){i=i-32;}
							DrawImage(OBJECT, get_object(obj, obj_var2), tmp[0][i]*radius +72, tmp[1][i]*radius + 42, A_NORMAL,TRUE,0);
							i+=5; if (i>=32){i=i-32;}
							DrawImage(OBJECT, get_object(obj, obj_var2), tmp[0][i]*radius +72, tmp[1][i]*radius + 42, A_NORMAL,TRUE,0);
							i+=4; if (i>=32){i=i-32;}
							
						//	DrawImage(OBJECT, get_object(obj, obj_var2), tmp[0][i+6] +72, tmp[1][i+6] + 42, A_NORMAL,TRUE,0);

	
						//	DrawImage(OBJECT, get_object(obj, obj_var2), cos(k)*radius +72, sin(k)*radius + 42, A_NORMAL,TRUE,0);
							DrawImage(OBJECT, get_object(obj, obj_var2), cos(k+.9)*radius +72, sin(k+.9)*radius + 42, A_NORMAL,TRUE,0);
							DrawImage(OBJECT, get_object(obj, obj_var2), cos(k+1.8)*radius +72, sin(k+1.8)*radius + 42, A_NORMAL,TRUE,0);
							DrawImage(OBJECT, get_object(obj, obj_var2), cos(k+2.7)*radius +72, sin(k+2.7)*radius + 42, A_NORMAL,TRUE,0);
							DrawImage(OBJECT, get_object(obj, obj_var2), cos(k+3.6)*radius +72, sin(k+3.6)*radius + 42, A_NORMAL,TRUE,0);
							DrawImage(OBJECT, get_object(obj, obj_var2), cos(k+4.5)*radius +72, sin(k+4.5)*radius + 42, A_NORMAL,TRUE,0);
							DrawImage(OBJECT, get_object(obj, obj_var2), cos(k+5.4)*radius +72, sin(k+5.4)*radius + 42, A_NORMAL,TRUE,0);
							k+=.2;// the lower the .xx, the slower it goes. - .2 is fast
							
						//	if (k>12){radius+=8;k=0;}

						//	sprintf(dbg,"%f %f %i",tmp[0][i], cos(k), i);
					//		debug();
							i++;//k+=.2;
							if (i>=32){i=i-32;radius+=8;}
							save_scr();
							slow(20*250);slow(20*250);
						//	wait_for_key(esc_ko);
						}
						wait_for_key(b_ko);
						//DrawImage(LINK, link_picture, 42, 16, A_NORMAL, TRUE,0);
						
						printf("\n%i %i %i ",obj, get_item_info(item,item_damage), get_item_info(item,item_pic_id));
						wait_for_key(esc_ko);

}// delete me8*/

void clr_all()
{
			// clear out global variables and arrays
				current_gfx_file=0;current_mob_gfx=0; 
				shop_active=FALSE, last_story=0;current_warp=0;
				current_game=0;skip_animate_mob=FALSE;
				all_keys_unpressed();
				clr_inv();
				clr_object();
				clr_room();
				clr_warp();
				clr_dung_map();
				clr_mob_list(1);
				clr_mob_list(2);
				clr_exec_sl();

}

void exit_or_reset()
{
	printf("\npress esc to exit or F1 to reset calculator");
	beg:
		switch(get_key())
		{
			case esc_ko: return;
			case start_ko: OSReset(); break;
		}
	goto beg;
}

void _main(void)
{

	clrscr();// clear the screen so i can see the errors displayed.

	
		if (folder_check()){printf("\npress esc to quit");wait_for_key(esc_ko);goto no_dll;}
		
		TRY
				OSSetSR (0x0700);// disable all interrupts
				OSSetSR (0x0000);// reenable all interrrupts
		ONERR
		ENDTRY


	int ld_dll=FALSE;// variable used to let me know if the dll loading failed. 

		TRY// try loading the dll
			 switch(LoadDLL ("ezelda", 2015, 3, 1)) 
		   {
				case DLL_OK: 						printf("dll loaded");	ld_dll=TRUE;			 	break;
				case DLL_OUTOFMEM:			printf("Ran out of memory loading DLL.");	break;
				case DLL_NOTFOUND:			printf("DLL not found.");									break;
				case DLL_LOCKFAILED:		printf("Couldn't lock DLL.");							break;
				case DLL_WRONGVERSION:	printf("DLL is wrong version.");					break;
				default:		printf("Unknown error loading DLL: ???");							break;
				}// end switch
		ONERR
		ENDTRY

	if (!ld_dll){printf("\ndll loading failed.");exit_or_reset();	goto no_dll;}

		TRY// malloc out the planes
			dark = malloc(LCD_SIZE);
			light = malloc(LCD_SIZE);
		ONERR
			printf("malloc failed"); goto stopgame;
		ENDTRY	



			//------------------------------------------------------------------
			// Install DUMMY Interrupt, to use _rowread and grayscale together
			//------------------------------------------------------------------	
		TRY
			save_int_1 = GetIntVec (AUTO_INT_1);
			SetIntVec(AUTO_INT_1, DUMMY_HANDLER);
			if (!GrayOn()) {printf("\nGraycale failed"); exit_or_reset();goto end;} //turn on greyscale
		ONERR
			printf("interrupt install failed");	goto stopgame;
		ENDTRY

char a1[70],a2[70];// used for debug mode

int st=0;
restart:// label used to go back to the beginning screen


	
		TRY	// clear out global variables and arrays
				clr_all();
				// load default gfx files and lists that dont change 
				link_gfx_loader(1);// load by default
				object_gfx_loader(1);// load by default
				get_item_list(1);// grab the items
				get_proj_list(1);// grab the enemies weapons
				fill_circle_values(); // this will fill the sin/cos values of the circle array
		ONERR
				disp_error("array init failed");  goto stopgame;
		ENDTRY
		
		
		

		TRY // main game
	//tester();

			exited=FALSE;
			
			// call the beginning screens
			set_planes(light, dark);
			
			mod_link(ow_id, 32000,TRUE);// this will allow the init_terrain() below to always start.
			if (!init_terrain(999,999)){goto stopgame;}//load the beginning stuff
			
			
			st_game();
			select_menu();
			
			if (link_stat(hp)<24){mod_link(hp,24,TRUE);}// always start with a minimum of 24 hp
		
			//debug_mode=TRUE;// force to start in debug mode - for testing purposes only
	//		slowdown=2;
beg:// starting label for the main game loop
		//printf("e");	
			if (debug_mode){
				
					GrayDrawRect(0,0,107,16,COLOR_WHITE,RECT_FILLED);
					sprintf(a1,"Room x=%i y=%i w=%i",link_stat(map_x), link_stat(map_y), oob()); 
					sprintf(a2,"Link x=%i y=%i ",link_x, link_y);
					add_print(0,0,a1);
					add_print(0,8,a2);//*/
			//	if (get_room_info(mobs_killed)==FALSE){
			///			set_room_info(mobs_killed,TRUE);
			//			clr_mob_list(1);
			//		}
					
				}// end if debug_mode
				st=link_stat(state);
				// if link is not stunned or dead, then you can use the keys
				if ((st!=LINK_STUN) && (st!=LINK_DEAD)){keypress();}
		
				DrawScreen();//call main loop that displayes and animates everything.
				if (exited==3){goto restart;}				
				else if (exited){goto end;}// made for the continue thing.
				
goto beg;
			
			
		ONERR
			disp_error("main game failed");	goto stopgame;
		ENDTRY	

stopgame:// if the game crashes, at least attempt to display an error message
	printf("\nsomething failed. press esc to exit");
	wait_for_key(esc_ko);

end:
		TRY
			clr_all();
			GrayOff();

		ONERR
		ENDTRY	

		TRY
			//---------------------------------
			// Restore the original interrupt
			//---------------------------------
		
			SetIntVec(AUTO_INT_1, save_int_1);
			OSSetSR (0x0700);// disable all interrupts
		ONERR
		ENDTRY
		
		TRY// this is seperate, just in case i loaded the dll but it failed at the above try.
			if (ld_dll){UnloadDLL();}// to prevent an address error.
		ONERR
		ENDTRY
		
		TRY
			free(light);
			free(dark);
		ONERR
		ENDTRY	
		


no_dll:
	FolderCur(SYMSTR("main"),TRUE);// reset back to main folder. 

}



/*===========================================================================*/
/* DrawScreen() animates everything                                          */
/*===========================================================================*/

void DrawScreen()
{
	//--------------------------------------------
	// Clears the screen and puts it into the dll
	//--------------------------------------------
	
	clr_planes();
	set_planes(light, dark);
	
	//-------------------------------
	// Animate and Draw terrain
	//-------------------------------
	
	DrawTerrain(link_y);
	slow(slowdown*250);
	//-----------------------------------------------------------------
	// send link info to dll - reduces arguments to pass into routines
	//-----------------------------------------------------------------
	set_object_animate_info(button_pressed, link_direction, dark_room);// do this before animating anything

	//--------------------------------------------------------------
	// the below animates things - names should be self explanitory
	//--------------------------------------------------------------

	
	AnimateObject();slow(slowdown*250);
	AnimateMob();slow(slowdown*250);

	//-------------------------------------------------
	// Check to see if link is dealt damage or is dead
	// but if link is being healed via faerie, do not
	// make him dead.  skip_animate_mob is only set when
	// link is being healed by a faerie.
	//-------------------------------------------------
	if (!skip_animate_mob){
		if (touch_mob(link_x, link_y, LINK)!=555){pain(LINK,0,0,0);}
		if (link_stat(hp)<=0){md_link(state,LINK_DEAD,TRUE);}}
	
	AnimateLink();slow(slowdown*250);

	if (link_stat(dual_state)!=LINK_HOLE_FALL){hole_walkling();}// test to always see if you are walking on a hole. 
	
	//--------------------------------------
	// Copy virtual screens to real screen
	//--------------------------------------
	
	save_scr();

	//-------------------------------------------------
	// display the prices if a shop is active
	//-------------------------------------------------	
	
	if (shop_active){draw_prices();}

	//-------------------------------------------------
	// the below animates the terrain, by using "loop"
	//-------------------------------------------------
	slow(slowdown*250);
	loop++;// this var is used for the animation.
	if (loop>ter_ani_speed){loop=0;s_animate(g_animate()+1);}
	if (g_animate()>=4){s_animate(0);}// this is good for the right left}

}// end DrawScreen()


//=================================================================================================

//=================================================================================================



