// Header File
// Created 7/18/2011; 12:23:49 AM

//  link stats location defines.  you should define the mobs in the same manor.

/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#define hp 0
#define max_hp 1
#define mana 2
#define max_mana 3
#define rupies 4
#define max_rupies 5
#define hold_a 6
#define hold_b 7
#define hold_c 8
#define hold_d 9
#define worn_a 10
#define worn_b 11
#define worn_c 12
#define worn_d 13
#define max_bombs 14
#define max_arrows 15
#define map_id 16
#define map_x 17 // this was originally for the world[][], but since world[][] is gone, it will be
#define map_y 18 // used for the rset anyways.
#define inv_link_x 19 // used for the ezelda so we know where link is located.
#define inv_link_y 20
//#define room_x 19// may not be needed anymore since the 4x4 is gone
//#define room_y 20
#define hc_pieces 21
#define def 22
#define state 23
#define hold_a_amt 24  // if you mod these then you will have to mod switch_item(), too in inventory.c
#define hold_b_amt 25
#define hold_c_amt 26
#define hold_d_amt 27
#define link_blink 28
#define dual_state 29// this exists so link can return back to his previous state

#define save_x 30 // link xpos to reload at after save or continue.
#define save_y 31
#define save_rset_id 32 // this is used to save the starting rset when link reloads himself from a save or dies and then continues.
#define rset_id 33 // used to store the temp rset, instead of using a global var
#define save_ow_id 34 // when link loggs out, set the default id to this and where he will repop.
#define link_rand_var1 35
#define link_letter_1 36// these are for link's name
#define link_letter_2 37
#define link_letter_3 38
#define link_letter_4 39
#define link_letter_5 40
#define link_letter_6 41
#define inv_link_speed 42
#define ow_x 43 // this will tell us where we are on the overworld[][]
#define ow_y 44
#define ow_id 45 // this will save the current overworld id #, so i can avoid another global var
#define save_map_x 46 // this is used to save the current x/y coord of rset so link can reload there
#define save_map_y 47
#define save_world_map 48
//#define link_rand_var2 42
#define save_heart_xpos 49
#define save_heart_ypos 50
#define save_animation_speed 51
#define save_disp_hearts 52
#define save_debug_mode 53
#define save_speed_limiter 54
#define zelda_game_number 55 // this is specifically use to know which game you are playing.  if not the same, then delete


#define up 0
#define down 1
#define left 2
#define right 3
// diagnal directions for the ghosts.
#define upleft 4
#define upright 5
#define downleft 6
#define downright 7

// directions for the diagnal objects
// 30 is for a slight diagnal increase
// 40 is for the larger diagnal increase
#define up_30_left 10
#define down_30_left 11
#define left_30_left 12
#define right_30_left 13

#define up_30_right 20
#define down_30_right 21
#define left_30_right 22
#define right_30_right 23

#define up_45_left 30
#define down_45_left 31
#define left_45_left 32
#define right_45_left 33

#define up_45_right 40
#define down_45_right 41
#define left_45_right 42
#define right_45_right 43

#define hold 1
#define bag 2
#define either 6// this is for either hold or bag

#define TERRAIN 0
#define MOB 1
#define LINK 100
#define OBJECT 3

//State when he is just standing
#define LINK_NORMAL   0

//State when player pushes the movement keys
#define LINK_WALK     1

//State when Link thrusts his sword
#define LINK_THRUST   2
#define LINK_THRUST2  3
#define LINK_SPIN_SLASH 10
#define LINK_WALKING_SWORD 11
#define LINK_REEL_BACK 12
#define LINK_STUN 13
#define LINK_PUSH 14
#define LINK_SHIELD 15// when he walks with the sword
#define LINK_GENERIC_ITEM 16
#define LINK_WAND 17
#define LINK_LIFT1 18
#define LINK_LIFT2 19
#define LINK_GET_ITEM 20
#define LINK_HOLE_FALL 21
#define LINK_RAFTING 22
#define LINK_DEAD 23
#define LINK_REEL_BACK_NO_DAMAGE 24
#define LINK_HOOKSHOT 25
//State when Link is jumping or falling
//#define LINK_JUMP     4
//#define LINK_JUMP2    5
//#define LINK_JUMP3    6


#define BOOMERANG     1
//#define SWORD2     2
//#define SWORD3     3
//#define SWORD4     4
//#define SWORD5     5
//#define SWORD6     4
#define WAND   7 // this is used for the object list
#define ARROW   31
#define BOMB2  39
#define ARROW2   5
#define FIRE     30


#define blk_heart 18
#define half_heart 19
// but there are a total of 8 swords.. b/c the last is for the spin slash.


// each one of the mob stats are for a specific x pos in the mob_stat array

#define mob_msg_id 1//mob_def 1
#define mob_msg_num  11 //mob_item 11
// the above 2 are special.  for the towns person, the defence and shield is not needed,
// so they will be used to show what message.  right now the message is static, but
// it could be modded if you add in mod_mob into the sl. 



#define mob_hp 0// it is unwise to change this define, b/c if you do, then pede will break.
#define mob_def 1
#define mob_dam 2
#define mob_x 3
#define mob_y 4
#define mob_pause 5// used for the movement to know if the mob is paused or not. 
#define mob_sprites 6 // # of frames
#define mob_walk_sprites 7 // # of frames to allocate to walking
#define mob_sprite_id 8
#define mob_special_atk 9 // for like revenge attack (dog), shooting projectiles, chicken attack
#define mob_shield 10 // does it have a shield or not
#define mob_item 11 // items the mob holds?
#define mob_sl_exec 12 //execute a sl when they die - might be imped later for the bosses or for key
// drop
#define mob_stunned 13
#define mob_underground 14
#define mob_type 15 // like gohst(which can travel through walls)
#define mob_frame 16 // this is to let you know which pic to animate them with
#define mob_id 17
#define mob_dir 18
#define mob_rand_var1 19// used in the movement to set specific special movements 
#define mob_speed  20// tell the speed that the mob should move.  if 0, then dont move, but animate.
#define mob_stops 21 // 0 for constantly moving, 1 for random, 2 moves when link in proximety
#define mob_animation_type 22// 0 always animate, 1 animate when moving.
#define mob_rand_var2 23// used in the movement to set specific special movements 
// rand var 2 will also be used after the mob is hit.
#define mob_animation_speed 24// used to tell how fast to speed thorugh the frames.  
					// 1 will animate every frame.  2, every other frame ... 10 every 10 frames ... 20 every
					// 20 frames, etc.
#define mob_current_sprite 25
#define mob_move_type 26// tells how the mob should move, such as MOB_WANDER, MOB_FLUTTER, 
					//MOB_HOP, MOB_FOLLOW
#define mob_hit 27// this lets me know if the mob has been hit by a weapon or not.					
#define mob_h 28 // mob height
#define mob_w 29// mob width



#define sometimes 1// this is related to mob_stops

#define flyer 7// this goes along with mob_type
//#define ghost 8
#define digger 3

#define chicken 0
#define dog 1
//#define butterfly 2

#define monster 4
//#define urchin 5
#define crab 6
#define generic 10
#define towns_people 12
#define wizard 13
#define quest_master 5

#define pede_head 20
#define pede_body 21
#define evil_eye 22 // this has the circle eyes rotate around it
#define circle_eye 23
#define spider 24

// these defines are for room_maps[8][x]
#define gfx_list 0  // this will not be used, b/c it is now placed in the world[][]
#define mob_gfx_list 1
#define mob_file 2
#define warp_list 3
#define add_key 4 // add key will be used to tell the map to add a key to a monster or not.
// it will only add a normal key.
//#define treasure_list 4
//#define locked_door_list 5 - not needed anymore
//#define world_pos_x 5 // this is the replacement for locked door list
#define key_gotten 5
#define story_file 6
#define shop_list 7
#define hidden 8  
#define msg_list 9

// these defines are for room_maps[9][x]
#define room_dark 10  // just do <define> - 10 to get the thingie.
//room id=19
#define mobs_killed 11 // this will tell you whether to load the mob file for the room or not. 
	// this is no longer used. - redefine for the room stats, though.
//#define world_pos_y 11 // this is the replacement for mobs killed.
#define mobs_start 12// these let me know the range of mobs to use in the mob list
#define mobs_end 13 
#define no_save 14
#define torches_to_be_lit 15
#define torches_lit 16
#define mobs_amount 17  // the amount of mobs to randomly create for a room.
#define base_sprite 18 // this is used as the base ground, so when you cut or move an object, then
// it will replace it with that sprite.

//#define mobs_killed 1000 // this is redone so it can work in the get_room_info still and pull the
// get_room_stats array.
#define room_lit 1001 // this is to tell whether that room has been lit or not.
//#define key_gotten 1002


enum {MOB_WANDER, MOB_FLUTTER, MOB_HOP, MOB_FOLLOW, MOB_BAT, MOB_WIZARD, MOB_SPIKE, MOB_CONSTANT, MOB_GHOST};  //Movement Types, used in function MoveMob


#define max_mobs 8//8 // if you ever want to change the amt of mobs in the mob list then just redo this
// number
#define mob_num_of_stats 30 // this is the number of stats per mob.

///


enum {OBJECT_NUMBER, OBJECT_X, OBJECT_Y, OBJECT_FRAME, obj_dir, obj_var1, obj_var2, obj_dam,obj_type}; //Used in object_list
// obj dir is the direction the object if flying.
// obj dam is the damage the object does
// obj type is the type of object.

// these tell how far an object can travel out of bounds of the screen.
#define object_x_min_oob -12
#define object_y_min_oob -12
#define object_x_max_oob 156
#define object_y_max_oob 124
//====================================================================================
//												defines for item object (used for addobject)
//====================================================================================
#define item_bomb 1003
#define item_boomerang 1004
#define item_wand 1005
#define item_bow 1006
#define item_heart 1008
#define item_rock 1009
#define item_hookshot 1010
#define item_pot 1019
#define item_dark_torch 1013
#define item_light_torch 1014
#define item_treasure_chest 1015
#define item_key_normal 1016
#define item_key_master 1017
#define item_key_boss 1018
#define item_bomb_bag 1020
#define item_gauntlet 1021
#define item_heart_container 1022
#define item_rupie_bag 1023
#define item_ring 1024
#define item_tunic 1025
#define item_push_stone 1026
#define item_hover_boots 1027
#define item_raft 1028
#define item_quiver 1029
#define item_bottle_1 1030
#define item_bottle_2 1031
#define item_bottle_3 1032
#define shop_bottle_half 1033
#define shop_bottle_full 1034
#define item_light_orb 1035
#define item_faerie 1036
#define shop_bottle_faerie 1037
#define item_map 1038
//Shadows found under mobs when jumping
#define SHADOW1    1122

//Link's sword, representing 7 swing directions


//Displayed when Link chops a bush
#define LEAF1      8
#define LEAF2      9
#define LEAF3      10
#define LEAF4      11

//Displayed when enemies get killed
#define EXPLODE1   12
#define EXPLODE2   13
#define EXPLODE3   14

//After chopping bushes or enemies you can get hearts and crystals
#define HEART1     15
#define CRYSTAL1   16
#define EXPLOSION  55
#define HOOKSHOT 40

//#define sword 1000
//#define msword 1001

// the below are shield types


#define immortal 5000
#define death_by_fire 5001// this lets me know if the mob can only be killed by fire.
#define death_by_arrow 5002
#define death_by_bomb 5003
#define shield_equipped 5004
#define immune_magic 5005

#define nostun 6000
#define nostun_death_by_fire 6001// this lets me know if the mob can only be killed by fire.
#define nostun_death_by_arrow 6002
#define nostun_death_by_bomb 6003
#define nostun_shield_equipped 6004
#define nostun_immune_magic 6005
#define nostun_immortal 6006
#define nostun_shield_immune_magic 6007


#define projectile_offset 9000// this will give the id# offset.  so anything >=projectile_offset, use proj_list
															// instead of the item_list[][]

#define max_projectiles_size 15
#define max_projectiles_stats 6

#define proj_id 20
#define proj_pic_id 21
#define proj_damage 22
#define proj_H 23
#define proj_W 24
#define proj_type 25

// item stat info defines

#define max_list_size 40
#define max_item_stats 11

#define item_id 0
#define item_type 1
#define item_pic_id 2
#define item_cost 3
#define item_damage 4
#define item_hold 5 // for bottles

// these below 3 are like the above 3: - they are for objects on the screen.  however, these defines
// are for the treasure boxes, so i dont get confused.
#define treasure_amt 3// for either gold or item amount.
#define treasure_slot 4// for the inventory slot to say that the treasure has been gotten.
#define treasure_item 5// what item the treasure box holds.

#define item_duration 6
#define item_pic_2 7
#define item_pic_3 8
#define item_H 9
#define item_W 10
//#define item_x_whitespace 11
//#define item_y_whitespace 12
// these are for the item types
#define bomb 20 //normal displaying purposes only
#define arrow 1
#define wand 2
#define weapon 3
#define shield 4
#define boomerang 205
#define sword 6
#define heart 7
#define arrow_ammo 8
#define rock 9
#define boulder 10
#define slashable_terrain 11
#define pushable 12
#define throw_object 13  // this is when link is lifting the object.
#define follow_object 14 // this is when the object is already been lifted
#define boom_bomb 15 //the bomb that goes boom
#define flying_bomb 16
#define hookshot 17
#define torch 30//the torch is an item type that you cannot walk on, but you can
// hit it with fire and when it does get hit by fire, it will dissappear and
// and add +1 to the torch_lit count.
#define treasure_box 41
#define rupie 42 // this is for the storyline.  it is for a treasure box.  in the 
// treasure box, asign a rupie and then a value of rupies.
#define key_normal 50
#define key_boss 51
#define key_master 52
#define bomb_bag 53
#define gauntlet 54
#define heart_container 55
#define rupie_bag 56
#define tunic 57
#define ring 58
#define raft 59
#define hover_boots 60
#define quiver 61
#define bottle 62
#define potion 63
#define light_orb 64
#define faerie 65
#define type_map 70
//#define compass 71
// bottle defines:
#define bottle_empty 0
#define bottle_half 1
#define bottle_full 2
#define bottle_faerie 3

#define arrow_foe 21
#define arrow_foe_rotate 22
#define arrow_foe_multi_3 23
#define arrow_foe_multi_5 24
#define arrow_foe_diagnal 26
//#define arrow_foe_at_link 27 - dont feel like making it.  besides im almost at 15 weapons anyways
#define arrow_foe_rotate_follow 28
#define arrow_foe_follow 29
#define mob_replicator 12000 // this is a special mob type that will keep placing mobs onto the field.
#define chicken_attack 12001 // when the chicken attacks

#define mob_weaps ((typ>=arrow_foe) && (typ<=arrow_foe_follow))
#define mob_rotate_weaps ((typ>=arrow_foe_rotate) && (typ<=arrow_foe_rotate_follow)) 
#define a_mob_weapon ((dam_type>=arrow_foe) && (dam_type<=arrow_foe_follow))

#define chi_arrow 7
#define msg_arrow 8
#define white_arrow 9

#define box 0 // this is used for the pointer type in the inventory selecting.

//#define overwrite 10// this is for the drawtype.  it will overwrite the plane.


#define a_mob (who!=LINK)
#define a_player (who==LINK)

#define message 1
#define message_n_selector 3
#define message_n_yn_box 4

#define rot_90 90
#define rot_180 180
#define rot_270 270


// defines for buttons ==================================

#define a_ko 1
#define b_ko 2
#define up_ko 3
#define down_ko 4
#define left_ko 5
#define right_ko 6
#define start_ko 7

#define esc_ko 33
#define with *10+
#define f3_ko 8
#define f5_ko 10
#define c_ko 200
//===========================================


// damage types:

#define type_lit 8000
#define type_fire 8001
#define type_ice 8002
#define type_arrow 8003
#define type_magic 8004


#define clr_scr clr_planes

//  defines for quest items =============================

#define dungeon_map 0
#define compass 1
#define crystal 2


//  gfx list sizes

#define mob_gfx_list_size 32//32//48
#define gfx_list_size 200
#define link_gfx_size 14
#define object_gfx_size 75

////////////////////////////////////////////////////////////////////////////////
//									inventory specific defines
////////////////////////////////////////////////////////////////////////////////
#define inv_rows 11
#define inv_cols 30



#define inv_treasure_loc 8// the treasure location starts at inv[8][x] - used in below code
// it extends 3 rows, so if you change the rows, be sure to remeber this.
#define inv_treasure_rows 3 // how many rows the treasure uses
#define inv_story_marker_loc 5
#define inv_story_marker_rows 2 // how many rows the story marker uses

//  tells which marker to use
#define treasure_marker 300
#define story_marker 400

////////////////////////////////////////////////////////////////////////////////


#define overworld_rows 21
#define overworld_cols 4

//#define world_rows 12
//#define world_cols 8

#define obj_list_size 50
#define obj_stat_size 13

//#define num_of_room_stats 3


#define msg_arr_size 50  // for the list size of messages

// sl stuff:

#define sl_max 50
#define sl_width 6

// overworld map defines:

#define overworld_gfx_file 0
#define overworld_dungeon_num 1
#define overworld_mob_stat_list 2
#define overworld_mob_gfx_file 3

#define overworld_game_num 10
#define overworld_rset_start 11
#define overworld_rmapx_start 12
#define overworld_rmapy_start 13

#define overworld_link_xpos_start 20
#define overworld_link_ypos_start 21
#define overworld_start_world_map 22

#define overworld_world_to_left 30
#define overworld_world_to_right 31
#define overworld_world_to_up 32
#define overworld_world_to_down 33

#define overworld_map_nums 20 // where all the map numbers are stored - dont use for stats()


//==============================================
// warp set stuff
#define warp_points 12
#define warp_stats 11
//warp[warp_points][warp_stats]
// from warp
#define warp_map_x 0
#define warp_map_y 1
#define warp_x_sprite 2
#define warp_y_sprite 3
// to warp
#define warp_to_ow 4
#define warp_to_map 5
#define warp_to_map_x 6
#define warp_to_map_y 7
#define warp_to_sprite_x 8
#define warp_to_sprite_y 9
#define warp_world_check 10

#define same_map -88



//================================================

#define dissappear 333


